﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Acop.AcopChartUtil
{
  class AcopConst
  {
#   pragma warning disable 1591
    //??    protected static DecimalFormat textFormat = new DecimalFormat("#0.0000");
    protected static internal int max_points = 524288;   //	8192*64
    protected static internal double zero_check = 1.0e-30;

    protected static internal int N_TIME = 7;
    protected static internal int[] timeMax = { 1000, 100, 100, 100, 100, 20, 68 }; // maximum 68 years for interger overflow!! 2007 hwu
    protected static internal double[] timeScale = { 0.001, 1, 60, 3600, 86400, 2592000, 31536000 };
    protected static internal String[] timeStr = { "MilliSeconds", "Seconds", "Minutes", "Hours", "Days", "Months", "Years" };
    public static int tScale_ms = 0,
                      tScale_second = 1,
                      tScale_minute = 2,
                      tScale_hour = 3,
                      tScale_day = 4,
                      tScale_month = 5,
                      tScale_year = 6;

    public static int MAX_PERSIST = 10;    // maximum # of persistent display curves
    public static int MAX_DISPLAY = 100;    // maximum # of curves
    protected static internal int MAX_TEXT = 100;    // maximum # of text strings
    public static int N_DEF_DISPLAY = 20;    // maximum # of curves for averaging
    protected static internal int TEXT_MOVE = 3;    // x move bit 0; y move bit 1
    protected static internal int lengthZoom = 20;
    protected static internal int MAX_BACKGROUND_REGION = 16;
    protected static internal int MAX_AXIS = 2;     // maximum # of Axis

    protected static internal int NEW_PRINT_WINDOW = 4;
    protected static internal int NEW_TEXT_WINDOW = 3;
    protected static internal int NEW_ZOOM_WINDOW = 2;
    protected static internal int NEW_MOVE_WINDOW = 1;

    protected static internal int FFT_SPEKTRUM = 0x1;	// spektrum + 0
    protected static internal int FFT_PHASE = 0x2;	// phase + 0
    protected static internal int FFT_SP = 0x3;	// spektrum + phase
    protected static internal int FFT_RI = 0x4;	// real part + imaginary part
    protected static internal int FFT_REAL = 0x5; // real part
    protected static internal int FFT_IMAGINARY = 0x6; // imaginary part
    protected static internal int FFT_RI_INVERSE = 0x7; // inverse FFT for real and imaginary
    protected static internal int FFT_DIFFER_STATISTIC = 0x8; // differencial statustucs
    protected static internal int FFT_INTEGRAL_STATISTIC = 0x9; // integeral statistics
    protected static internal int FFT_LINE_FIT = 0xa; // line fit
    protected static internal int FFT_EXPONENTIAL_FIT = 0xb; // exponential fit
    protected static internal int FFT_GAUSSIAN_FIT = 0xc; // Gaussian fit
    protected static internal int FFT_POLYNORM_QUADRTIC_FIT = 0xd; // Parabolic fit
    protected static internal int FFT_POLYNORM_CUBIC_FIT = 0xe; // Cubic fit
    protected static internal int FFT_POLYNORM_QUARTIC_FIT = 0xf; // Quartic fit

    public const int PS_SOLID = 0,
                          PS_DASH = 1,
                          PS_DOT = 2,
                          PS_DASH_DOT = 3,
                          PS_DASH_DOT_DOT = 4;

    public const int mode_polyline = 0,
                  mode_barline = 1,
                  mode_histogram = 2,
                  mode_dots = 3,
                  mode_histogram_rastoring = 4,
                  mode_rectangle = 5,
                  mode_circle = 6,
                  mode_textbox = 7,
                  mode_polyline_dots = 8,
                  mode_barline_dots = 9,
                  mode_histogram_dots = 10,
                  mode_histogram_rastoring_dots = 11,
                  mode_barline_histo = 12,
                  mode_barline_histo_dots = 13,
                  mode_polyline_cross = 14,
                  mode_annotation = 15,
                  mode_status = 16,
                  mode_barline_ganttplot = 17,
                  mode_barline_bit = 18;

    protected static internal int AnnotationSize = 14;

    protected static internal double log_check(double x)
    {
      //      if (x < 1.0e-18) x = 1.0e-19; // it was -14 and -15 2007-10 hwu
      if (x < 1.0e-30) x = 1.0e-30; // it was -18 and -19 2016-8 hwu
      return x;
    }

    protected static internal Pen createStroke(Color c, float penWidth, int penStyle)
    {
      Pen stroke;

      stroke = new Pen(c, (float)penWidth);
      if (penStyle == PS_SOLID)
      {
        stroke.DashStyle = System.Drawing.Drawing2D.DashStyle.Solid;
        //	  	else stroke = new Pen(c, (float)penWidth, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER);
      }
      else if (penStyle == AcopConst.PS_DASH)
      {
        stroke.DashStyle = System.Drawing.Drawing2D.DashStyle.Dash;
        float[] myDashes = { 6.0f, 2.0f };
        stroke.DashPattern = myDashes;
      }
      else if (penStyle == AcopConst.PS_DOT)
      {
        stroke.DashStyle = System.Drawing.Drawing2D.DashStyle.Dot;
        float[] myDashes = { 2.0f, 2.0f };
        stroke.DashPattern = myDashes;
        //          stroke = new BasicStroke((float)penWidth, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, (float)penWidth, new float[] { 2.f, 2.f }, 2f);
      }
      else if (penStyle == AcopConst.PS_DASH_DOT)
      {
        stroke.DashStyle = System.Drawing.Drawing2D.DashStyle.DashDot;
        float[] myDashes = { 6.0f, 2.0f, 2.0f, 2.0f };
        stroke.DashPattern = myDashes;
        //          stroke = new BasicStroke((float)penWidth, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, (float)penWidth, new float[] { 2.f, 2.f, 6.f, 2.f }, 2f);
      }
      else
      {
        stroke.DashStyle = System.Drawing.Drawing2D.DashStyle.DashDotDot;
        float[] myDashes = { 6.0f, 2.0f, 2.0f, 2.0f, 2.0f, 2.0f };
        //        stroke.DashStyle = System.Drawing.Drawing2D.DashStyle.DashDot;
        //        float[] myDashes = { 2.0f, 2.0f, 6.0f, 2.0f };
        stroke.DashPattern = myDashes;
        //          stroke = new BasicStroke((float)penWidth, BasicStroke.CAP_BUTT, BasicStroke.JOIN_MITER, (float)penWidth, new float[] { 2.f, 2.f, 6.f, 2.f }, 2f);
      }
      return stroke;
    }
  }
}
