﻿using System;
using System.Collections.Generic;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Acop.AcopChartUtil
{
  public partial class AcopFrame
  {
#   pragma warning disable 1591
    protected internal Color frameForeColor;
    protected internal SolidBrush framBrush;
    protected internal Font frameFont;
    protected internal Boolean leftTimeLabel;   // it is valid only for x
    protected internal Boolean absTimeDisplay;
    protected internal int histogramPosition;
    protected internal Rectangle histRect;    // pixel width and height
    protected internal Boolean drawFlag;

    protected internal int ZoomExtent;
    protected internal Rectangle zoomIcon;

    protected internal int xleft, xright, dxwidth, absxleft;

    public AcopFrame()
    {
      histRect = new Rectangle();
      zoomIcon = new Rectangle();
      ZoomExtent = 36;
    }

    //{{DECLARE_CONTROLS
    protected internal void getOxleftright(AcopHisto pHisto, AcopScale pScale)
    {
      int Rest, Wpixel, Offset;
      double xtemp;

      if (pHisto.dismode == AcopConst.mode_histogram_rastoring)
      {
        dxwidth = Math.Min(histRect.Width, (int)(pScale.max - pScale.min));
        if (dxwidth < 2) dxwidth = pHisto.npoints > 2 ? pHisto.npoints - 1 : 1;
        if (histRect.Width >= dxwidth)
        {
          Wpixel = histRect.Width / dxwidth;        // space between two indices
          Offset = histRect.Width % Wpixel;		    // fractions to get rid of
          Rest = ((histRect.Width - Offset) % dxwidth);// rest to compensate histogram
          if (histogramPosition == 0)	    		// left adjusted
          {
            xleft = 0;
            xright = histRect.Width - Rest - Offset;
          }
          else if (histogramPosition == 2)  // right adjusted
          {
            xleft = Rest + Offset;
            xright = histRect.Width;
          }
          else									// centered
          {
            xleft = Rest / 2;
            xright = histRect.Width - (Rest - Rest / 2) - Offset;
          }
        }
      }
      else
      {
        xleft = 0;
        xright = histRect.Width;
      }
      dxwidth = xright - xleft;
      absxleft = xleft + histRect.X;
    }
  }
}
