﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Acop
{
  [ToolboxItem(true)]
  [ToolboxBitmap(typeof(AcopLine), "Line")]
  public partial class AcopLine : AcopShape
  {
    public AcopLine()
    {
      InitializeComponent();
      setShapeType(ShapeTypes.line);
    }
    [Category("Acop.Display")]
    [Browsable(false), EditorBrowsable(EditorBrowsableState.Never)]
    public new Int32 CornerRadius { get; set; }
    [Category("Acop.Display")]
    [Browsable(false), EditorBrowsable(EditorBrowsableState.Never)]
    public new Int32 RotationAngle { get; set; }
    [Category("Acop.Display")]
    [Browsable(false), EditorBrowsable(EditorBrowsableState.Never)]
    public new Color FillColor { get; set; }
    /// <summary>
    /// draw line from bottom left to top right
    /// </summary>
    [Category("Acop.Display")]
    [Description("draw line from bottom left to top right")]
    public Boolean BottomToTop { get { return botToTop; } set { SetBottomToTop(value); } }
    /// <summary>
    /// determines the proper bounding region height to width ratio for which a straight line is drawn
    /// </summary>
    [Category("Acop.Display")]
    [Description("determines the proper bounding region height to width ratio for which a straight line is drawn")]
    public Int32 StraightLineAspectRatio { get { return getStraightLineAspect(); }set { setStraightLineAspect(value); } }
    /// <summary>
    /// if either LeftArrow or RightArrow is set to true: sets the size of the arrow drawn.
    /// </summary>
    [Category("Acop.Display")]
    [Description("if either LeftArrow or RightArrow is set to true: sets the size of the arrow drawn.")]
    public Int32 ArrowSize { get { return lineArrowSize; } set { setLineArrowSize(value); } }
    /// <summary>
    /// if true draws an arrow on the left hand side of the line
    /// </summary>
    [Category("Acop.Display")]
    [Description("if true draws an arrow on the left hand side of the line")]
    public Boolean LeftArrow {  get { return lineLeftArrow; } set { setLineLeftArrow(value); } }
    /// <summary>
    /// if true draws an arrow on the right hand side of the line
    /// </summary>
    [Category("Acop.Display")]
    [Description("if true draws an arrow on the right hand side of the line")]
    public Boolean RightArrow { get { return lineRightArrow; } set { setLineRightArrow(value); } }
    /// <summary>
    /// height of optional text area (otherwise text is overlayed)
    /// </summary>
    [Category("Acop.Display")]
    [Description("height of optional text area (otherwise text is overlayed)")]
    public Int32 TextRectangleHeight { get { return extraHeight; } set { setExtraHeight(value); } }
    /// <summary>
    /// width of optional text area (otherwise text is overlayed)
    /// </summary>
    [Category("Acop.Display")]
    [Description("width of optional text area (otherwise text is overlayed)")]
    public Int32 TextRectangleWidth { get { return extraWidth; } set { setExtraWidth(value); } }
  }
}
