﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;

namespace Acop.AcopSpiderUtil
{
  public partial class DebugInfo : Form
  {
#   pragma warning disable 1591
    static AcopSpider sp = AcopSpider.GetInstance();
    public DebugInfo()
    {
      InitializeComponent();
      try
      {
        Text = "Connection Information for : " + Process.GetCurrentProcess().MainWindowTitle;
      }
      catch (Exception) { }
    }
    private void updateActiveLinks()
    {
      Boolean RefreshList = false;
      String[] lst = sp.GetConnections(true);
      if (lst == null) RefreshList = true;
      //activeLinksList.Items.Clear();
      //foreach (String s in lst) activeLinksList.Items.Add(s);
      String[] olst = activeLinksList.Items.Cast<String>().ToList().ToArray();
      if (olst == null) RefreshList = true;
      if (olst.Length != lst.Length) RefreshList = true;
      if (!RefreshList && olst.Length == lst.Length)
      {
        for (int i = 0; !RefreshList && i < lst.Length; i++)
        {
          if (lst[i].CompareTo(olst[i]) != 0) RefreshList = true;
        }
      }
      if (RefreshList)
      {
        activeLinksList.Items.Clear();
        foreach (String s in lst) activeLinksList.Items.Add(s);
      }
    }
    private void updateAllLinks()
    {
      String[] lst = sp.GetConnections(false);
      allLinksList.Items.Clear();
      foreach (String s in lst) allLinksList.Items.Add(s);
    }
    private void updateMessages()
    {
      String[] lst = sp.GetMessages();
      msgsList.Items.Clear();
      foreach (String s in lst) msgsList.Items.Add(s);
    }
    public void updateInfo()
    {
      updateActiveLinks();
      updateAllLinks();
      updateMessages();
    }
    private void DebugInfo_Load(object sender, EventArgs e)
    {
    }

    private void DebugInfo_unload(object sender, FormClosedEventArgs e)
    {
      sp.removeDebugWindow();
    }
    public void refreshActiveLinksInList()
    {
      if (activeLinksList.Visible) updateActiveLinks();
    }
    private void updateTabbedInfo()
    {
      switch (tabControl1.SelectedIndex)
      {
        case 0:
          updateActiveLinks(); break;
        case 1:
          updateAllLinks(); break;
        case 2:
          updateMessages(); break;
      }
    }
    private void InfoDblClick(object sender, EventArgs e)
    {
      updateTabbedInfo();
    }
    private void TabPanelKeyDown(object sender, KeyEventArgs e)
    {
      if (e.KeyCode == Keys.F5)
      {
        updateTabbedInfo();
      }
    }

    private void RefreshClicked(object sender, EventArgs e)
    {
      updateTabbedInfo();
    }
  }
}
