﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AcopTransport
{
  class AcopLinkFactory
  {
    private static int defaultInterval = 1000;
    private static String defaultProtocol = "STARS";
    public static int GetDefaultInterval() { return defaultInterval; }
    public static String GetDefaultProtocol() { return defaultProtocol; }
    static Dictionary<String, AcopLink> lnkTbl = new Dictionary<String, AcopLink>();
    public static AcopLink[] GetAcopLinks()
    {
      return lnkTbl.Values.ToArray();
    }
    public static AcopLink GetAcopLink(String key)
    {
      if (key == null) return null;
      if (lnkTbl.ContainsKey(key)) return lnkTbl[key];
      return null;
    }
    public static void AddAcopLink(String key, AcopLink lnk)
    {
      if (lnkTbl.ContainsKey(key)) return;
      lnkTbl.Add(key, lnk);
    }
    public static void removeAcopLink(String key)
    {
      if (key == null) return;
      if (!lnkTbl.ContainsKey(key)) return;
      lnkTbl.Remove(key);
    }
  }
}
