﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace SineCurvesMuchProgramming
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }
    float[][] v = new float[4][];
    int[] hDisplay = new int[4];
    float[] ampl = new float[4];
    private void Form1_Load(object sender, EventArgs e)
    {
      acopChart1.XMax = 1024;
      acopChart1.XBestScale = false;
      // flag the links as 'grouped' -> common update event
      acopLink1.LinkGrouped = true;
      // initialization and start the links ...
      for (int i = 0; i < 4; i++)
      {
        hDisplay[i] = -1; // initialized display handles to invalid values ...
        v[i] = new float[1024]; // fix the dimension of each curve ...
        acopLink1.LinkDevice = "SineGen"+i.ToString();
        acopLink1.Attach(v[i], null, 0, 1000, null);
        acopTable1.SetValueForeColor(colors[i], i);
      }
      acopLink2.Attach(ampl, null, 0, 1000, null);
    }
    Color[] colors = new Color[] { Color.DarkBlue, Color.DarkRed, Color.DarkGreen, Color.DarkMagenta };
    private void acopLink1_acopLinkUpdate(object sender, Acop.Link lnk)
    {
      for (int i = 0; i < 4; i++)
      {
        if (hDisplay[i] < 0)
        {
          acopChart1.ForeColor = colors[i];
          hDisplay[i] = acopChart1.Draw(v[i]);
          if (i == 3) acopChart1.AutoScale(false, false, true, true);
        }
        else
        {
          acopChart1.RefreshScreen(v[i], hDisplay[i]);
        }
      }
    }

    private void acopChart1_acopMsMove(object sender, Acop.AcopChartUtil.AcopEvent e)
    {
      int idx = e.GetArrayIndex();
      for (int i = 0; i < 4; i++)
      {
        acopTable1.SetTableValue(i, 1, v[i][idx].ToString());
      }
    }

    private void acopLink2_acopLinkUpdate(object sender, Acop.Link lnk)
    {
      if (acopTable1.InvokeRequired)
      {
        acopTable1.LinkUpdateInvoker(acopLink2_acopLinkUpdate, sender, lnk);
        return;
      }
      for (int i = 0; i < 4; i++)
      {
        if (hDisplay[i] >= 0)
        {
          acopTable1.SetTableValue(i, 2, acopChart1.GetYDataMax(hDisplay[i]).ToString());
          acopTable1.SetTableValue(i, 3, acopChart1.GetYDataMin(hDisplay[i]).ToString());
        }
        acopTable1.SetTableValue(i, 0, ampl[i].ToString());
      }

    }
  }
}
