Imports System.Runtime.InteropServices
Imports tine
Public Class Form1
  <StructLayout(LayoutKind.Sequential, Pack:=1, CharSet:=CharSet.Ansi)> _
  Public Structure SineInfo
    Public amplitude As Single
    Public frequency As Single
    Public noise As Single
    Public phase As Single
    Public numberCalls As Integer
    <MarshalAs(UnmanagedType.ByValArray, SizeConst:=64)> _
      Public description() As Char
  End Structure
  Private Const PRP_SINE = 1
  Private Const PRP_AMPLITUDE = 2
  Private Const PRP_FREQUENCY = 3
  Private Const PRP_PHASE = 4
  Private Const PRP_NOISE = 5
  Private Const PRP_INFO = 6
  Private Const PRP_BYTEARRAY = 18
  Private Const PRP_ECHO = 19
  Private Const NUM_DEVICES = 10
  Private Const NUM_VALUES = (1024 * 8)
  Dim sinbuf(NUM_DEVICES - 1, NUM_VALUES - 1) As Single
  Dim tts As TTaggedStruct
  Dim sineInfoTable(NUM_DEVICES - 1) As SineInfo
  Dim myeqm As TEquipmentModule

  Public Function sineqm(ByVal dev As String, ByVal prp As String, ByVal dout As TDataType, ByVal din As TDataType, ByVal acc As UShort, ByVal eqm As TEquipmentModule) As Int32

    Dim fval As Single
    Dim mcarray(NUM_DEVICES) As Single
    Dim cc As Integer, i As Integer
    Dim devnr As Integer
    Dim prpid As Integer
    Dim cln As ClnInfo
    cln = myeqm.GetCallerInformation()
    Debug.Print("called by " + cln.GetUserName() + " at " + cln.GetNetworkAddr() + vbCrLf)

    devnr = eqm.GetDeviceNumber(dev, prp)
    prpid = eqm.GetPropertyId(prp)
    'Select Case prp
    '  Case "Sine"
    '    cc = Errors.illegal_read_write
    '    If ((acc And Access.CA_WRITE) = 0) Then
    '      cc = dout.PutData(sinbuf, devnr, NUM_VALUES, 0)
    '      sineInfoTable(devnr).numberCalls = sineInfoTable(devnr).numberCalls + 1
    '    End If
    'End Select
    Select Case prpid
      Case PRP_SINE
        cc = Errors.illegal_read_write
        If ((acc And Access.CA_WRITE) = 0) Then
          cc = dout.PutData(sinbuf, devnr, NUM_VALUES, 0)
          sineInfoTable(devnr).numberCalls = sineInfoTable(devnr).numberCalls + 1
        End If
      Case PRP_AMPLITUDE
        If (din.GetDataArrayLength() > 0) Then
          If ((acc & Access.CA_WRITE) <> Access.CA_WRITE) Then
            cc = Errors.illegal_read_write
          End If
          cc = din.GetData(fval)
          If cc <> 0 Then Exit Select
          sineInfoTable(devnr).amplitude = fval
        End If
        If (dout.GetDataArrayLength() > 0) Then
          For i = 0 To NUM_DEVICES - 1
            mcarray(i) = sineInfoTable(i).amplitude
            cc = dout.PutData(mcarray, NUM_DEVICES, devnr)
            If cc <> 0 Then Exit Select
          Next
        End If
      Case PRP_FREQUENCY
        If (din.GetDataArrayLength() > 0) Then
          If ((acc & Access.CA_WRITE) <> Access.CA_WRITE) Then
            cc = Errors.illegal_read_write
          End If
          cc = din.GetData(fval)
          If cc <> 0 Then Exit Select
          sineInfoTable(devnr).frequency = fval
        End If
        If (dout.GetDataArrayLength() > 0) Then
          For i = 0 To NUM_DEVICES - 1
            mcarray(i) = sineInfoTable(i).frequency
            cc = dout.PutData(mcarray, NUM_DEVICES, devnr)
            If cc <> 0 Then Exit Select
          Next
        End If
      Case PRP_PHASE
        If (din.GetDataArrayLength() > 0) Then
          If ((acc & Access.CA_WRITE) <> Access.CA_WRITE) Then
            cc = Errors.illegal_read_write
          End If
          cc = din.GetData(fval)
          If cc <> 0 Then Exit Select
          sineInfoTable(devnr).phase = fval
        End If
        If (dout.GetDataArrayLength() > 0) Then
          For i = 0 To NUM_DEVICES - 1
            mcarray(i) = sineInfoTable(i).phase
            cc = dout.PutData(mcarray, NUM_DEVICES, devnr)
            If cc <> 0 Then Exit Select
          Next
        End If
      Case PRP_NOISE
        If (din.GetDataArrayLength() > 0) Then
          If ((acc & Access.CA_WRITE) <> Access.CA_WRITE) Then
            cc = Errors.illegal_read_write
          End If
          cc = din.GetData(fval)
          If cc <> 0 Then Exit Select
          sineInfoTable(devnr).noise = fval
        End If
        If (dout.GetDataArrayLength() > 0) Then
          For i = 0 To NUM_DEVICES - 1
            mcarray(i) = sineInfoTable(i).noise
            cc = dout.PutData(mcarray, NUM_DEVICES, devnr)
            If cc <> 0 Then Exit Select
          Next
        End If
      Case PRP_INFO
        If (din.GetDataArrayLength() > 0) Then
          If (din.GetDataFormat() <> Formats.CF_STRUCT) Then
            cc = Errors.illegal_format
            Exit Select
          End If
          If (din.GetDataTag().CompareTo("SineInfo") <> 0) Then
            cc = Errors.invalid_structure_tag
          End If
          Dim sinf As SineInfo
          sinf = New SineInfo()
          cc = din.GetData(sinf)
          If cc <> 0 Then Exit Select
          sineInfoTable(devnr).amplitude = sinf.amplitude
          sineInfoTable(devnr).frequency = sinf.frequency
          sineInfoTable(devnr).phase = sinf.phase
          sineInfoTable(devnr).noise = sinf.noise
        End If
        If (dout.GetDataArrayLength() > 0) Then
          If (dout.GetDataFormat() <> Formats.CF_STRUCT) Then
            cc = Errors.illegal_format
            Exit Select
          End If
          If (dout.GetDataTag() <> "SineInfo") Then
            cc = Errors.invalid_structure_tag
          End If
          If (dout.GetDataArrayLength() > NUM_DEVICES) Then dout.SetDataArrayLength(NUM_DEVICES)
          cc = dout.PutData(sineInfoTable, NUM_DEVICES, devnr)
        End If
      Case PRP_BYTEARRAY
        If (dout.GetDataArrayLength() > 0) Then
          Dim ba(63) As Byte
          For i = 0 To 63
            ba(i) = 65 + i
          Next
          Select Case dout.GetDataFormat()
            Case Formats.CF_BYTE
              cc = dout.PutData(ba)
            Case Formats.CF_CHAR
              cc = dout.PutData(ba)
            Case Else
              cc = Errors.illegal_format
          End Select
        End If
      Case PRP_ECHO
        Dim dlen = din.GetDataArrayLength()
        Dim dfmt = din.GetDataFormat()
        If (dlen = 0) Or (dlen <> dout.GetDataArrayLength()) Then
          cc = Errors.dimension_error
          Exit Select
        End If
        If (dfmt <> dout.GetDataFormat()) Then
          cc = Errors.illegal_format
          Exit Select
        End If
        Select Case dfmt
          Case Formats.CF_NAME64
            Dim n(dlen - 1) As NAME64
            cc = din.GetData(n)
            If (cc = 0) Then
              For i = 0 To dlen - 1
                Console.WriteLine(n(i).GetName())
              Next
              cc = dout.PutData(n)
            End If
          Case Else
            cc = Errors.not_implemented
        End Select
      Case Else
        cc = Errors.illegal_property
    End Select
    sineqm = cc
  End Function
  Public Sub updateSine(ByVal devnr As Integer)
    Dim i As Integer, k As Integer
    Dim f As Single, n As Single, p As Single, a As Single
    f = sineInfoTable(devnr).frequency
    n = sineInfoTable(devnr).noise
    p = sineInfoTable(devnr).phase
    a = sineInfoTable(devnr).amplitude
    For i = 0 To NUM_VALUES - 1
      k = (i + p) Mod NUM_VALUES
      sinbuf(devnr, k) = (Rnd()) * n + (Math.Sin(f * i * 6.2832 / (NUM_VALUES / 8)) * a)
    Next
  End Sub
  Public Sub setAnAlarm()
    Dim myads As ADS

    '    myads = New ADS(512, "goofy tag", 7)
    myads = New ADS()
    myads.SetAlarmTag("goofy tag")
    myads.SetAlarmText("this is a goofy alarm")
    myads.SetDataText("as if this thing had data!")
    myads.alarmCode = 512
    myads.alarmSeverity = 7
    myeqm.AppendAlarmInfoTable(myads)
    myeqm.SetAlarm("SineGen0", 512, Nothing, AlarmDescriptors.almNEWALARM)

  End Sub
  Private bkgCounter As Integer

  Public Sub sinbkg()
    Dim i As Integer
    For i = 0 To NUM_DEVICES - 1
      Call updateSine(i)
    Next
    bkgCounter = bkgCounter + 1
    If bkgCounter = 10 Then setAnAlarm()
  End Sub
  Public Sub sinini()
    Dim i As Integer, k As Integer
    Dim dsc As String
    Dim tdt As TDataType

    For i = 0 To NUM_DEVICES - 1
      sineInfoTable(i).amplitude = 256
      sineInfoTable(i).frequency = 1
      sineInfoTable(i).phase = 0
      sineInfoTable(i).noise = 5.0
      ReDim sineInfoTable(i).description(63)
      dsc = "Sine device " + Str(i) + " at your service"
      For k = 0 To Len(dsc) - 1
        sineInfoTable(i).description(k) = dsc.Chars(k)
      Next
    Next

    tdt = New TDataType(sineInfoTable)

    Dim ba(63) As Byte
    Dim btdt As TDataType
    btdt = New TDataType(ba)
    btdt.PutData("a string".ToCharArray)

    Dim ca(63) As Char
    Dim ctdt As TDataType
    ctdt = New TDataType(ca)
    ctdt.PutData(ba)


    Dim n64 As NAME64
    n64 = New NAME64("hello")
    tdt = New TDataType(n64)

    TKernel.FecLog("staring up from vb.NET")

    'Dim myads(0) As ADS

    'myads(0) = New ADS()
    'myads(0).setAlarmTag("goofy tag")
    'myads(0).setAlarmText("this is a goofy alarm")
    'myads(0).setDataText("as if this thing had data!")
    'myads(0).alarmCode = 512
    'myads(0).alarmSeverity = 7
    'myeqm.AppendAlarmInfoTable(myads)

    Dim myads As ADS

    '    myads = New ADS(512, "goofy tag", 7)
    myads = New ADS()
    myads.SetAlarmTag("goofy tag")
    myads.SetAlarmText("this is a goofy alarm")
    myads.SetDataText("as if this thing had data!")
    myads.alarmCode = 512
    myads.alarmSeverity = 7
    'myeqm.AppendAlarmInfoTable(myads)

    'myeqm.SetAlarm("device1", 512, Nothing, AlarmDescriptors.almNEWALARM)



  End Sub
  Public Sub sinexi()
    Console.WriteLine("server stopping")
  End Sub
  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    TKernel.SetAppDate(DateTime.Now)
    TKernel.SetAppVersion(1, 0, 1)
    TKernel.SetHistoryFilesRepository("c:\HISTORY")

    Dim po As Integer
    po = TKernel.GetPortOffset("DNFEC")
    TKernel.RegisterFecInformation("DNFEC", "TEST", "TEST", "Dot Net Test", "Here", "none", "me", po)

    TKernel.InitializeServer()

    tts = New TTaggedStruct(sineInfoTable)

    Dim tt As TDataType
    tt = New TDataType(1, tine.Formats.CF_STRUCT, "SineInfo")

    Dim ttag As String
    Dim ttag2 As String

    ttag = "ABCD"
    ttag2 = "ABCD"

    ttag = tt.GetDataTag()

    If ttag = "SineInfo" Then
      Debug.Print("got it")
    Else
      Debug.Print("lengths:" + Str(Len(ttag)) + " " + Str(Len("SineInfo")))
    End If

    If tt.GetDataTag().CompareTo("SineInfo") = 0 Then
      Debug.Print("got it")
    End If




    myeqm = New TEquipmentModule("/TEST/DOTNETSINE", "DNSEQM", 10, AddressOf sineqm, AddressOf sinini, AddressOf sinbkg, 500, AddressOf sinexi)

    TKernel.StartServices()

  End Sub
End Class
