﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Diagnostics;
using Acop.AcopChartUtil;
using System.Drawing.Printing;

namespace Acop
{
  [ToolboxItem(true)]
  [ToolboxBitmap(typeof(PerformanceCounter))]
  public partial class AcopChart : AcopUserComponent, INotifyPropertyChanged
  {
#   pragma warning disable 1591
    private static readonly long serialVersionUID = 351823797042270731L;
    private ToolTip acopToolTip;

    private AcopChartContextMenu cm;
    protected internal AcopHisto[] histo = new AcopHisto[AcopConst.MAX_DISPLAY]; // maximum
    // 100
    protected internal int globalDisplayMode, enableDots, enableBarlineHisto, bitDisplayMask;
    protected internal double ganttBitDisplayBase, ganttBitDisplayHeight;
    // added by ike to demonstrate simple customizer
    //	private AbstractCustomizerPanel customizer;
    //	private PopupManager popupManager;
    private Boolean popupEnabled;
    protected Boolean frameBorderOn;
    internal Boolean forceWidth = false;
    private int n_display;
    protected internal int m_lock;
    protected internal Boolean drawTicks = true; // after new scalling
    protected internal Boolean repainHisto = false;
    protected internal int rescaleFlag = 2;
    protected internal int histIndex = -1;
    private int loadXYindex = 0;
    private int m_filled = 0; // N_DISPLAY is filled
    private int m_keep = 0; // # of keeped histogram
    protected internal int lastDisp = 0;
    protected internal int lastTagHisto = 0;
    private int m_numberkeep = 0;
    private int m_keepstart = 0;
    protected AcopAxis[] axis = new AcopAxis[AcopConst.MAX_AXIS];
    protected AcopText[] ptext = new AcopText[AcopConst.MAX_TEXT]; // maximum 100
    private int n_text;
    private int loadTextIndex = 0;
    protected internal Boolean textFlag = false; // Ondraw text?
    protected internal int rescaleTextFlag = 0;
    private double[] g_rdata = new double[512];
    private Boolean RandomInitialized = false;
    protected internal Pen stroke;
    // private Stroke penLine = null;
    // private int dxmin, dxmax, dymin, dymax, dxwidth, dywidth;
    private double xwidth, ywidth;
    private Rectangle titleRect = new Rectangle();
    // private Rectangle histRect = new Rectangle();
    protected internal Rectangle histRoundRect = new Rectangle();
    private Rectangle xRect = new Rectangle();
    private Rectangle yRect = new Rectangle();
    protected internal Rectangle yAxisRect = new Rectangle();
    protected internal Rectangle tagRect = new Rectangle();
    private Rectangle zoomRect = new Rectangle();
    private int changeScaleWidth;
    private int fLeft, fRight, fTop, fBottom;
    private int fLeftPixel, fRightPixel, fTopPixel, fBottomPixel;
    private int HistLeft, HistRight, leftPixel, HistRectleftReference;
    private Boolean paintCursorMarker = false;
    protected internal Boolean errWindowOn = false;
    protected internal Boolean ScaleEnable = false; // yScaleArray on-off
    protected internal Boolean ReferenceEnable = false;
    // protected int xleft, xright, dxwidth;
    protected int[] bufferedXtimeFlag = new int[AcopConst.lengthZoom];
    protected double[,] bufferedMin = new double[AcopConst.lengthZoom, 3];
    protected double[,] bufferedMax = new double[AcopConst.lengthZoom, 3];
    protected int zoomIndex, zoomLogFlag;
    protected internal Boolean isZoomedFlag;
    protected Boolean zoomFlag, movie; // zoom is on?
    protected Point moviepoint;
    protected int saveBestFlag;
    protected double moviePercent = 0.01;
    protected int movieLogCnt = 10;
    protected int xCnt = 0;
    protected int yCnt = 0;
    // protected double s_xmin, s_xmax, s_ymin, s_ymax; // user display rectangle
    protected int time_scale;
    protected double tick_xmin, tick_xmax; // ticks area
    protected internal int m_histstart = 0; // reference index of base histogram
    protected internal double wrapxmin, wrapxmax; // wrap x range
    private int mouseX, mouseY, mouseLastX, mouseLastY;
    private Point mStart, mEnd, mousepoint, mdashStart, mdashEnd, mRightStart;
    private double[] mouseConvert = new double[3];
    private int mouseIndex, leftButton, rightButton;
    private MouseEventArgs mouseEvent;
    private int mouseArea;
    protected internal AcopScale[] sca = new AcopScale[3];
    // private AcopLine gridLine = new AcopLine();
    protected internal AcopFrame aFrame = new AcopFrame();
    //protected AcopTransport transport = new AcopTransport(this);
    // private BasicGraphicsUtils bGraphic = new BasicGraphicsUtils();
    //  private Vector AcopListeners = new Vector();
    private Bitmap ima;
    //  private java.awt.Graphics2D g2dima;
    private String yZoomRatio, xZoomRatio, bufferedZoomRatio;
    protected internal int yzero;
    protected Color foreColor, backColor;
    private Boolean captionChanged;
    private Font captionFont;
    private double lastTextx, lastTexty;
    private int nBackRegions;
    private Boolean backgroundRegionFixed;
    private int[] backkgroundRegionType = new int[AcopConst.MAX_BACKGROUND_REGION];
    private RectangleF[] backRegionUserRect = new RectangleF[AcopConst.MAX_BACKGROUND_REGION]; // userinput
    // rectangle
    private Rectangle[] backRegionRect = new Rectangle[AcopConst.MAX_BACKGROUND_REGION]; // converted
    // device
    // rect
    private Color[] backRegionColor = new Color[AcopConst.MAX_BACKGROUND_REGION]; // userinput
    private SolidBrush[] backRegionBrush = new SolidBrush[AcopConst.MAX_BACKGROUND_REGION]; // userinput
    // color
    private Bitmap[] backRegionImage = new Bitmap[AcopConst.MAX_BACKGROUND_REGION]; // userinput
    // images
    protected internal Color[] pTagColorArray;
    protected internal int nElement;
    protected internal Color TagBackColor; // init with forecolor
    private long mousePreviousClickTime, previousButton;
    private Point rButtonPoint;
    protected double[] yReferenceArray;
    protected int yRASize, yRAdataSize;
    protected double[] yWindowArray;
    protected int yWASize, yWAdataSize;
    protected internal double e_xmin, e_xmax, e_ymin, e_ymax; // error window display
    // rectangle
    protected internal Pen markerStroke;
    protected internal int m_marker;
    protected internal int saveMarkerWidth;
    protected internal double xlabelRotateGrad, xlabelRotateDegree, xlabelcos, xlabelsin;
    protected internal int xlabelQudrant, xlabelAxis;
    protected int printScreenPosition;
    private int averagingIndex, averagingLength, NumberAveragingData;
    private double totalWeight;
    private double[] averageWeight = new double[AcopConst.N_DEF_DISPLAY];
    private double[][] averagingBuffer = new double[AcopConst.N_DEF_DISPLAY][];
    protected Pen cursorMarkerStroke;
    private Point mMovePoint = new Point(); // for mouse
    private Point mOffsetMovePoint = new Point(); // for traslated coordinate
    private int cursorStay, cursorMarkerFlag, cursorix, cursoriy, cursorwx, cursorwy;
    private double cursorXPercent, cursorYPercent;
    private double cursorXposition, cursorYposition;
    private Boolean firstText;
    protected internal Boolean printTextLine = false;
    protected internal Boolean appendLineIndexInTextMode = true;
    protected internal int zoomXmaxFlag = 0;
    protected AcopPesist[] persist = new AcopPesist[AcopConst.MAX_PERSIST];
    protected internal String XLeftLabel = "";
    protected internal String XRightLabel = "";
    protected internal String[] ylab;
    protected internal int ylabON = 0, ylabLength = 0, yLabelDisplayOffset = 0, yLabelStart = 0, yLabelInterval = 1;
    private Boolean textAntiAliasing = true; //false;
    protected internal Boolean weightStatistics = true;

    // PropertyDescriptor ReceiveQueueDepth = new
    // PropertyDescriptor("ReceiveQueueDepth",beanClass,
    // "getReceiveQueueDepth","setReceiveQueueDepth");
    //  protected java.awt.List listTextBox;
    internal ListBox listTextBox;
    internal TextBox textArea;
    protected String caption = "";
    protected int captionPosition;
    protected int barlineColorFilled;
    protected int frameWidth;
    // protected java.awt.Color frameForeColor;
    protected int frameLeftOffset;
    protected int frameRightOffset;
    protected int frameTopOffset;
    protected int frameBottomOffset;
    protected internal int displayMode;
    // protected double xMin;
    // protected double xMax;
    // protected double yMin;
    // protected double yMax;
    protected internal int drawWidth;
    // protected java.awt.Font frameFont;
    // protected int XTicks;
    protected internal double _XScale;
    protected internal double _XShift;
    protected int graphStyle;
    // protected int YTicks;
    protected internal double _YScale;
    protected internal Boolean wrapAround;
    protected internal double _YShift;
    protected double _YExtent;
    protected internal int drawWidthPointsLimit;
    protected int screenDepth;
    protected internal int keepStyle;
    // protected Boolean YGrid;
    // protected Boolean XGrid;
    protected int zooming;
    // protected java.lang.String YAxisLabel = "";
    protected internal int keepWidth;
    protected Boolean randomData;
    protected Boolean randomText;
    // protected int XFineTicks;
    protected internal Boolean invert;
    protected internal int drawStyle;
    // protected Boolean XTickText;
    protected Boolean reuseText;
    protected internal Color keepColor;
    // protected Boolean xBestScale;
    protected int averagingMode, averagingDepth;
    protected internal int FFT;
    protected double _XExtent;
    // protected Boolean YTickText;
    // protected int histogramPosition;
    // protected int YFineTicks;
    protected Boolean reuseScreen;
    protected int textDepth;
    // protected java.lang.String XAxisLabel = "";
    // protected Boolean yBestScale;
    protected Boolean colorFilled;
    // protected Boolean leftTimeLabel;
    protected internal int xlabelRotation;
    protected internal int printTextStickyAttribute;
    protected internal int printTextLocation;
    protected internal int printTextRotation;
    protected internal Color m_tagColor;
    protected internal int m_tagWidth;
    protected internal Boolean m_tagging;
    protected internal Color m_errorColor;
    protected internal Color _LeadingEdgeColor;
    protected internal int _LeadingEdgeGapSize;
    protected internal int _LeadingEdgeMotion;
    protected internal int _LeadingEdgeMode;
    protected internal int _LeadingEdgeWidth;
    protected internal int _LeadingEdgeStyle;
    protected internal double _LeadingEdgeXExtent;
    protected internal double _LeadingEdgeYExtent;
    protected internal Color m_markerColor;
    protected internal int m_markerMode;
    protected internal int m_markerStyle;
    protected internal int m_markerWidth;
    protected internal double m_markerXExtent;
    protected internal double m_markerYExtent;
    protected Color m_cursorMarkerColor;
    protected Color rev_cursorMarkerColor;
    protected int m_cursorMarkerMode;
    protected int m_cursorMarkerStyle;
    protected int m_cursorMarkerWidth;
    protected double m_cursorMarkerXExtent;
    protected double m_cursorMarkerYExtent;
    protected Boolean _mousePressed;
    private Boolean cursorLockedToCurrentScreenPosition = false;
    private Rectangle theRectangle;
    private Brush backBrush;

    public new enum AutoScaleMode
    {
      off = 0,
      once = 1,
      always = 2,
    }
    private AutoScaleMode autoScaleUpdate = AutoScaleMode.off;
    private Boolean autoTrend = false;
    private bool applyAutoLinkCapacity = false;
    private const int AT_CHANNEL = 0x10;

    int TrendDepthInPoints = 1200; // number of points
    int TrendDepthInSeconds = 86400; // depth in seconds

    /// <summary>
    /// Allowable plotting modes (for line drawing) for the plotted data
    /// </summary>
    public enum AcopPlotMode
    {
      polyline = 0,
      barline = 1,
      histogram = 2,
      dots = 3,
      histogram_rastoring = 4,
      rectangle = 5,
      circle = 6,
      textbox = 7,
      polyline_dots = 8,
      barline_dots = 9,
      histogram_dots = 10,
      histogram_rastoring_dots = 11,
      barline_histo = 12,
      barline_histo_dots = 13,
      polyline_cross = 14,
      annotation = 15,
      status = 16
    }
    /// <summary>
    /// ALlowable plotting line styles for the data plotting with a 'line' type plotting mode.
    /// </summary>
    public enum AcopDrawStyle
    {
      PS_SOLID = 0,
      PS_DASH = 1,
      PS_DOT = 2,
      PS_DASH_DOT = 3,
      PS_DASH_DOT_DOT = 4
    }

    public enum AcopAxisLabelAnchor
    {
      bottom = 0,
      top = 1,
    }

    public AcopChart()
    {
      //setDoubleBuffered(false);
      // {{INIT_CONTROLS
      this.SuspendLayout();
      this.ResumeLayout(false);
      //    setLayout(null);
      //    setSize(502, 350);
      //    setPreferredSize(new Dimension(502, 350));
      //    setMinimumSize(new Dimension(100, 100));
      InitializeComponent();
      leftButton = 0;
      rightButton = 0;
      backBrush = new SolidBrush(this.BackColor);

      this.DoubleBuffered = true;
      this.SetStyle(ControlStyles.ResizeRedraw, true);
      this.AllowDrop = true;    // for mouse drag

      this.Location = new Point(100, 160);
      //this.ClientSize = new System.Drawing.Size(500, 350);
      this.ClientSize = new System.Drawing.Size(300, 150);

      _mousePressed = false;
      SetPopupEnabled(true);
      captionPosition = 1;
      captionChanged = true;
      keepColor = Color.Gray;
      keepWidth = 1;
      keepStyle = AcopConst.PS_SOLID;
      m_tagColor = Color.Cyan;
      m_tagWidth = 1;
      m_tagging = false;
      pTagColorArray = null;
      nElement = 0;
      m_marker = 0;
      saveMarkerWidth = 0;
      m_markerColor = Color.Black;
      m_markerMode = 0;
      m_markerStyle = AcopConst.PS_SOLID;
      m_markerWidth = 1;
      m_markerXExtent = -1;
      m_markerYExtent = -1;
      m_cursorMarkerColor = Color.Black;
      rev_cursorMarkerColor = Color.White;
      m_cursorMarkerMode = 0;
      m_cursorMarkerStyle = AcopConst.PS_SOLID;
      m_cursorMarkerWidth = 1;
      cursorMarkerStroke = AcopConst.createStroke(m_cursorMarkerColor, m_cursorMarkerWidth, m_cursorMarkerStyle);
      m_cursorMarkerXExtent = -1;
      m_cursorMarkerYExtent = -1;
      mMovePoint.X = -1;
      mMovePoint.Y = -1;
      mOffsetMovePoint.X = -1;
      mOffsetMovePoint.Y = -1;
      cursorStay = 0;
      cursorXPercent = -1;
      cursorYPercent = -1;
      cursorMarkerFlag = 0;
      cursorix = 0;
      cursoriy = 0;
      cursorwx = 0;
      cursorwy = 0;
      m_errorColor = Color.Red;
      colorFilled = true;
      averagingMode = 0;
      averagingDepth = 0;
      averagingIndex = 0;
      averagingLength = 0;
      NumberAveragingData = 0;
      for (int i = 0; i < AcopConst.N_DEF_DISPLAY; i++)
        averageWeight[i] = Math.Exp((double)i);
      FFT = 0;
      printScreenPosition = 0;
      for (int i = 0; i < 3; i++)
      {
        if (i < 2) axis[i] = new AcopAxis(this, i);
        sca[i] = new AcopScale(this, i == 0 ? true : false, i == 2 ? true : false);
        // load pointer into AcopScale class
        sca[i].ticks = -1;
        sca[i].fineTicks = 1;
        sca[i].grid = false;
        sca[i].leftBottom = i < 2 ? true : false;
        sca[i].bestScale = true;  // 2007 hwu false;
        sca[i].ticktext = true;
        sca[i].log = 0;
        sca[i].xtime = 0;
        sca[i].tickLabelForeColor = Color.Black;  // Color.Gray;
        sca[i].tickLabelBrush = new SolidBrush(sca[i].tickLabelForeColor);
        sca[i].leftBottLabel = true;
        sca[i].OnFlag = i < 2 ? true : false;
        sca[i].setUserscale(i == 0 ? 0 : -100, 100);
        sca[i].labelOffsetMode = 0;
        sca[i].labelOffset = 0;
      }
      textArea = new TextBox();
      //  listTextBox = new java.awt.List();
      listTextBox = new ListBox();
      this.Controls.Add(listTextBox);
      listTextBox.Visible = false;
      nBackRegions = 0;
      changeScaleWidth = 0;
      invert = false;
      _XShift = 0;
      _XScale = 1;
      _YShift = 0;
      _YScale = 1;
      leftPixel = 0;
      RandomInitialized = false;
      randomData = this.DesignMode;   // Beans.isDesignTime();
      randomText = this.DesignMode;   // Beans.isDesignTime();
      randomData = LicenseManager.UsageMode == LicenseUsageMode.Designtime ? true : false;
      randomText = LicenseManager.UsageMode == LicenseUsageMode.Designtime ? true : false;
      frameWidth = 30;
      frameLeftOffset = 10; // 2007 hwu
      frameRightOffset = 0;
      frameTopOffset = 0;
      frameBottomOffset = 0;
      graphStyle = 0;
      aFrame.leftTimeLabel = true;
      aFrame.absTimeDisplay = false;
      aFrame.histogramPosition = 1;
      aFrame.frameForeColor = Color.Black;// Color.Gray;
      aFrame.framBrush = new SolidBrush(aFrame.frameForeColor);
      stroke = new Pen(aFrame.frameForeColor, 1.0f);
      aFrame.frameFont = new Font("MonoSpaced", 8, FontStyle.Regular);
      caption = "";
      displayMode = AcopConst.mode_polyline; // AcopConst.mode_histogram;
      setGlobalDisplayMode();
      bitDisplayMask = 0;
      ganttBitDisplayBase = 0;
      ganttBitDisplayHeight = 0.8;
      e_xmin = 0;
      e_xmax = 100;
      drawWidth = 1; // 1 pixel
      drawStyle = AcopConst.PS_SOLID;// DASH_DOT ;//AcopConst.PS_SOLID;
      e_ymin = -100;
      e_ymax = 100;
      // penLine = new BasicStroke(3);
      m_lock = 0;
      drawWidthPointsLimit = 5000;
      screenDepth = 20;
      n_display = screenDepth;
      textDepth = 20;
      n_text = textDepth; // copConst.MAX_TEXT;
      m_filled = 0;
      barlineColorFilled = 0;
      wrapxmin = -1.7e+308;
      wrapxmax = 1.7e+308; // wrap x range
      zoomIndex = 0;
      zoomLogFlag = 0;
      zooming = 7;  // 2007 hwo buffered zooming   3;
      isZoomedFlag = false;
      zoomFlag = false;
      reuseScreen = false;
      reuseText = false;
      _XExtent = 0;
      _YExtent = 0;
      xlabelRotation = 0;
      foreColor = this.ForeColor;
      backColor = this.BackColor;
      wrapAround = false;
      printTextStickyAttribute = 0;
      printTextLocation = 0;
      printTextRotation = 0;
      _LeadingEdgeColor = this.ForeColor;
      _LeadingEdgeGapSize = 0;
      _LeadingEdgeMotion = 0;
      _LeadingEdgeMode = 0;
      _LeadingEdgeWidth = 1;
      _LeadingEdgeStyle = AcopConst.PS_SOLID;
      _LeadingEdgeXExtent = -1;
      _LeadingEdgeYExtent = -1;
      yRASize = yRAdataSize = 0;
      yWASize = yWAdataSize = 0;
      fLeft = 0;
      fRight = 0;
      fTop = 0;
      fBottom = 0;
      fLeftPixel = 0;
      fRightPixel = 0;
      fTopPixel = 0;
      fBottomPixel = 0;
      frameBorderOn = true;
      firstText = true;
      printTextLine = false;
      if ((zooming & 0x7) != 0) setZoomingWindow(zooming & 0x4);
      scaleFrameDraw();
      //    if (Beans.isDesignTime() && randomData == true)
      //    if (this.DesignMode && randomData == true)
      if (LicenseManager.UsageMode == LicenseUsageMode.Designtime && randomData == true)
      {
        prepareDraw();
        // System.out.println("DesignTime and RandomData");
      }
      // if ( randomData == true ) prepareDraw();
      //    enableEvents(AWTEvent.MOUSE_EVENT_MASK | AWTEvent.MOUSE_MOTION_EVENT_MASK | AWTEvent.COMPONENT_EVENT_MASK);
      // }}

      // initialize the acop transport ...
      //InitializeAcop();
      Control[] ctrls = new Control[] { };
      setControlsList(ctrls);
      setDisplayAsMCA(true);
      SetLateInitializerProlog(initTransportInfo);
      setNotifier(notifyLinkUpdate);
      SetDefaultUpdater(defaultUpdate);
      StartLateInitialization();
    }

    private void InitializeComponent()
    {
      cm = new AcopChartContextMenu(this);
      cm.Popup += Cm_Popup;
      this.ContextMenu = cm;

      this.MouseMove += new System.Windows.Forms.MouseEventHandler(this.AcopMouseMove);
      this.MouseUp += new System.Windows.Forms.MouseEventHandler(this.AcopMouseUp);
      this.Paint += new System.Windows.Forms.PaintEventHandler(this.AcopPaint);
      this.MouseEnter += new System.EventHandler(this.AcopMouseEnter);
      this.MouseHover += new System.EventHandler(this.AcopMouseHover);
      this.MouseLeave += new System.EventHandler(this.AcopMouseLeave);
      this.MouseDown += new System.Windows.Forms.MouseEventHandler(this.AcopMouseDown);
      this.MouseClick += new System.Windows.Forms.MouseEventHandler(this.AcopMouseClick);
      this.MouseDoubleClick += new System.Windows.Forms.MouseEventHandler(this.AcopMouseDoubleClick);
      this.Resize += new System.EventHandler(this.AcopResize);
      this.acopToolTip = new ToolTip();
      this.acopToolTip.OwnerDraw = true;
      this.acopToolTip.Draw += new DrawToolTipEventHandler(this.acopTooltip_Draw);
    }

    private void Cm_Popup(object sender, EventArgs e)
    {
      if (this.AutoScaleUpdate == AutoScaleMode.always) cm.ScaleAlways = true;
      else cm.ScaleAlways = false;
    }

    protected void OnPropertyChanged(string name)
    {
      PropertyChangedEventHandler handler = PropertyChanged;
      if (handler != null)
      {
        handler(this, new PropertyChangedEventArgs(name));
      }
    }
    /// <summary>
    /// Sets the chart's max and min setting back to the original default conditions
    /// </summary>
    public void SetDefaultScale()
    {
      autoScaleUpdate = AutoScaleMode.off;
      YMax = ymaxInitialSetting;
      YMin = yminInitialSetting;
      if (!autoTrend)
      {
        XMax = xmaxInitialSetting;
        XMin = xminInitialSetting;
      }
    }
    private void setAutoScaleUpdate(AutoScaleMode value)
    {
      autoScaleUpdate = value;
      if (!IsDesignMode())
      {
        if (autoScaleUpdate == AutoScaleMode.once) AutoScale(true);
      }
    }
    private AutoScaleMode getAutoScaleUpdate() { return autoScaleUpdate; }

    private void setAutoTrend(bool value)
    {
      autoTrend = value;
      if (value && AutoLinkCapacity == 0)
      {
        AutoLinkCapacity = 1;
      }
    }
    private bool getAutoTrend() { return autoTrend; }

    private int getTrendDepth() { return TrendDepthInPoints; }
    private void setTrendDepth(int depth) { TrendDepthInPoints = depth; }
    private double getTrendDepthHours()
    {
      return ((double)TrendDepthInSeconds) / 3600;
    }
    private void setTrendDepthHours(double depth)
    {
      depth *= 3600;
      TrendDepthInSeconds = (int)depth;
      if (!IsDesignMode())
      {
        if (!autoTrend) return;
        AcopControl.AcopLink[] lst = AcopControl.AcopLink.GetAcopLinkTable(this);
        if (lst == null || lst.Length == 0) return;
        foreach (AcopControl.AcopLink lnk in lst)
        {
          ClearScreen(lnk.GetDisplayId());
          lnk.SetDisplayId(-1);
        }
      }
    }
    private int pruneTrendBuffers(double[] buf, double[] tsbuf, int length)
    {
      double spacing = (TrendDepthInSeconds / TrendDepthInPoints);
      int i, n = 1;
      if (tsbuf.Length < length) length = tsbuf.Length;
      // check to see if the older points are in range ...
      for (i = 0; i < length && tsbuf[i] < tsbuf[length - 1] - TrendDepthInSeconds - spacing; i++) { }
      tsbuf[0] = tsbuf[i];
      buf[0] = buf[i];
      //spacing = (spacing * 5) / 4;
      //len = (len * 4) / 5; // prune the 1st 80%.
      for (i++; i < length - 1; i++)
      {
        if (tsbuf[i] < tsbuf[n - 1] + spacing)
        {
          continue;
        }
        tsbuf[n] = tsbuf[i];
        buf[n] = buf[i];
        n++;
      }
      for (; i < length; i++)
      {
        tsbuf[n] = tsbuf[i];
        buf[n] = buf[i];
        n++;
      }
      return n;
    }
    private Boolean captionSetAtDesignTime = false;
    private int getTickStringLength(double max, double min)
    {
      String fmtStr = "{0:###.#####}";
      if (max > 99999 || min < -99999) fmtStr = "{0:0e+0}";
      if (max > 0 && max < 0.00001) fmtStr = "{0:0e+0}";
      if (min > 0 && min < 0.00001) fmtStr = "{0:0e+0}";
      String smx = String.Format(fmtStr, YMax);
      String smn = String.Format(fmtStr, YMin);
      return Math.Max(smx.Length, smn.Length);
    }
    private void applyYAxisDisplaySettings(AcopTransport.DisplaySettings dsp)
    {
      if (dsp != null)
      {
        String dsc = FrameCaption;
        if (dsc == null || dsc.Length == 0 || captionSetAtDesignTime)
        {
          captionSetAtDesignTime = true;
          dsc = dsp.GetDescription();
          if (!LinkGrouped && LinkDevice.Length > 0) dsc += " (" + LinkDevice + ")";
          setCaption(dsc);
        }
        try
        {
          if (!yScaleSetByUser) YMax = dsp.GetYMaximum();
          if (!yScaleSetByUser) YMin = dsp.GetYMinimum();
          int slen = getTickStringLength(YMax, YMin);
          //String fmtStr = sca[0].getTickFormat();
          //String ymaxLabel = String.Format(fmtStr, YMax);
          //int slen = Math.Max(String.Format(fmtStr, YMax).Length, String.Format(fmtStr, YMin).Length);
          if (slen > 4)
          {
            if (FrameLeftOffset <= 10) FrameLeftOffset = slen * 5;
          }
        }
        catch (Exception) { } // just skip it if there's a problem
        setYAxisLabel(dsp.GetYUnits());
      }
    }
    private void applyXAxisDisplaySettings(AcopTransport.DisplaySettings dsp, ref String[] labels)
    {
      if (dsp != null)
      {
        if (!xScaleSetByUser) XMin = dsp.GetXMinimum();
        double xmx = dsp.GetXMaximum();
        int cap = getAutoLinkCapacity();
        if (cap > 0 && cap < xmx)
        {
          xmx = cap;
          applyAutoLinkCapacity = true;
        }
        if (!xScaleSetByUser) XMax = xmx;
        setXAxisLabel(dsp.GetXUnits());
        if (dsp.GetXScale() != 1) XScale = dsp.GetXScale();
        if (dsp.GetXShift() != 0) XShift = dsp.GetXShift();
        int atype = dsp.GetArrayType();
        if ((atype & AT_CHANNEL) == AT_CHANNEL)
        {
          if (!isAllowedHistogramDisplayMode(getDisplayMode()))
          {
            setDisplayMode(AcopConst.mode_histogram);
          }
          if (labels == null || labels.Length == 0)
          {
            if (LinkAddress != null)
            {
              String[] parts = LinkAddress.Split(new char[] { '/' }, StringSplitOptions.RemoveEmptyEntries);
              if (parts.Length > 1)
              {
                String ctx = parts[0];
                String srv = parts[1];
                if (parts.Length > 2 && parts[2].Contains("*"))
                  srv += "/" + parts[2];
                labels = AcopControl.AcopLink.GetDeviceList(LinkProtocol, ctx, LinkSubSystem, srv, LinkProperty);
              }
            }
          }
        }
        else if ((int)dsp.GetXMaximum() == 1 && (int)dsp.GetXMinimum() == 1)
        {
          setDisplayMode(AcopConst.mode_textbox);
        }
        else
        {
          if (PlottedBarLinesFilled == AcopBarLineFilledStyle.no_fill)
          {
            if (!isAllowedTrendChartDisplayMode(getDisplayMode(), false))
            {
              setDisplayMode(AcopConst.mode_polyline);
            }
          }
          else
          {
            if (!isAllowedTrendChartDisplayMode(getDisplayMode(), true))
            {
              setDisplayMode(AcopConst.mode_barline);
            }
          }
        }
      }
    }
    private String[] acopChartLabels = null;
    protected double ymaxInitialSetting = 0;
    protected double yminInitialSetting = 0;
    protected double xmaxInitialSetting = 0;
    protected double xminInitialSetting = 0;
    private void initTransportInfo()
    {
      if (!IsDesignMode())
      {
        AcopTransport.DisplaySettings dsp = null;
        if (!AutoLinkAttach && !AutoLinkUpdate)
        {
          displaySettingsAcquired = true;
          return;
        }
        needLegend = (showLegend && lgdItems.Count == 0);
        if (!getLinkGrouped())
        {
          dsp = acquireAndApplyDisplaySettings(LinkAddress, LinkProperty, ref acopChartLabels, false);
          if (dsp == null || dsp.SettingsStale()) return;
          displaySettingsAcquired = true;
          applyYAxisDisplaySettings(dsp);
          applyXAxisDisplaySettings(dsp, ref acopChartLabels);
        }
        else
        {
          AcopControl.AcopLink[] lst = AcopControl.AcopLink.GetAcopLinkTable(this);
          for (int i = 0; i < lst.Length; i++)
          {
            dsp =
              acquireAndApplyDisplaySettings(lst[i].GetAddress(), lst[i].GetProperty(), ref acopChartLabels, true);
            if (dsp == null) continue;
            displaySettingsAcquired = true; // chart just needs one active link to get the settings 
            applyYAxisDisplaySettings(dsp);
            applyXAxisDisplaySettings(dsp, ref acopChartLabels);
            break;
          }
        }
      }
      ymaxInitialSetting = YMax;
      yminInitialSetting = YMin;
      xmaxInitialSetting = XMax;
      xminInitialSetting = XMin;
    }
    public enum ColorIncrement
    {
      none = 0,
      lighter = 1,
      darker = 2,
      dramatic = 3
    }
    private ColorIncrement fgColorIncrement = ColorIncrement.none;
    private int colorIncrCounter = 0;
    private Color getColorIncrement(Color c)
    {
      switch (fgColorIncrement)
      {
        case ColorIncrement.none: return c;
        case ColorIncrement.lighter:
          return ControlPaint.Light(c, 33f);
        case ColorIncrement.darker:
          return ControlPaint.Dark(c, 33f);
        default:
          int r = c.R, g = c.G, b = c.B;
          int t = r;
          r = g; g = b; b = t;
          Color nc = Color.FromArgb(r, g, b);
          if (colorIncrCounter++ < 3) return nc;
          return ControlPaint.Dark(nc, 50f);
      }
    }
    public ColorIncrement GetForegroundColorAutoIncrement()
    {
      return fgColorIncrement;
    }
    public void SetForegroundColorAutoIncrement(ColorIncrement value)
    {
      fgColorIncrement = value;
    }
    private int colorListIndex = 0;
    private Color getDrawColor()
    {
      Color c = ForegroundColor;
      Color[] lst = GetColorList();
      if (lst != null)
      {
        c = lst[colorListIndex];
        colorListIndex = (++colorListIndex % lst.Length);
      }
      else if (fgColorIncrement != ColorIncrement.none)
      {
        c = getColorIncrement(ForegroundColor);
      }
      return c;
    }
    /// <summary>
    /// gets a trend of history points according to the TrendDepthInPoints setting
    /// </summary>
    /// <param name="Flags">optional flags</param>
    /// <returns>a trend of history points according to the TrendDepthInPoints setting</returns>
    public double[][] GetTrendPoints(int Flags)
    {
      double stopt = getUtcNow();
      int len = TrendDepthInPoints;
      double[][] hdata = new double[2][];
      hdata[0] = new double[len];
      hdata[1] = new double[len];
      double startt = stopt - TrendDepthInSeconds;
      AcopControl.AcopLink lnk = GetAttachedLink();
      if (lnk == null) return null;
      if (lnk.GetHistoryPoints(hdata, ref len, startt, stopt, Flags, 500) == 0)
      {
        if (len < TrendDepthInPoints && lnk.IsAttached())
        {
          hdata[0][len] = lnk.GetOutputYAxis()[0];
          hdata[1][len] = stopt;
          len++;
        }
      }
      Array.Resize(ref hdata[0], len);
      Array.Resize(ref hdata[1], len);
      return hdata;
    }
    private Boolean isAllowedHistogramDisplayMode(int mode)
    {
      switch (mode)
      {
        case AcopConst.mode_histogram: return true;
        case AcopConst.mode_histogram_dots: return true;
        case AcopConst.mode_histogram_rastoring: return true;
        case AcopConst.mode_histogram_rastoring_dots: return true;
      }
      return false;

    }
    private Boolean isAllowedTrendChartDisplayMode(int mode, bool filled)
    {
      switch (mode)
      {
        case AcopConst.mode_barline: return true;
        case AcopConst.mode_barline_dots: return true;
        case AcopConst.mode_polyline: return filled ? false : true;
        case AcopConst.mode_polyline_cross: return filled ? false : true;
        case AcopConst.mode_polyline_dots: return filled ? false : true;
      }
      return false;
    }
    private void showInitialTrend(AcopControl.AcopLink lnk)
    {
      if (PlottedBarLinesFilled == AcopBarLineFilledStyle.no_fill)
      {
        if (!isAllowedTrendChartDisplayMode(getDisplayMode(), false))
        {
          setDisplayMode(AcopConst.mode_polyline);
        }
      }
      else
      {
        if (!isAllowedTrendChartDisplayMode(getDisplayMode(), true))
        {
          setDisplayMode(AcopConst.mode_barline);
        }
      }
      setAcopGraphStyle(AcopGraphStyle.TIME_LIN);
      setLeftTimeLabel(false);
      XMax = getUtcNow();
      int len = TrendDepthInPoints;
      double[][] hdata = new double[2][];
      hdata[0] = new double[len];
      hdata[1] = new double[len];
      double startt = XMax - TrendDepthInSeconds;
      if (lnk.GetHistoryPoints(hdata, ref len, startt, XMax, 0, 500) == 0)
      {
        XMin = startt;
        if (len < TrendDepthInPoints)
        {
          hdata[0][len] = lnk.GetOutputYAxis()[0];
          hdata[1][len] = XMax;
          len++;
        }
        lnk.SetDisplayId(Draw(hdata[0], hdata[1], len, TrendDepthInPoints));
        double spacing = (TrendDepthInSeconds / TrendDepthInPoints);
        if (len > 2 && (hdata[1][1] - hdata[1][0] > spacing || spacing > DefaultMonitorInterval/1000))
        {
          SetNeedsPruning(lnk.GetDisplayId(), true);
        }
      }
      else
      {
        XMin = XMax - TrendDepthInPoints;
        lnk.SetDisplayId(Draw(lnk.GetOutputYAxis()[0], XMax, 1, TrendDepthInPoints));
      }
    }
    private int pruneTrendDisplay(AcopControl.AcopLink lnk)
    {
      int did = lnk.GetDisplayId();
      double spacing = (TrendDepthInSeconds / TrendDepthInPoints);
      if (GetNumberDrawnData(did) >= (TrendDepthInPoints - spacing))
      {
        if (TrendDepthInSeconds > TrendDepthInPoints)
        {
          double[] dbuf = new double[TrendDepthInPoints];
          double[] tbuf = new double[TrendDepthInPoints];
          int ndrawn;
          if ((ndrawn = GetDrawnData(dbuf, tbuf, TrendDepthInPoints, 0, did)) > 0)
          {
            int npts = pruneTrendBuffers(dbuf, tbuf, ndrawn);
            if (npts > 0)
            {
              int n = TrendDepthInPoints - npts;
              double[] zpts = new double[n];
              zpts.Initialize();
              //RefreshScreen(zpts, did, n, 0, zpts);
              //RefreshScreen(dbuf, did, npts, n, tbuf);
              AppendScreen(zpts, did, n, 0, zpts);
              AppendScreen(dbuf, did, npts, n, tbuf);
              //Color c = histo[did].penColor;
              //if (c == Color.Empty) c = ForeColor;
              //ClearScreen(did);
              //SetForeground(c);
              //did = Draw(dbuf, tbuf, npts, TrendDepthInPoints);
              //lnk.SetDisplayId(did);
              if (npts > 2 && tbuf[1] - tbuf[0] < spacing)
              {
                SetNeedsPruning(lnk.GetDisplayId(), false);
              }
            }
          }
        }
        else
        {
          SetNeedsPruning(lnk.GetDisplayId(), false);
        }
      }
      return did;
    }
    // below: the default update event handler
    // each control will do something similar ...
    private object updateLock = new object();
    private Boolean needLegend = false;
    private String getLegendString(String addr, String prop)
    {
      if (addr == null && prop == null) return "";
      String ls = prop == null ? "" : prop;
      if (addr != null)
      {
        String[] parts = addr.Split(new char[] { '/' }, StringSplitOptions.RemoveEmptyEntries);
        String dev = parts.Last();
        if (dev.Length > 0) ls += "(" + dev + ")";
      }
      return ls;
    }
    private void defaultUpdate(AcopControl.AcopLink lnk)
    {
      lock (updateLock)
      {
        if (!lateInitializationDone)
        {
          if (lnk.GetStatus() == 0) earlyRespondingLink = lnk;
          return;
        }
        if (!displaySettingsAcquired) initTransportInfo();
        if (getAutoUpdate() && !autoTrend)
        {
          if (!getLinkGrouped())
          { // not grouped
            if (lnk.GetStatus() != 0 && ErrorValue.Length == 0) return;
            int did = lnk.GetDisplayId();
            if ((did = lnk.GetDisplayId()) < 0)
            { // are channel names contained in the output data type ?
              String[] names = lnk.GetOutputChannelNames();
              if (names == null) names = acopChartLabels;
              if (applyAutoLinkCapacity)
              {
                int cap = getAutoLinkCapacity();
                did = Draw(lnk.GetOutputYAxis(), null, null, names, cap, cap, false);
              }
              else
              {
                did = acopChartLabels != null ? Draw(lnk.GetOutputYAxis(), names) : Draw(lnk.GetOutputYAxis());
              }
              lnk.SetDisplayId(did);
              if (autoScaleUpdate == AutoScaleMode.once) AutoScale(true);
              if (needLegend)
              { // auto-legend
                String dsc = getDescription();
                if (dsc.Length == 0) dsc = LinkProperty;
                AddLegendItem(did, dsc);
              }
            }
            else
            {
              if (this.histo[did].displayON == 1) RefreshScreen(lnk.GetOutputYAxis(), did);
            }
          }
          else
          { // is grouped !
            AcopControl.AcopLink[] lst = AcopControl.AcopLink.GetAcopLinkTable(this);
            int did;
            foreach (AcopControl.AcopLink al in lst)
            {
              if (al.GetStatus() != 0 && ErrorValue.Length == 0) continue;
              if ((did = al.GetDisplayId()) < 0)
              {
                String[] names = lnk.GetOutputChannelNames();
                if (names == null) names = acopChartLabels;
                ForegroundColor = getDrawColor();
                if (applyAutoLinkCapacity)
                {
                  int cap = getAutoLinkCapacity();
                  did = Draw(al.GetOutputYAxis(), null, null, names, cap, cap, false);
                }
                else
                {
                  did = acopChartLabels != null ? Draw(al.GetOutputYAxis(), names) : Draw(al.GetOutputYAxis());
                }
                if (autoScaleUpdate == AutoScaleMode.once) AutoScale(true);
                al.SetDisplayId(did);
                if (needLegend)
                { // auto-legend
                  AddLegendItem(did, getLegendString(al.GetAddress(),al.GetProperty()));
                }
              }
              else
              {
                if (this.histo[did].displayON == 1) RefreshScreen(al.GetOutputYAxis(), did);
              }
            }
          }
        }
        else if (autoTrend)
        {
          if (!getLinkGrouped())
          {
            if (lnk.GetStatus() != 0 && ErrorValue.Length == 0) return;
            int did = lnk.GetDisplayId();
            if (did < 0)
            {
              showInitialTrend(lnk);
              if (autoScaleUpdate == AutoScaleMode.once) AutoScale(true);
              if (needLegend)
              { // auto-legend
                String dsc = getDescription();
                if (dsc.Length == 0) dsc = LinkProperty;
                did = lnk.GetDisplayId(); // should be valid now
                AddLegendItem(did, dsc);
              }
            }
            else
            {
              if (NeedsPruning(did)) did = pruneTrendDisplay(lnk);
              AppendScreen(lnk.GetOutputYAxis()[0], did, getUtcNow());
            }
          }
          else
          {
            AcopControl.AcopLink[] lst = AcopControl.AcopLink.GetAcopLinkTable(this);
            int did;
            foreach (AcopControl.AcopLink al in lst)
            {
              if (al.GetStatus() != 0 && ErrorValue.Length == 0) continue;
              if ((did = al.GetDisplayId()) < 0)
              {
                ForegroundColor = getDrawColor();
                showInitialTrend(al);
                if (autoScaleUpdate == AutoScaleMode.once) AutoScale(true);
                if (needLegend)
                { // auto-legend
                  did = al.GetDisplayId(); // should be valid now
                  AddLegendItem(did, getLegendString(al.GetAddress(), al.GetProperty()));
                }
              }
              else
              {
                if (NeedsPruning(did)) pruneTrendDisplay(lnk);
                AppendScreen(al.GetOutputYAxis()[0], did, getUtcNow());
              }
            }
          }
        }
        if (!IsZoomed() && autoScaleUpdate == AutoScaleMode.always) AutoScale(true);
      }
    }
    private void acopTooltip_Draw(object sender, DrawToolTipEventArgs e)
    {
      e.DrawBackground();
      e.DrawBorder();
      e.DrawText();
    }

    private void PrintPage(object sender, PrintPageEventArgs e)
    {
      float x1, x2, x3, y1, y2, y3, tmp, scale, offsetX, offsetY;
      Graphics graphics = e.Graphics;
      RectangleF pArea = e.PageSettings.PrintableArea;
      x1 = pArea.Width;  // pageFormat.getImageableWidth();
      x2 = this.Size.Width;   // .getSize().width;
      x3 = pArea.X;  // pageFormat.getImageableX();
      y1 = pArea.Height; // pageFormat.getImageableHeight();
      y2 = this.Size.Height;  //.getSize().height;
      y3 = pArea.Y;  // pageFormat.getImageableY();
      tmp = x1 / x2;
      scale = y1 / y2;
      offsetX = 0;
      offsetY = 0;
      if (printScreenPosition != 0)
      {
        if (tmp < scale)
        {
          offsetY = y1 - y2 * tmp;
          if (printScreenPosition == 1) offsetY /= 2;
        }
        else
        {
          offsetX = x1 - x2 * scale;
          if (printScreenPosition == 1) offsetX /= 2;
        }
      }
      if (tmp < scale) scale = tmp;
      float xMargin = (x1 - x2 * scale) / 2 + offsetX;
      float yMargin = (y1 - y2 * scale) / 2 + offsetY;
      graphics.TranslateTransform(x3 + xMargin, y3 + yMargin);
      graphics.ScaleTransform(scale, scale);
      paintComponent(graphics);
      graphics.ScaleTransform(-scale, -scale);
      graphics.TranslateTransform(-x3 - xMargin, -y3 - yMargin);
    }
    public int PrintScreen()
    {
      return PrintScreen(0);
    }
    public int PrintScreen(int position)
    {
      PrintDocument PrintDoc = new PrintDocument();
      printScreenPosition = (position < 0 || position > 2) ? 0 : position;

      PrintDoc.PrintPage += new PrintPageEventHandler(PrintPage);
      PrintDoc.Print();

      return 0;
    }

    public int SetBackgroundRegion(RectangleF[] colorRegionRect, Color[] regionColor, Boolean fixedR)
    {
      return SetBackgroundRegion(colorRegionRect, regionColor, null, null, fixedR);
    }
    public int SetBackgroundRegion(RectangleF[] imageRegionRect, String[] imageFilename, Boolean fixedR)
    {
      return SetBackgroundRegion(null, null, imageRegionRect, imageFilename, fixedR);
    }
    public int SetBackgroundRegion(RectangleF[] colorRegionRect, Color[] regionColor,
        RectangleF[] imageRegionRect, String[] imageFilename, Boolean fixedR)
    {
      int numColorRegion, numImageRegion, numRegion, colorLength, imageLength;
      if ((colorRegionRect == null && imageRegionRect == null) || // no rectangle
          (regionColor == null && imageFilename == null))
      {
        nBackRegions = 0;
        return 0;
      }
      numColorRegion = (colorRegionRect != null && regionColor != null) ? colorRegionRect.Length : 0;
      numImageRegion = (imageRegionRect != null && imageFilename != null) ? imageRegionRect.Length : 0;
      if (numColorRegion <= 0 && numImageRegion <= 0)
      {
        nBackRegions = 0;
        return 0;
      }
      colorLength = regionColor != null ? regionColor.Length : 0;
      imageLength = imageFilename != null ? imageFilename.Length : 0;
      numRegion = numColorRegion + numImageRegion;
      if (numRegion > AcopConst.MAX_BACKGROUND_REGION) numRegion = AcopConst.MAX_BACKGROUND_REGION;
      for (int i = 0; i < numRegion; i++) // load user region and color array or
      // images
      {
        backRegionUserRect[i] = i < numColorRegion ? colorRegionRect[i] : imageRegionRect[i - numColorRegion];
        if (backRegionUserRect[i] == null)
        {
          backkgroundRegionType[i] = 0;
          continue;
        }
        if (i < numColorRegion)
        {
          backRegionColor[i] = i < colorLength ? regionColor[i] : regionColor[i - 1];
          backRegionBrush[i] = new SolidBrush(backRegionColor[i]);
          backkgroundRegionType[i] = 1;
        }
        else
        {
          backkgroundRegionType[i] = 2;
          if (i - numColorRegion >= imageLength)
            backRegionImage[i] = backRegionImage[i - 1];
          else
            backRegionImage[i] = new Bitmap(imageFilename[i - numColorRegion]);
        }
      }
      backgroundRegionFixed = fixedR;
      if (numRegion > 0)
      {
        nBackRegions = numRegion;
        convertBackgroundRegion(true);
      }
      return numRegion;
    }

    private void convertBackgroundRegion(Boolean fourceConvert)
    {
      int xpos, xlength, ypos, ylength;
      if (nBackRegions == 0) return;
      if (!fourceConvert && backgroundRegionFixed) return;
      for (int i = 0; i < nBackRegions; i++) // convert
      {
        if (backkgroundRegionType[i] == 0) continue;
        ylength = (int)(aFrame.histRect.Height * backRegionUserRect[i].Height / sca[1].dispSize);
        ypos = (int)(aFrame.histRect.Y - ylength + aFrame.histRect.Height
            * (1.0 - (backRegionUserRect[i].Y - sca[1].min) / sca[1].dispSize));
        xpos = (int)(aFrame.histRect.X + aFrame.histRect.Width * (backRegionUserRect[i].X - sca[0].min)
            / sca[0].dispSize);
        xlength = (int)(aFrame.histRect.Width * backRegionUserRect[i].Width / sca[0].dispSize);
        backRegionRect[i] = new Rectangle(xpos, ypos, xlength, ylength);
      }
    }

    public int SetDisplayGap(int pixel)
    {
      return SetDisplayGap(pixel, pixel);
    }
    public int SetDisplayGap(int xPixel, int yPixel)
    {
      return SetDisplayGap(xPixel, xPixel, yPixel, yPixel);
    }
    public int SetDisplayGap(int xLeftPixel, int xRightPixel, int yTopPixel, int yBottomPixel)
    {
      if (xLeftPixel < 0 || xLeftPixel >= aFrame.histRect.Width / 2) xLeftPixel = 0;
      if (xRightPixel < 0 || xRightPixel >= aFrame.histRect.Width / 2) xRightPixel = 0;
      if (yTopPixel < 0 || yTopPixel >= aFrame.histRect.Height / 2) yTopPixel = 0;
      if (yBottomPixel < 0 || yBottomPixel >= aFrame.histRect.Height / 2) yBottomPixel = 0;
      fLeftPixel = xLeftPixel;
      fRightPixel = xRightPixel;
      fTopPixel = yTopPixel;
      fBottomPixel = yBottomPixel;
      scaleFrameDraw();
      return xLeftPixel;
    }

    protected internal void averagingScaling(double[] df, int start, int stop, int index)
    {
      int i, j, max;
      double maximum;
      if (averagingDepth > 0) // averaging
      {
        if (averagingLength == 0)
          NumberAveragingData = histo[index].npoints;
        else if (++averagingIndex == averagingDepth) averagingIndex = 0;
        if (averagingLength < averagingDepth)
        {
          if (averagingBuffer[averagingIndex] == null || averagingBuffer[averagingIndex].Length < NumberAveragingData)
            averagingBuffer[averagingIndex] = new double[NumberAveragingData];
          averagingLength++;
          // calculate averaging exponential function
          totalWeight = 0;
          for (i = 0; i < averagingLength; i++)
            totalWeight += averageWeight[i];
        }
        max = histo[index].npoints < NumberAveragingData ? histo[index].npoints : NumberAveragingData;
        Array.Copy(df, 0, averagingBuffer[averagingIndex], 0, max);
        if (averagingLength > 1) for (j = start; j < stop; j++)
          {
            if (j >= max) break;
            maximum = 0;
            for (i = 0; i < averagingLength; i++)
            {
              if (averagingMode == 0)
                maximum += averagingBuffer[i][j];
              else
                maximum += (averagingBuffer[i][j] * averageWeight[i]);
            }
            df[j] = maximum / (averagingMode == 0 ? averagingLength : totalWeight);
          }
      }
      if (yWAdataSize > 0 && histo[index].yScaleEnable)
      {
        max = histo[index].npoints < yWAdataSize ? histo[index].npoints : yWAdataSize;
        for (i = start; i < stop && i < max; i++)
          df[i] *= yWindowArray[i];
      }
      if (yRAdataSize > 0 && histo[index].yReferenceEnable)
      {
        max = histo[index].npoints < yRAdataSize ? histo[index].npoints : yRAdataSize;
        for (i = start; i < stop && i < max; i++)
          df[i] -= yReferenceArray[i];
      }
    }

    /// <summary>
    /// Apply a 'weight function' (i.e. an array used to scale the contents of the drawn array)
    /// </summary>
    /// <param name="WeightArray">The array used to multiply (element by element) the drawn Y-axis array.</param>
    /// <returns>0 upon success</returns>
    public int WeightFunction(Object WeightArray)
    {
      return WeightFunction(WeightArray, 0);
    }
    /// <summary>
    /// Apply a 'weight function' (i.e. an array used to scale the contents of the drawn array)
    /// </summary>
    /// <param name="WeightArray">The array used to multiply (element by element) the drawn Y-axis array.</param>
    /// <param name="Length">The length of the input array to apply.</param>
    /// <returns>0 upon success</returns>
    public int WeightFunction(Object WeightArray, int Length)
    {
      int ndata;
      ndata = AcopHisto.getArrayLength(WeightArray);
      if (ndata <= 0) return -1;
      if (Length > 0 && Length < ndata) ndata = Length;
      if (yWindowArray == null || yWASize < ndata)
      {
        yWindowArray = new double[ndata];
        yWASize = ndata;
      }
      AcopHisto.copyArray(yWindowArray, WeightArray, 0, ndata, ndata, 1);
      yWAdataSize = ndata;
      return 0;
    }

    /// <summary>
    /// Apply a 'reference function' (i.e. an array used to offset the contents of the drawn array).
    /// </summary>
    /// <param name="ReferenceArray">The array used to offset (element by element) the drawn Y-axis array.</param>
    /// <returns>0 upon success</returns>
    public int ReferenceFunction(Object ReferenceArray)
    {
      return ReferenceFunction(ReferenceArray, 0);
    }
    /// <summary>
    /// Apply a 'reference function' (i.e. an array used to offset the contents of the drawn array).
    /// </summary>
    /// <param name="ReferenceArray">The array used to offset (element by element) the drawn Y-axis array.</param>
    /// <param name="Length">The length of the input array to apply.</param>
    /// <returns>0 upon success</returns>
    public int ReferenceFunction(Object ReferenceArray, int Length)
    {
      int ndata;
      ndata = AcopHisto.getArrayLength(ReferenceArray);
      if (ndata <= 0) return -1;
      if (Length > 0 && Length < ndata) ndata = Length;
      if (yReferenceArray == null || yRASize < ndata)
      {
        yReferenceArray = new double[ndata];
        yRASize = ndata;
      }
      AcopHisto.copyArray(yReferenceArray, ReferenceArray, 0, ndata, ndata, 1);
      yRAdataSize = ndata;
      return 0;
    }

    public Boolean IsErrorWindowOn()
    {
      return IsErrorWindowOn(-1, -1);
    }
    public Boolean IsErrorWindowOn(int hDisplay)
    {
      return IsErrorWindowOn(hDisplay, -1);
    }
    public Boolean IsErrorWindowOn(Boolean turnON)
    {
      return IsErrorWindowOn(-1, turnON ? 1 : 0);
    }
    public Boolean IsErrorWindowOn(int hDisplay, Boolean turnON)
    {
      return IsErrorWindowOn(hDisplay, turnON ? 1 : 0);
    }
    private Boolean IsErrorWindowOn(int hDisplay, int value)
    {
      Boolean arayon;
      if (hDisplay < -1 || hDisplay >= n_display) return false; // out of range,
      // -1 to set for
      // default value
      if (value < 0 || value > 1) // reading
        return (hDisplay == -1 || histo[hDisplay] == null) ? errWindowOn : histo[hDisplay].errWindowEnable;
      arayon = value != 0 ? true : false;
      if (hDisplay != -1)
      {
        if (histo[hDisplay] == null) return false;
        histo[hDisplay].errWindowEnable = arayon;
        return histo[hDisplay].errWindowEnable;
      }
      errWindowOn = arayon; // set default value and all the rest
      for (int i = 0; i < n_display; i++)
      {
        if (histo[i] == null) break;
        histo[i].errWindowEnable = arayon;
      }
      return arayon;
    }
    public Boolean IsWeighted(int hDisplay)
    {
      return IsWeighted(hDisplay, -1);
    }
    public Boolean IsWeighted(int hDisplay, int value)
    {
      Boolean arayon;
      if (hDisplay < -1 || hDisplay >= n_display) return false; // out of range,
      // -1 to set for
      // default value
      if (value < 0 || value > 1) // reading
        return (hDisplay == -1 || histo[hDisplay] == null) ? ScaleEnable : histo[hDisplay].yScaleEnable;
      arayon = value != 0 ? true : false;
      if (hDisplay != -1)
      {
        if (histo[hDisplay] == null) return false;
        histo[hDisplay].yScaleEnable = arayon;
        return histo[hDisplay].yScaleEnable;
      }
      ScaleEnable = arayon; // set default value and all the rest
      for (int i = 0; i < n_display; i++)
      {
        if (histo[hDisplay] == null) break;
        histo[hDisplay].yScaleEnable = arayon;
      }
      return arayon;
    }
    public Boolean IsReferenced(int hDisplay)
    {
      return IsReferenced(hDisplay, -1);
    }
    public Boolean IsReferenced(int hDisplay, int value)
    {
      Boolean arayon;
      if (hDisplay < -1 || hDisplay >= n_display) return false; // out of range,
      // -1 to set for
      // default value
      if (value < 0 || value > 1)
        // reading
        return (hDisplay == -1 || histo[hDisplay] == null) ? ReferenceEnable : histo[hDisplay].yReferenceEnable;
      arayon = value != 0 ? true : false;
      if (hDisplay != -1)
      {
        if (histo[hDisplay] == null) return false;
        histo[hDisplay].yReferenceEnable = arayon;
        return histo[hDisplay].yReferenceEnable;
      }
      ReferenceEnable = arayon; // set default value and all the rest
      for (int i = 0; i < n_display; i++)
      {
        if (histo[i] == null) break;
        histo[i].yReferenceEnable = arayon;
      }
      return arayon;
    }
    protected internal void setmarkerflag(int flag)
    {
      for (int n = 0; n < n_display; n++)
      {
        if (histo[n] == null) break;
        if (flag == 2 || histo[n].displayON != 0) histo[n].marker_ary_cpy = flag;
      }
    }

    /// <summary>
    /// Sets the Zoom state of the given acop chart (as if it were zoomed per hand).
    /// </summary>
    /// <param name="ZoomXMax">If true will accept zoomed X-axis maximum coordinates</param>
    /// <param name="ZoomXMin">If true will accept zoomed X-axis minimum coordinates</param>
    /// <param name="ZoomYMax">If true will accept zoomed Y-axis maximum coordinates</param>
    /// <param name="ZoomYMin">If true will accept zoomed Y-axis minimum coordinates</param>
    /// <param name="SecondaryYMax">If true will accept zoomed secondary Y-axis maximum coordinates</param>
    /// <param name="SecondaryYMin">If true will accept zoomed secondary Y-axis minimum coordinates</param>
    /// <param name="xmx">Is the desired X-axis maximum following the zoom action.</param>
    /// <param name="xmn">Is the desired X-axis minimum following the zoom action.</param>
    /// <param name="ymx">Is the desired Y-axis maximum following the zoom action.</param>
    /// <param name="ymn">Is the desired Y-axis minimum following the zoom action.</param>
    /// <param name="ymxSecondary">Is the desired secondary Y-axis maximum following the zoom action.</param>
    /// <param name="ymnSecondary">Is the desired secondary Y-axis minimum following the zoom action</param>
    public void SetZoom(Boolean ZoomXMax, Boolean ZoomXMin, Boolean ZoomYMax, Boolean ZoomYMin, Boolean SecondaryYMax, Boolean SecondaryYMin, double xmx, double xmn,
        double ymx, double ymn, double ymxSecondary, double ymnSecondary)
    {
      int dezoomFlag = 0, i;
      double[] storemin = new double[3];
      double[] storemax = new double[3];
      if (histo[m_histstart] == null || !aFrame.drawFlag) return;
      if (!ZoomXMax) xmx = sca[0].getMax();
      if (!ZoomXMin) xmn = sca[0].getMin();
      if (!ZoomYMax) ymx = sca[1].getMax();
      if (!ZoomYMin) ymn = sca[1].getMin();
      if (!SecondaryYMax) ymxSecondary = sca[2].getMax();
      if (!SecondaryYMin) ymnSecondary = sca[2].getMin();
      if (xmn >= xmx)
      {
        xmn = sca[0].usermin;
        xmx = sca[0].usermax;
      }
      if (ymn >= ymx)
      {
        ymn = sca[1].usermin;
        ymx = sca[1].usermax;
      }
      if (ymnSecondary >= ymxSecondary)
      {
        ymnSecondary = sca[2].usermin;
        ymxSecondary = sca[2].usermax;
      }
      if ((zooming & 0x4) != 0)
      {
        dezoomFlag = 0;
        if (zoomIndex > 0) // compare size
        {
          for (i = 0; i < 3; i++)
          {
            storemin[i] = sca[i].getMin();
            storemax[i] = sca[i].getMax();
          }
          if (Math.Abs((xmx - xmn) - (storemax[0] - storemin[0])) < AcopConst.zero_check
              && Math.Abs((ymx - ymn) - (storemax[1] - storemin[1])) < AcopConst.zero_check
              && Math.Abs((ymxSecondary - ymnSecondary) - (storemax[2] - storemin[2])) < AcopConst.zero_check) return;
          if ((xmx - xmn) > (storemax[0] - storemin[0]) || (ymx - ymn) > (storemax[1] - storemin[1]) || (ymxSecondary - ymnSecondary) > (storemax[2] - storemin[2]))
          {
            dezoomFlag = 1;
            if (zoomIndex == 1) // finish zoom
            {
              xmn = sca[0].usermin;
              xmx = sca[0].usermax;
              ymn = sca[1].usermin;
              ymx = sca[1].usermax;
              ymnSecondary = sca[2].usermin;
              ymxSecondary = sca[2].usermax;
            }
          }
        }
        if (dezoomFlag == 0 && zoomIndex < AcopConst.lengthZoom)
        {
          for (i = 0; i < 3; i++)
          {
            storemin[i] = sca[i].getMin();
            storemax[i] = sca[i].getMax();
          }
        }
      }
      if (zoomXmaxFlag != 2) zoomXmaxFlag = xmx < sca[0].usermax ? 2 : 1;
      sca[0].setDispscale(xmn, xmx);
      sca[1].setDispscale(ymn, ymx);
      sca[2].setDispscale(ymnSecondary, ymxSecondary);
      if (sca[0].isOriginMaxMin() && sca[1].isOriginMaxMin())
      {
        isZoomedFlag = false;
        zoomXmaxFlag = 0;
        if ((zooming & 0x4) != 0) zoomIndex = 0;
      }
      else
      {
        isZoomedFlag = true;
        if ((zooming & 0x4) != 0)
        {
          if (dezoomFlag != 0)
          {
            zoomIndex--;
            for (i = 0; i < 3; i++)
            {
              sca[i].setDispscale(bufferedMin[zoomIndex, i], bufferedMax[zoomIndex, i]);
              if (sca[i].log != 0) sca[i].setDispscale(Math.Pow(10.0, sca[i].min), Math.Pow(10.0, sca[i].max));
            }
            zoomXmaxFlag = bufferedXtimeFlag[zoomIndex];
            bufferedZoomRatio = "Z" + zoomIndex;
          }
          else if (zoomIndex < AcopConst.lengthZoom)
          {
            bufferedXtimeFlag[zoomIndex] = zoomXmaxFlag;
            for (i = 0; i < 3; i++)
            {
              bufferedMin[zoomIndex, i] = storemin[i];
              bufferedMax[zoomIndex, i] = storemax[i];
              if (zoomIndex > 0 && sca[i].log != 0)
              {
                if (storemin[i] > 0) bufferedMin[zoomIndex, i] = Math.Log(storemin[i]) / Math.Log(10);
                if (storemax[i] > 0) bufferedMax[zoomIndex, i] = Math.Log(storemax[i]) / Math.Log(10);
              }
            }
            zoomIndex++;
            bufferedZoomRatio = "Z" + zoomIndex;
          }
        }
      }
      zoomFlag = false;
      sca[0].scaleToGrid();
      if (m_marker == 2) setmarkerflag(2); // recalculate marker array
      // prepareDraw(TRUE, -1, FALSE, nScaleText); // rescale and not set max
      // limit
      rescaleFlag = 1;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw(); // rescale and not set max limit
      yZoomRatio = "V" + (int)(sca[1].userSize / sca[1].dispSize + 0.5) + ":1";
      xZoomRatio = "H" + (int)(sca[0].userSize / sca[0].dispSize + 0.5) + ":1";
    }
    /// <summary>
    /// Sets the Zoom state of the given acop chart (as if it were zoomed per hand).
    /// </summary>
    /// <param name="ZoomXMax">If true will accept zoomed X-axis maximum coordinates</param>
    /// <param name="ZoomXMin">If true will accept zoomed X-axis minimum coordinates</param>
    /// <param name="ZoomYMax">If true will accept zoomed Y-axis maximum coordinates</param>
    /// <param name="ZoomYMin">If true will accept zoomed Y-axis minimum coordinates</param>
    /// <param name="xmx">Is the desired X-axis maximum following the zoom action.</param>
    /// <param name="xmn">Is the desired X-axis minimum following the zoom action.</param>
    /// <param name="ymx">Is the desired Y-axis maximum following the zoom action.</param>
    /// <param name="ymn">Is the desired Y-axis minimum following the zoom action.</param>
    public void SetZoom(Boolean ZoomXMax, Boolean ZoomXMin, Boolean ZoomYMax, Boolean ZoomYMin, double xmx, double xmn,
        double ymx, double ymn)
    {
      SetZoom(ZoomXMax, ZoomXMin, ZoomYMax, ZoomYMin, false, false, xmx, xmn, ymx, ymn, 0, 0);
    }
    /// <summary>
    /// Sets the Zoom state of the given acop chart (as if it were zoomed per hand).
    /// </summary>
    /// <param name="xmx">Is the desired X-axis maximum following the zoom action.</param>
    /// <param name="xmn">Is the desired X-axis minimum following the zoom action.</param>
    /// <param name="ymx">Is the desired Y-axis maximum following the zoom action.</param>
    /// <param name="ymn">Is the desired Y-axis minimum following the zoom action.</param>
    /// <param name="ymxSecondary">Is the desired secondary Y-axis maximum following the zoom action.</param>
    /// <param name="ymnSecondary">Is the desired secondary Y-axis minimum following the zoom action</param>
    public void SetZoom(double xmx, double xmn, double ymx, double ymn, double ymxSecondary, double ymnSecondary)
    {
      SetZoom(true, true, true, true, true, true, xmx, xmn, ymx, ymn, ymxSecondary, ymnSecondary);
    }
    /// <summary>
    /// Sets the Zoom state of the given acop chart (as if it were zoomed per hand).
    /// </summary>
    /// <param name="xmx">Is the desired X-axis maximum following the zoom action.</param>
    /// <param name="xmn">Is the desired X-axis minimum following the zoom action.</param>
    /// <param name="ymx">Is the desired Y-axis maximum following the zoom action.</param>
    /// <param name="ymn">Is the desired Y-axis minimum following the zoom action.</param>
    public void SetZoom(double xmx, double xmn, double ymx, double ymn)
    {
      SetZoom(true, true, true, true, false, false, xmx, xmn, ymx, ymn, 0, 0);
    }

    public int getScaledCoordinates(Object Coordinates)
    {
      int arySize, i; // return up to 6 values: Left, Right, Bottom, Top,
      // SecondaryBottom, SecondaryTop
      if (Coordinates == null) return 0;
      arySize = AcopHisto.getArrayLength(Coordinates);
      if (arySize == 0) return 0;
      if (arySize > 6) arySize = 6;
      double[] tmpData = new double[arySize];
      for (i = 0; i < arySize; i++)
        tmpData[i] = (i % 2 == 0) ? sca[i / 2].getMin() : sca[i / 2].getMax();
      arySize = AcopHisto.copyArray(tmpData, Coordinates, 0, arySize, arySize, 0);
      return arySize;
    }
    /// <summary>
    /// Retrieves the data displayed on the given acop display.
    /// </summary>
    /// <param name="Yarray">Is a reference to an array object which will be filled with the vertical (Y-axis) coordinates of the plotted data.</param>
    /// <param name="Xarray">Is a reference to an array object which will be filled with the horizontal (X-axis) coordinates of the plotted data.</param>
    /// <param name="Length">Is the desired length within the array provided which should be filled with plotted data.</param>
    /// <param name="Offset">Is the desired offset within the array provided which should be filled with plotted data.</param>
    /// <param name="hDisplay">Is the display handle of the acop display for which the data are desired (returned via a call to Draw()).</param>
    /// <returns></returns>
    public int GetDrawnData(Object Yarray, Object Xarray, int Length, int Offset, int hDisplay)
    {
      if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
      return histo[hDisplay].getDrawnData(Yarray, Xarray, Length, Offset, hDisplay);
    }
    /// <summary>
    /// Retrieves the data displayed on the given acop display.
    /// </summary>
    /// <param name="Yarray">Is a reference to an array object which will be filled with the vertical (Y-axis) coordinates of the plotted data.</param>
    /// <param name="Xarray">Is a reference to an array object which will be filled with the horizontal (X-axis) coordinates of the plotted data.</param>
    /// <param name="hDisplay">Is the display handle of the acop display for which the data are desired (returned via a call to Draw()).</param>
    /// <param name="xPosition">Is the screen X position for which the displayed data are desired.</param>
    /// <param name="yPosition">Is the screen Y position for which the displayed data are desired.</param>
    /// <returns></returns>
    public int GetDrawnData(Object Yarray, Object Xarray, int hDisplay, double xPosition, double yPosition)
    {
      int dataIndex;
      if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
      dataIndex = histo[hDisplay].getHistoIndex(xPosition, yPosition);
      return histo[hDisplay].getDrawnData(Yarray, Xarray, 1, dataIndex, hDisplay);
    }
    public int GetNumberDrawnData(int hDisplay)
    {
      if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
      return histo[hDisplay].getNumberDrawnData();
    }
    /// <summary>
    /// returns the drawn Y-axis data for the input display
    /// </summary>
    /// <param name="hDisplay">the display id for the targeted curve (-1 => the initially drawn curve)</param>
    /// <returns>the drawn Y-axis data for the input display</returns>
    public double[] GetDrawnYData(int hDisplay)
    {
      if (hDisplay < 0) hDisplay = 0;
      if (hDisplay >= n_display || histo[hDisplay] == null) return null;
      int n = histo[hDisplay].getNumberDrawnPoints();
      double[] y = new double[n];
      int nret = histo[hDisplay].getDrawnData(y, null, n, 0, hDisplay);
      if (nret < n) Array.Resize(ref y, nret);
      return y;
    }
    /// <summary>
    /// returns the drawn X-axis data for the input display
    /// </summary>
    /// <param name="hDisplay">the display id for the targeted curve (-1 => the initially drawn curve)</param>
    /// <returns>the drawn X-axis data for the input display</returns>
    public double[] GetDrawnXData(int hDisplay)
    {
      if (hDisplay < 0) hDisplay = 0;
      if (hDisplay >= n_display || histo[hDisplay] == null) return null;
      int n = histo[hDisplay].getNumberDrawnPoints();
      double[] x = new double[n];
      int nret = histo[hDisplay].getDrawnData(null, x, n, 0, hDisplay);
      if (nret < n) Array.Resize(ref x, nret);
      return x;
    }
    private Boolean NeedsPruning(int hDisplay)
    {
      return histo[hDisplay].getNeedsPruning();
    }
    private void SetNeedsPruning(int hDisplay, Boolean value)
    {
      histo[hDisplay].setNeedsPruning(value);
    }
    private void setlimit()
    {
      isZoomedFlag = false; // new change!
      zoomXmaxFlag = 0;
      if ((zooming & 0x4) != 0) zoomIndex = 0;
      for (int i = 0; i < 3; i++)
        sca[i].setscale();
    }
    // setup HistoRect... ...
    private void scaleframe()
    {
      Rectangle r = this.ClientRectangle;
      fLeft = frameWidth + frameLeftOffset; // init 4 offset
      fRight = frameWidth + frameRightOffset;
      fTop = frameWidth + frameTopOffset;
      fBottom = frameWidth + frameBottomOffset;
      if (fLeft < 0)
        fLeft = 0; // check x
      else if (fLeft >= r.Width) fLeft = r.Width - 1;
      if (fRight < 0)
        fRight = 0;
      else if ((fRight + fLeft) >= r.Width) fRight = r.Width - fLeft - 1;
      if (fTop < 0)
        fTop = 0; // check y
      else if (fTop >= r.Height) fTop = r.Height - 1;
      if (fBottom < 0)
        fBottom = 0;
      else if ((fBottom + fTop) >= r.Height) fBottom = r.Height - fTop - 1;
      // titleRect.setBounds(r.x+fLeft, r.y, r.Width-fLeft-fRight, fTop);
      // titleRect.setBounds(fLeft, 0, r.Width-fLeft-fRight, fTop);
      titleRect = new Rectangle(0, 0, r.Width, fTop);
      // histRect.setBounds(r.x+fLeft, r.y+fTop, r.Width-fLeft-fRight,
      // r.Height-fTop-fBottom);
      // aFrame.histRect.setBounds(fLeft, fTop, r.Width-fLeft-fRight,
      // r.Height-fTop-fBottom);
      aFrame.histRect = new Rectangle(fLeft + fLeftPixel, fTop + fTopPixel, r.Width - fLeft - fRight - fLeftPixel
          - fRightPixel, r.Height - fTop - fBottom - fTopPixel - fBottomPixel);
      aFrame.zoomIcon = new Rectangle(aFrame.histRect.X + aFrame.histRect.Width - aFrame.ZoomExtent,
          aFrame.histRect.Y + 1, aFrame.ZoomExtent - 1, aFrame.ZoomExtent - 1);
      // histRoundRect.setBounds(aFrame.histRect.x - 1,aFrame.histRect.y -
      // 1,aFrame.histRect.Width + 2,aFrame.histRect.Height + 2);
      histRoundRect = new Rectangle(aFrame.histRect.X - fLeftPixel - 1, aFrame.histRect.Y - fTopPixel - 1,
          aFrame.histRect.Width + fLeftPixel + fRightPixel + 2, aFrame.histRect.Height + fTopPixel
              + fBottomPixel + 2);
      // xRect.setBounds(r.x, r.y+r.Height-fBottom, r.Width, fBottom);
      xRect = new Rectangle(0, r.Height - fBottom, r.Width, fBottom);
      setTickRectangle(0);
      // yRect.setBounds(r.x, r.y, fLeft, r.Height);
      yRect = new Rectangle(0, 0, fLeft, r.Height);
      // yAxisRect.setBounds(r.x+r.Width-fRight, r.y, fRight, r.Height);
      yAxisRect = new Rectangle(r.Width - fRight, 0, fRight, r.Height);
      setTickRectangle(1);
      tagRect = new Rectangle(histRoundRect.Location, histRoundRect.Size); // tagging
      HistRectleftReference = aFrame.histRect.X + leftPixel;
      listTextBox.SetBounds(aFrame.histRect.X, aFrame.histRect.Y, aFrame.histRect.Width, aFrame.histRect.Height);
    }

    // setup which rectangle used for ticks
    private void setTickRectangle(int i)
    {
      Rectangle tmpRect;
      if (sca[i].leftBottom) // take lower Rect for x and left Rect for y
      {
        sca[i].ticksRect = i == 0 ? xRect : yRect;
        tmpRect = i == 0 ? titleRect : yAxisRect;
      }
      else
      {
        sca[i].ticksRect = i == 0 ? titleRect : yAxisRect;
        tmpRect = i == 0 ? xRect : yRect;
      }
      if (i == 1) // secondary Y ticks and label area
      {
        sca[2].ticksRect = tmpRect;
        sca[2].labelRect = sca[i].leftBottom != sca[i].leftBottLabel ? sca[i].ticksRect : tmpRect;
        sca[2].leftBottom = sca[i].leftBottom ? false : true;
        sca[2].leftBottLabel = sca[i].leftBottLabel ? false : true;
      }
      if (i == 0)
      {
        sca[i].labelRect = sca[i].leftBottom ? xRect : titleRect; 
      }
      else
      {
        sca[i].labelRect = sca[i].leftBottom == sca[i].leftBottLabel ? sca[i].ticksRect : tmpRect;
      }
    }
    private Boolean drawOneHist(int num)
    {
      if (histo[num].npoints > 10000) return false;
      Graphics a = (Graphics)CreateGraphics();
      if (a == null) return false; // currently not displayable!!
      a.SetClip(histRoundRect);
      a.TranslateTransform(aFrame.histRect.X, aFrame.histRect.Y);
      histo[num].drawhist(a);
      a.TranslateTransform(-aFrame.histRect.X, -aFrame.histRect.Y);
      a.Dispose();
      return true;
    }

    protected internal void prepareDraw()
    {
      double xtemp;
      int i, j, start, ende;
      if (randomData == true && sca[0].usermax > sca[0].usermin && sca[1].usermax > sca[1].usermin)
      {
        if (RandomInitialized == false)
        {
          for (i = 0; i < 512; i++)
            g_rdata[i] = Math.Sin(i * 6.2832 / 512.0);
          RandomInitialized = true;
        }
        xtemp = sca[0].userSize + 1; // one more point for the right edge!
        if (xtemp < 1.0) xtemp = 1.0;
        j = (int)xtemp;
        double[] ppvdata = new double[j];
        for (i = 0; i < j; i++)
          ppvdata[i] = sca[1].usermin + (1 + g_rdata[j >= 512 ? i % 512 : (int)(i * 512 / xtemp) % 512])
              * sca[1].userSize / 2;
        if (histo[0] == null)
        {
          histo[0] = new AcopHisto(this, 0);
        }
        if (histo[0].setHisto(ppvdata, null, null, null, 0, 0, foreColor) == 0)
        {
          if (wrapAround) histo[0].getMaxWindow();
          aFrame.drawFlag = true;
          histo[0].displayON = 1;
          histo[0].displayModeSetting = displayMode;
          histo[0].dismode = globalDisplayMode;
          histo[0].disDots = enableDots;
          histo[0].disBarHisto = enableBarlineHisto;
          histo[0].xext = _XExtent;
          histo[0].yext = _YExtent;
          histo[0].colorfilled = colorFilled;
          histo[0].barlineColorFilled = barlineColorFilled;
          loadXYindex = 0;
          lastDisp = 0;
        }
      }
      if (rescaleFlag == 2)
      {
        setlimit(); // load m_xmin... ...
        sca[0].scaleToGrid();
      }
      if (rescaleFlag > 0)
      {
        for (i = 0; i < 3; i++)
          sca[i].xyscale(rescaleFlag == 2 ? true : false); // set new min max(2007 hwu before was true)
        //      convertBackgroundRegion(false);
      }
      // 2009-5-26
      if (rescaleFlag > 0 || drawTicks) convertBackgroundRegion(false);

      if (histIndex < 0 || histIndex >= n_display)
      {
        start = 0;
        ende = n_display;
      }
      else
      {
        start = histIndex;
        ende = histIndex + 1;
      }
      if (aFrame.drawFlag) for (i = start; i < ende; i++)
        {
          if (histo[i] == null) break;
          if (histo[i].displayON == 0 && i != m_histstart) continue;
          // if ( disp[n]->dismode >= AcopConst.mode_textbox ) continue;
          // scale screen: xleft, xright and dxwidth! getOxleftright(0);
          if (i == m_histstart) aFrame.getOxleftright(histo[i], sca[0]);
          // find wrapindex
          if (wrapAround && rescaleFlag != 0 && sca[0].log == 0) histo[i].setwrapindex();
          histo[i].setExtent();
          if (i == m_histstart)
          {
            if (histo[i].dismode == AcopConst.mode_textbox)
            {
              clearListTextBox();
            }
            else
              listTextBox.Visible = false;
          }
          // map to screen coordinate
          histo[i].mapScreen(-1);
        }
      if (rescaleTextFlag > 0) for (i = 0; i < n_text; i++)
        {
          if (ptext[i] == null) break;
          ptext[i].rescaleText(rescaleTextFlag);
        }
      // if ( aFrame.drawFlag == false )
      // {
      // aFrame.xleft = 0;
      // aFrame.xright = aFrame.histRect.Width;
      // aFrame.dxwidth =aFrame.xright - aFrame.xleft;
      // aFrame.absxleft = aFrame.xleft + aFrame.histRect.x;
      // return;
      // }
      //    if (rescaleFlag > 0 && cursorStay > 0)
      if ((rescaleFlag > 0 || drawTicks) && cursorStay > 0)  // 2009-4-30
      {
        mMovePoint.X = sca[0].getScreenPosition(cursorXposition);
        mMovePoint.Y = sca[1].getScreenPosition(cursorYposition);
      }
      if (sca[1].log != 0)
        yzero = aFrame.histRect.Height;
      else if (sca[1].max >= 0 && sca[1].min <= 0)
        yzero = (int)(aFrame.histRect.Height * (1 + sca[1].min / sca[1].dispSize));
      else
        yzero = (int)((sca[1].max > 0 && sca[1].min > 0) ? aFrame.histRect.Height : 0);
      if (repainHisto == true && drawTicks == false && rescaleFlag == 0 && rescaleTextFlag == 0
          && start + 1 == ende)
      {
        if (drawOneHist(start) == false) repaintHisto();
      }
      else if (rescaleFlag > 0 || drawTicks)
        Invalidate();
      // else if ( start == ende - 1 && repainHisto == false )
      // histo[start].drawhist(null);
      else
        repaintHisto();
      rescaleTextFlag = 0;
      rescaleFlag = 0;
      drawTicks = false;
      histIndex = -1;
      repainHisto = false;
    }
    /// <summary>
    /// Converts to the Acop PlotMode enumeration from an integer
    /// </summary>
    /// <param name="m">the integer representation of a display plot mode</param>
    /// <returns>the Acop PlotMode enumeration</returns>
    public static AcopPlotMode GetPlotMode(int m)
    {
      if (Enum.IsDefined(typeof(AcopPlotMode), m)) return (AcopPlotMode)m;
      return AcopPlotMode.polyline;
    }
    AcopPlotMode getPlotMode()
    {
      return GetPlotMode(displayMode);
    }
    void setPlotMode(AcopPlotMode m)
    {
      setDisplayMode((int)m);
    }
    private void setGlobalDisplayMode()
    {
      globalDisplayMode = displayMode;
      if (displayMode > AcopConst.mode_textbox)
      {
        if (displayMode == AcopConst.mode_polyline_dots) globalDisplayMode = AcopConst.mode_polyline;
        if (displayMode == AcopConst.mode_barline_dots) globalDisplayMode = AcopConst.mode_barline;
        if (displayMode == AcopConst.mode_histogram_dots) globalDisplayMode = AcopConst.mode_histogram;
        if (displayMode == AcopConst.mode_histogram_rastoring_dots) globalDisplayMode = AcopConst.mode_histogram_rastoring;
        if (displayMode != AcopConst.mode_barline_histo) enableDots = 1;
        else enableDots = 0;
        if (displayMode == AcopConst.mode_polyline_cross)
        {
          globalDisplayMode = AcopConst.mode_polyline;
          enableDots = 2;
        }
        if (displayMode == AcopConst.mode_barline_histo || displayMode == AcopConst.mode_barline_histo_dots)
        {
          globalDisplayMode = AcopConst.mode_barline;
          enableBarlineHisto = 1;
        }
        else if (displayMode == AcopConst.mode_annotation)
        {
          globalDisplayMode = AcopConst.mode_annotation;
          enableDots = 0;
        }
        else if (displayMode == AcopConst.mode_status)
        {
          globalDisplayMode = AcopConst.mode_status;
          enableDots = 0;
        }

        else enableBarlineHisto = 0;
      }
      else
      {
        enableDots = 0;
        enableBarlineHisto = 0;
      }
    }

    public int LockCursorMarker(Boolean Enable)
    {
      return LockCursorMarker(Enable, false, 0, false, 0);
    }
    public int LockCursorMarker(Boolean Enable, double Xposition, double Yposition)
    {
      return LockCursorMarker(Enable, true, Xposition, true, Yposition);
    }
    public int LockCursorMarker(Boolean Enable, Boolean xInput, double Xposition, Boolean yInput,
        double Yposition)
    {
      paintCursorMarker = true;
      if (cursorLockedToCurrentScreenPosition) return cursorStay;
      int on;
      if (m_cursorMarkerMode == 0) return -1; // has to turn mode on first!
      on = Enable ? 1 : 0;
      cursorStay = on;
      if (cursorStay > 0)
      {
        if (xInput)
          mMovePoint.X = sca[0].getScreenPosition(Xposition);
        else
          Xposition = sca[0].getUserPosition(mMovePoint.X);
        if (yInput)
          mMovePoint.Y = sca[1].getScreenPosition(Yposition);
        else
          Yposition = sca[1].getUserPosition(mMovePoint.Y);
        cursorXposition = Xposition;
        cursorYposition = Yposition;
      }
      if (aFrame.drawFlag) repaintHisto();
      return on;
    }
    private void drawCursorMarker(Graphics g2d, Point point)
    {
      int modeTmp;
      if (!paintCursorMarker) return;
      if (g2d == null)  // come from mouse routine, do not do XOR drawing, set flag and return!
      {
        paintCursorMarker = false; // so that we get into the 'if' branch below ...
        return;
      }
      //    RectangleF Cliprect = null;
      RectangleF Cliprect;
      int initFlag = g2d == null ? 0 : 1;
      if (g2d == null) // called from mouse move, first map and clip, then remove
      // previous line first
      {
        g2d = (Graphics)CreateGraphics();
        Cliprect = g2d.ClipBounds;
        if (Cliprect != null)
        {
          if (Cliprect.IntersectsWith(histRoundRect) == false) return;
        }
      }
      Cliprect = g2d.ClipBounds;
      //2014-11   g2d.setXORMode(rev_cursorMarkerColor);
      //    g2d.setXORMode(m_cursorMarkerColor);
      // g2d.setColor(m_cursorMarkerColor);
      //    g2d.setStroke(cursorMarkerStroke);
      if (initFlag == 0) // called from mouse move, first map and clip, then
      // remove previous line first
      {
        g2d.SetClip(histRoundRect);// clipRect(histRoundRect.X, histRoundRect.Y, histRoundRect.Width, histRoundRect.Height);
        // g2d.translate(aFrame.histRect.x, aFrame.histRect.y);
        if (cursorMarkerFlag == 2) // already onscreen, repaint it without the cursor line
        {
          modeTmp = m_cursorMarkerMode;
          m_cursorMarkerMode = 0;
          //        paintImmediately(histRoundRect);
          m_cursorMarkerMode = modeTmp;
        }
        else if (cursorMarkerFlag != 0) // if already onscreen, remove previous line first
        {
          if ((m_cursorMarkerMode & 0x2) != 0)
            g2d.DrawLine(cursorMarkerStroke, cursorwy, cursorwx - cursoriy, cursorwy, cursorwx + cursoriy);
          if ((m_cursorMarkerMode & 0x1) != 0)
            g2d.DrawLine(cursorMarkerStroke, cursorwy - cursorix, cursorwx, cursorwy + cursorix, cursorwx);
        }
      }
      // calculate new position
      cursorwx = point.Y;
      cursorwy = point.X;
      if (initFlag != 0)
      {
        cursorwx -= aFrame.histRect.Y;  // 2009-1 bug fix
        cursorwy -= aFrame.histRect.X;
      }
      if ((m_cursorMarkerMode & 0x1) != 0)
      {
        if (initFlag != 0)
        {
          if (cursorXPercent < 0)
          {
            if (m_cursorMarkerXExtent < 0)
              cursorXPercent = 1;
            else
              cursorXPercent = ((sca[0].log != 0) ? Math.Log(m_cursorMarkerXExtent) / Math.Log(10)
                  : m_cursorMarkerXExtent)
                  / (sca[0].tick_max - sca[0].tick_min) / 2;
          }
          cursorix = (int)(aFrame.histRect.Width * cursorXPercent);
        }
        g2d.DrawLine(cursorMarkerStroke, cursorwy - cursorix, cursorwx, cursorwy + cursorix, cursorwx);
      }
      if ((m_cursorMarkerMode & 0x2) != 0)
      {
        if (initFlag != 0)
        {
          if (cursorYPercent < 0)
          {
            if (m_cursorMarkerYExtent < 0)
              cursorYPercent = 1;
            else
              cursorYPercent = ((sca[1].log != 0) ? Math.Log(m_cursorMarkerYExtent) / Math.Log(10)
                  : m_cursorMarkerYExtent)
                  / sca[1].dispSize / 2;
          }
          cursoriy = (int)(aFrame.histRect.Height * cursorYPercent);
        }
        g2d.DrawLine(cursorMarkerStroke, cursorwy, cursorwx - cursoriy, cursorwy, cursorwx + cursoriy);
      }
      //    g2d.setPaintMode();
      if (initFlag == 0)
      {
        // g2d.translate(-aFrame.histRect.x, -aFrame.histRect.y);
        g2d.SetClip(Cliprect);
        g2d.Dispose();
      }
      if (initFlag != 0)
      {
        cursorwx += aFrame.histRect.Y;  // 2009-1 bug fix
        cursorwy += aFrame.histRect.X;
      }
      cursorMarkerFlag = initFlag == 1 ? 2 : 1; // cursor is on screen!
    }
    private void setZoomingWindow(int bufferedZoomFlag)
    {
      aFrame.ZoomExtent = bufferedZoomFlag != 0 ? 20 : 36;
      // zoom icon indicator
      aFrame.zoomIcon = new Rectangle(aFrame.histRect.X + aFrame.histRect.Width - aFrame.ZoomExtent,
          aFrame.histRect.Y + 1, aFrame.ZoomExtent - 1, aFrame.ZoomExtent - 1);
    }
    public String GetPrintedText(double[] leftBottom, double[] size, double[] position, int hText)
    {
      if (hText < 0 || hText >= n_text || ptext[hText] == null) return "Input Error!";
      return ptext[hText].getPrintedText(leftBottom, size, position);
    }
    /// <summary>
    /// Gives the zoomed stat of the acop chart
    /// </summary>
    /// <returns>True if the acop chart is in a zoomed state.  Otherwise False.</returns>
    public Boolean IsZoomed()
    {
      return this.isZoomedFlag;
    }
    /// <summary>
    /// Gives the left offset of histogram displays in the acop chart 
    /// </summary>
    /// <returns>The left offset of histogram displays in the acop chart.</returns>
    public int GetHistogramOffsetLeft()
    {
      return aFrame.xleft;
    }
    /// <summary>
    /// Gives the right offset of histogram displays in the acop chart 
    /// </summary>
    /// <returns>The right offset of histogram displays in the acop chart.</returns>
    public int GetHistogramOffsetRight()
    {
      return aFrame.histRect.Width - aFrame.xright;
    }
    /// <summary>
    /// Gives the left hand side chart axis setting.
    /// </summary>
    /// <returns>The left hand side chart axis setting.</returns>
    public double GetScaleLeft()
    {
      return sca[0].getMin();
    }
    /// <summary>
    /// Gives the left hand side chart axis setting.
    /// </summary>
    /// <returns>The left hand side chart axis setting.</returns>
    public double GetScaleRight()
    {
      return sca[0].getMax();
    }
    /// <summary>
    /// Gives the top chart axis setting.
    /// </summary>
    /// <returns>The top chart axis setting.</returns>
    public double GetScaleTop()
    {
      return sca[1].getMax();
    }
    /// <summary>
    /// Gives the bottom chart axis setting.
    /// </summary>
    /// <returns>The bottom chart axis setting.</returns>
    public double GetScaleBottom()
    {
      return sca[1].getMin();
    }
    private int loadAxis(int index, Boolean AxisOn, Object PositionArray, int ArraySize, Color[] ColorArray,
        int[] StyleArray, int[] WidthArray)
    {
      int ret;
      ret = axis[index].axisON != AxisOn ? 1 : 0;
      axis[index].axisON = AxisOn;
      if (ArraySize < 1 && ArraySize != -1) return -1; // wrong input
      if (ArraySize != -1)
        ret += axis[index].loadData(ArraySize, PositionArray, ColorArray, StyleArray, WidthArray);
      if (ret != 0 && aFrame.drawFlag) repaintHisto();
      return 0;
    }
    public int xAxis(Boolean AxisOn)
    {
      return loadAxis(0, AxisOn, null, -1, null, null, null);
    }
    public int yAxis(Boolean AxisOn)
    {
      return loadAxis(1, AxisOn, null, -1, null, null, null);
    }
    public int xAxis(Boolean AxisOn, Object PositionArray, int ArraySize, Color[] ColorArray, int[] StyleArray,
        int[] WidthArray)
    {
      return loadAxis(0, AxisOn, PositionArray, ArraySize, ColorArray, StyleArray, WidthArray);
    }
    public int yAxis(Boolean AxisOn, Object PositionArray, int ArraySize, Color[] ColorArray, int[] StyleArray,
        int[] WidthArray)
    {
      return loadAxis(1, AxisOn, PositionArray, ArraySize, ColorArray, StyleArray, WidthArray);
    }
    /// <summary>
    /// Refreshes the given display screen with the given data.
    /// </summary>
    /// <param name="Yarray">Is the vertical (Y) axis data to use in the new screen.</param>
    /// <param name="hDisplay">Is the handle to the screen to update (given by the initial 'draw' call).</param>
    /// <param name="Length">Is the number of points from the Yarray data to use in the screen udpate.</param>
    /// <param name="Offset">Is the offset in the drawn data buffer where the given Yarray data should be applied.</param>
    /// <param name="Xarray">Is a corresponding horizontal (X) axis update array.</param>
    /// <returns>0 upon success.</returns>
    public int RefreshScreen(Object Yarray, int hDisplay, int Length, int Offset, Object Xarray)
    {
      if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
      return histo[hDisplay].updateScreen(false, Yarray, Length, Offset, Xarray);
    }
    /// <summary>
    /// Refreshes the given display screen with the given data.
    /// </summary>
    /// <param name="Yarray">Is the vertical (Y) axis data to use in the new screen.</param>
    /// <param name="hDisplay">Is the handle to the screen to update (given by the initial 'draw' call).</param>
    /// <param name="Xarray">Is a corresponding horizontal (X) axis update array.</param>
    /// <returns>0 upon success.</returns>
    public int RefreshScreen(Object Yarray, int hDisplay, Object Xarray)
    {
      if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
      return histo[hDisplay].updateScreen(false, Yarray, -1, -1, Xarray);
    }
    /// <summary>
    /// Refreshes the given display screen with the given data.
    /// </summary>
    /// <param name="Yarray">Is the vertical (Y) axis data to use in the new screen.</param>
    /// <param name="hDisplay">Is the handle to the screen to update (given by the initial 'draw' call).</param>
    /// <returns>0 upon success.</returns>
    public int RefreshScreen(Object Yarray, int hDisplay)
    {
      if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
      return histo[hDisplay].updateScreen(false, Yarray, -1, -1, null);
    }
    /// <summary>
    /// Appends the given data to the designated display screen.
    /// </summary>
    /// <param name="Yarray">Is the vertical (Y) axis data to use in the new screen.</param>
    /// <param name="hDisplay">Is the handle to the screen to update (given by the initial 'draw' call).</param>
    /// <param name="Length">Is the number of points from the Yarray data to use in the screen udpate.</param>
    /// <param name="Offset">Is the offset in the drawn data buffer where the given Yarray data should be applied.</param>
    /// <param name="Xarray">Is a corresponding horizontal (X) axis update array.</param>
    /// <returns>0 upon success.</returns>
    public int AppendScreen(Object Yarray, int hDisplay, int Length, int Offset, Object Xarray)
    {
      if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
      return histo[hDisplay].updateScreen(true, Yarray, Length, Offset, Xarray);
    }
    /// <summary>
    /// Appends the given data to the designated display screen.
    /// </summary>
    /// <param name="Yarray">Is the vertical (Y) axis data to use in the new screen.</param>
    /// <param name="hDisplay">Is the handle to the screen to update (given by the initial 'draw' call).</param>
    /// <param name="Xarray">Is a corresponding horizontal (X) axis update array.</param>
    /// <returns>0 upon success.</returns>
    public int AppendScreen(Object Yarray, int hDisplay, Object Xarray)
    {
      if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
      return histo[hDisplay].updateScreen(true, Yarray, -1, -1, Xarray);
    }
    //public int AppendScreen(Object Yarray, Object Xarray, int hDisplay)
    //{
    //  if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
    //  return histo[hDisplay].updateScreen(true, Yarray, -1, -1, Xarray);
    //}

    /// <summary>
    /// Appends the given data to the designated display screen.
    /// </summary>
    /// <param name="Yarray">Is the vertical (Y) axis data to use in the new screen.</param>
    /// <param name="hDisplay">Is the handle to the screen to update (given by the initial 'draw' call).</param>
    /// <returns>0 upon success.</returns>
    public int AppendScreen(Object Yarray, int hDisplay)
    {
      if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null) return -1;
      return histo[hDisplay].updateScreen(true, Yarray, -1, -1, null);
    }
    /// <summary>
    /// Draws a curve on the acop chart using the data provided as the vertical coordinates (uniform horizontal coordinates from Xmin to Xmax) and the chart display settings
    /// </summary>
    /// <param name="ydata">
    /// is an array object containing the data points to be plotted on the vertical
    /// axis. If ydata is not an array of a number type (e.g. a string array) then the draw method
    /// will only succeed if the acop chart display mode is set to 'textbox'.  
    /// The horizontal (x) axis coordinates will be an array of monotonically 
    /// increasing integers.
    /// </param>
    /// <returns>
    /// a positive display handle which refers to the plot shown on the chart.
    /// This handle can be used in other acop API calls to for example refresh or clear
    /// a particular plot.  Upon error, and negative value is returned.
    /// </returns>
    public int Draw(Object ydata)
    {
      return Draw(ydata, null, null, null, 0, 0);
    }
    /// <summary>
    /// Draws a curve on the acop chart using the data provided as the vertical and horizontal coordinates and the chart display settings
    /// </summary>
    /// <param name="ydata">
    /// is an array object containing the data points to be plotted on the vertical
    /// axis. If ydata is not an array of a number type (e.g. a string array) then the draw method
    /// while only succeed if the acop chart display mode is set to 'textbox'.  
    /// </param>
    /// <param name="xdata">
    /// is an array object containing the data points to be plotted on the horizontal
    /// axis. If xdata is not an array of a number type (e.g. a string array) then the draw method
    /// will not succeed.
    /// </param>
    /// <param name="bindToSecondaryAxis">
    /// If true, applies the y-axis data to the 'secondary' Y-axis
    /// </param>
    /// <returns>
    /// a positive display handle which refers to the plot shown on the chart.
    /// This handle can be used in other acop API calls to for example refresh or clear
    /// a particular plot.  Upon error, and negative value is returned.
    /// </returns>
    public int Draw(Object ydata, Object xdata, Boolean bindToSecondaryAxis)
    {
      return Draw(ydata, xdata, null, null, 0, 0, bindToSecondaryAxis);
    }
    /// <summary>
    /// Draws a curve on the acop chart using the data provided as the vertical and horizontal coordinates and the chart display settings
    /// </summary>
    /// <param name="ydata">
    /// is an array object containing the data points to be plotted on the vertical
    /// axis. If ydata is not an array of a number type (e.g. a string array) then the draw method
    /// while only succeed if the acop chart display mode is set to 'textbox'.  
    /// </param>
    /// <param name="xdata">
    /// is an array object containing the data points to be plotted on the horizontal
    /// axis. If xdata is not an array of a number type (e.g. a string array) then the draw method
    /// will not succeed.
    /// </param>
    /// <returns>
    /// a positive display handle which refers to the plot shown on the chart.
    /// This handle can be used in other acop API calls to for example refresh or clear
    /// a particular plot.  Upon error, and negative value is returned.
    /// </returns>
    public int Draw(Object ydata, Object xdata)
    {
      return Draw(ydata, xdata, null, null, 0, 0);
    }
    /// <summary>
    /// Draws a curve on the acop chart using the data provided as the vertical and horizontal coordinates and the chart display settings
    /// </summary>
    /// <param name="ydata">
    /// is an array object containing the data points to be plotted on the vertical
    /// axis. If ydata is not an array of a number type (e.g. a string array) then the draw method
    /// while only succeed if the acop chart display mode is set to 'textbox'.  
    /// </param>
    /// <param name="xdata">
    /// is an array object containing the data points to be plotted on the horizontal
    /// axis. If xdata is not an array of a number type (e.g. a string array) then the draw method
    /// will not succeed.
    /// </param>
    /// <param name="disable">
    /// is a boolean array object designating specific elements to be shown in a disabled color.
    /// </param>
    /// <returns>
    /// a positive display handle which refers to the plot shown on the chart.
    /// This handle can be used in other acop API calls to for example refresh or clear
    /// a particular plot.  Upon error, and negative value is returned.
    /// </returns>
    public int Draw(Object ydata, Object xdata, Object disable)
    {
      return Draw(ydata, xdata, disable, null, 0, 0);
    }
    /// <summary>
    /// Draws a curve on the acop chart using the data provided as the vertical and horizontal coordinates and the chart display settings
    /// </summary>
    /// <param name="ydata">
    /// is an array object containing the data points to be plotted on the vertical
    /// axis. If ydata is not an array of a number type (e.g. a string array) then the draw method
    /// while only succeed if the acop chart display mode is set to 'textbox'.  
    /// </param>
    /// <param name="xdata">
    /// is an array object containing the data points to be plotted on the horizontal
    /// axis. If xdata is not an array of a number type (e.g. a string array) then the draw method
    /// will not succeed.
    /// </param>
    /// <param name="disable">
    /// is a boolean array object designating specific elements to be shown in a disabled color.
    /// </param>
    /// <param name="xlabel">
    /// is a string array object containing x-axis labels for each x-axis entry.  The length of this array should
    /// match that of the ydata and xdata arrays.
    /// </param>
    /// <returns>
    /// a positive display handle which refers to the plot shown on the chart.
    /// This handle can be used in other acop API calls to for example refresh or clear
    /// a particular plot.  Upon error, and negative value is returned.
    /// </returns>
    public int Draw(Object ydata, Object xdata, Object disable, String[] xlabel)
    {
      return Draw(ydata, xdata, disable, xlabel, 0, 0);
    }
    /// <summary>
    /// Draws a curve on the acop chart using the data provided as the vertical and horizontal coordinates and the chart display settings
    /// </summary>
    /// <param name="ydata">
    /// is an array object containing the data points to be plotted on the vertical
    /// axis. If ydata is not an array of a number type (e.g. a string array) then the draw method
    /// while only succeed if the acop chart display mode is set to 'textbox'.  
    /// </param>
    /// <param name="xdata">
    /// is an array object containing the data points to be plotted on the horizontal
    /// axis. If xdata is not an array of a number type (e.g. a string array) then the draw method
    /// will not succeed.
    /// </param>
    /// <param name="disable">
    /// is a boolean array object designating specific elements to be shown in a disabled color.
    /// </param>
    /// <param name="xlabel">
    /// is a string array object containing x-axis labels for each x-axis entry.  The length of this array should
    /// match that of the ydata and xdata arrays.
    /// </param>
    /// <param name="ArraySize">is the size of the 'internal' drawn buffer array used to reflect the ydata displayed.
    /// If not specified, this will be of the same length as the ydata array provided.</param>
    /// <param>
    /// <param name="MaxNumber">Is the maximum size of the 'internal' drawn buffer array.</param>
    /// a positive display handle which refers to the plot shown on the chart.
    /// This handle can be used in other acop API calls to for example refresh or clear
    /// a particular plot. 
    /// </param>
    public int Draw(Object ydata, Object xdata, Object disable, String[] xlabel, int ArraySize, int MaxNumber)
    {
      return Draw(ydata, xdata, disable, xlabel, ArraySize, MaxNumber, false);
    }
    /// <summary>
    /// Draws a curve on the acop chart using the data provided as the vertical and horizontal coordinates and the chart display settings
    /// </summary>
    /// <param name="ydata">
    /// is an array object containing the data points to be plotted on the vertical
    /// axis. If ydata is not an array of a number type (e.g. a string array) then the draw method
    /// while only succeed if the acop chart display mode is set to 'textbox'.  
    /// </param>
    /// <param name="xdata">
    /// is an array object containing the data points to be plotted on the horizontal
    /// axis. If xdata is not an array of a number type (e.g. a string array) then the draw method
    /// will not succeed.
    /// </param>
    /// <param name="ArraySize">is the size of the 'internal' drawn buffer array used to reflect the ydata displayed.
    /// If not specified, this will be of the same length as the ydata array provided.</param>
    /// <param>
    /// <param name="MaxNumber">Is the maximum size of the 'internal' drawn buffer array.</param>
    /// </param>
    /// <returns>
    /// a positive display handle which refers to the plot shown on the chart.
    /// This handle can be used in other acop API calls to for example refresh or clear
    /// a particular plot. 
    /// </returns>
    public int Draw(Object ydata, Object xdata, int ArraySize, int MaxNumber)
    {
      return Draw(ydata, xdata, null, null, ArraySize, MaxNumber, false);
    }
    /// <summary>
    /// Draws a curve on the acop chart using the data provided as the vertical and horizontal coordinates and the chart display settings
    /// </summary>
    /// <param name="ydata">
    /// is an array object containing the data points to be plotted on the vertical
    /// axis. If ydata is not an array of a number type (e.g. a string array) then the draw method
    /// while only succeed if the acop chart display mode is set to 'textbox'.  
    /// </param>
    /// <param name="xdata">
    /// is an array object containing the data points to be plotted on the horizontal
    /// axis. If xdata is not an array of a number type (e.g. a string array) then the draw method
    /// will not succeed.
    /// </param>
    /// <param>
    /// <param name="MaxNumber">Is the maximum size of the 'internal' drawn buffer array.
    /// </param>
    /// </param>
    /// <returns>
    /// a positive display handle which refers to the plot shown on the chart.
    /// This handle can be used in other acop API calls to for example refresh or clear
    /// a particular plot. 
    /// </returns>
    public int Draw(Object ydata, Object xdata, int MaxNumber)
    {
      return Draw(ydata, xdata, null, null, AcopHisto.getArrayLength(ydata), MaxNumber, false);
    }
    /// <summary>
    /// Draws a curve on the acop chart using the data provided as the vertical and horizontal coordinates and the chart display settings
    /// </summary>
    /// <param name="ydata">
    /// is an array object containing the data points to be plotted on the vertical
    /// axis. If ydata is not an array of a number type (e.g. a string array) then the draw method
    /// while only succeed if the acop chart display mode is set to 'textbox'.  
    /// </param>
    /// <param name="xdata">
    /// is an array object containing the data points to be plotted on the horizontal
    /// axis. If xdata is not an array of a number type (e.g. a string array) then the draw method
    /// will not succeed.
    /// </param>
    /// <param name="ArraySize">is the size of the 'internal' drawn buffer array used to reflect the ydata displayed.
    /// If not specified, this will be of the same length as the ydata array provided.
    /// </param>
    /// <param name="MaxNumber">Is the maximum size of the 'internal' drawn buffer array.</param>
    /// <param name="bindToSecondaryAxis">
    /// If true, applies the y-axis data to the 'secondary' Y-axis
    /// </param>
    /// <returns>
    /// a positive display handle which refers to the plot shown on the chart.
    /// This handle can be used in other acop API calls to for example refresh or clear
    /// a particular plot.  Upon error, and negative value is returned.
    /// </returns>
    public int Draw(Object ydata, Object xdata, int ArraySize, int MaxNumber, Boolean bindToSecondaryAxis)
    {
      return Draw(ydata, xdata, null, null, ArraySize, MaxNumber, bindToSecondaryAxis);
    }
    /// <summary>
    /// Draws a curve on the acop chart using the data provided as the vertical and horizontal coordinates and the chart display settings
    /// </summary>
    /// <param name="ydata">
    /// is an array object containing the data points to be plotted on the vertical
    /// axis. If ydata is not an array of a number type (e.g. a string array) then the draw method
    /// while only succeed if the acop chart display mode is set to 'textbox'.  
    /// </param>
    /// <param name="xlabel">
    /// is a string array object containing x-axis labels for each x-axis entry.  The length of this array should
    /// match that of the ydata and xdata arrays.
    /// </param>
    /// <returns>
    /// a positive display handle which refers to the plot shown on the chart.
    /// This handle can be used in other acop API calls to for example refresh or clear
    /// a particular plot.  Upon error, and negative value is returned.
    /// </returns>
    public int Draw(Object ydata, String[] xlabel)
    {
      return Draw(ydata, null, null, xlabel, 0, 0, false);
    }

    /// <summary>
    /// Draws a curve on the acop chart using the data provided as the vertical and horizontal coordinates and the chart display settings
    /// </summary>
    /// <param name="ydata">
    /// is an array object containing the data points to be plotted on the vertical
    /// axis. If ydata is not an array of a number type (e.g. a string array) then the draw method
    /// while only succeed if the acop chart display mode is set to 'textbox'.  
    /// </param>
    /// <param name="xdata">
    /// is an array object containing the data points to be plotted on the horizontal
    /// axis. If xdata is not an array of a number type (e.g. a string array) then the draw method
    /// will not succeed.
    /// </param>
    /// <param name="xlabel">
    /// is a string array object containing x-axis labels for each x-axis entry.  The length of this array should
    /// match that of the ydata and xdata arrays.
    /// </param>
    /// <returns>
    /// a positive display handle which refers to the plot shown on the chart.
    /// This handle can be used in other acop API calls to for example refresh or clear
    /// a particular plot.  Upon error, and negative value is returned.
    /// </returns>
    public int Draw(Object ydata, Object xdata, String[] xlabel)
    {
      return Draw(ydata, xdata, null, xlabel, 0, 0, false);
    }

    /// <summary>
    /// Draws a curve on the acop chart using the data provided as the vertical and horizontal coordinates and the chart display settings
    /// </summary>
    /// <param name="ydata">
    /// is an array object containing the data points to be plotted on the vertical
    /// axis. If ydata is not an array of a number type (e.g. a string array) then the draw method
    /// while only succeed if the acop chart display mode is set to 'textbox'.  
    /// </param>
    /// <param name="xdata">
    /// is an array object containing the data points to be plotted on the horizontal
    /// axis. If xdata is not an array of a number type (e.g. a string array) then the draw method
    /// will not succeed.
    /// </param>
    /// <param name="disable">
    /// is a boolean array object designating specific elements to be shown in a disabled color.
    /// </param>
    /// <param name="xlabel">
    /// is a string array object containing x-axis labels for each x-axis entry.  The length of this array should
    /// match that of the ydata and xdata arrays.
    /// </param>
    /// <param name="ArraySize">is the size of the 'internal' drawn buffer array used to reflect the ydata displayed.
    /// If not specified, this will be of the same length as the ydata array provided.
    /// </param>
    /// <param name="MaxNumber">Is the maximum size of the 'internal' drawn buffer array.</param>
    /// <param name="bindToSecondaryAxis">
    /// If true, applies the y-axis data to the 'secondary' Y-axis
    /// </param>
    /// <returns>
    /// a positive display handle which refers to the plot shown on the chart.
    /// This handle can be used in other acop API calls to for example refresh or clear
    /// a particular plot.  Upon error, and negative value is returned.
    /// </returns>
    public int Draw(Object ydata, Object xdata, Object disable, String[] xlabel, int ArraySize,
        int MaxNumber, Boolean bindToSecondaryAxis)
    {
      int i, tmp;
      if (m_lock == n_display) return -1; // no free slot to draw
      // this slot should not be overwrite
      if (aFrame.drawFlag == true && histo[loadXYindex] != null && histo[loadXYindex].displayON == 1)
      {
        // find next free slot
        for (i = loadXYindex + 1, tmp = 0; tmp < n_display; i++, tmp++)
        {
          if (i == n_display)
          {
            i = 0;
            m_filled = 1;
          }
          if (histo[i] == null || (histo[i].lockFlag == 0 && histo[i].displayON == 0))
            break;
          else if (reuseScreen && histo[i].lockFlag == 0) break;
        }
        if (tmp < n_display)
          loadXYindex = i;
        else
          return -2; // no free slot to draw
      }
      if (histo[loadXYindex] == null)
      {
        histo[loadXYindex] = new AcopHisto(this, loadXYindex);
        if (loadXYindex == 0 && aFrame.drawFlag == false && textFlag == true)
          rescaleTextFlag = AcopConst.NEW_PRINT_WINDOW;
        if (loadXYindex == 0 && textFlag == false) // first time;
        {
        }
      }
      if (histo[loadXYindex].setHisto(ydata, xdata, disable, xlabel, ArraySize, MaxNumber, foreColor) != 0)
        return -3;
      // if ( aFrame.drawFlag == false && textFlag == false ) drawTicks = true;
      if (aFrame.drawFlag == false)
        drawTicks = true;
      else
        drawTicks = false;
      // if ( histo[0].displayON != 0 ) repainHisto = true; // it was On
      if (aFrame.drawFlag == true && histo[loadXYindex].displayON == 0) repainHisto = true; // it
      // was
      // On
      aFrame.drawFlag = true;
      histo[loadXYindex].displayON = 1;
      histo[loadXYindex].displayModeSetting = displayMode;
      histo[loadXYindex].dismode = globalDisplayMode;
      histo[loadXYindex].disDots = enableDots;
      histo[loadXYindex].disBarHisto = enableBarlineHisto;
      histo[loadXYindex].xext = _XExtent;
      histo[loadXYindex].yext = _YExtent;
      histo[loadXYindex].colorfilled = colorFilled;
      histo[loadXYindex].barlineColorFilled = barlineColorFilled;
      if (m_keep == 0)
      {
        if (m_filled != 0 && m_lock == 0) // no refrence!
        {
          m_histstart = loadXYindex + 1;
          if (m_histstart >= n_display) m_histstart = 0;
        }
      }
      else
      // move start pointer, change lasthist to keeppen
      {
        if (m_numberkeep == m_keep)
        {
          histo[m_keepstart].displayON = 0; // turn off one
          if (m_lock == 0) for (i = ++m_keepstart; ; i++) // find histstart
            {
              if (i >= n_display) i = 0;
              if (i == loadXYindex) break;
              if (histo[i].displayON != 0)
              {
                m_histstart = i;
                break;
              }
            }
        }
      }
      if (wrapAround)
        histo[loadXYindex].getMaxWindow();
      else
        histo[loadXYindex].wrapindex = 0;
      histIndex = loadXYindex;
      lastDisp = loadXYindex;

      if (loadXYindex < 0 || loadXYindex >= n_display) return -1;
      if (histo[loadXYindex] != null && histo[loadXYindex].displayON != 0 && histo[loadXYindex].lockFlag == 0)
      {
        histo[loadXYindex].bindSecondaryY = bindToSecondaryAxis;
      }

      prepareDraw();
      m_keep = 0;
      return (loadXYindex);
    }
    /// <summary>
    /// Clears all (unlocked) displays in the chart.
    /// </summary>
    public void ClearScreen()
    {
      ClearScreen(-1, 0);
    }
    /// <summary>
    /// Clears the selected display in the chart (unless locked).
    /// </summary>
    /// <param name="hDisplay">The display handle of the curve to clear (returned from Draw() method). '-1' clears all curves.</param>
    public void ClearScreen(int hDisplay)
    {
      ClearScreen(hDisplay, 0);
    }
    private delegate void clearTheScreenDelegate(Boolean isUsingTextBox);
    private void clearTheScreen(Boolean isUsingTextBox)
    {
      if (isUsingTextBox)
      {
        if (listTextBox.InvokeRequired)
        {
          Invoke(new clearTheScreenDelegate(clearTheScreen), new object[] { isUsingTextBox });
          return;
        }
        listTextBox.Items.Clear();
      }
      if (drawTicks || histo[m_histstart].dismode >= AcopConst.mode_textbox || (aFrame.drawFlag == false && textFlag == false))
        this.Invalidate();
      else
        repaintHisto();
    }
    private delegate void clearListTextBoxDelegate();
    private void clearListTextBox()
    {
      if (listTextBox.InvokeRequired)
      {
        Invoke(new clearListTextBoxDelegate(clearListTextBox));
        return;
      }
      listTextBox.Items.Clear();
    }
    public delegate void addItemsToListBoxDelegate(string[] lines);
    public void addItemsToListBox(string[] lines)
    {
      if (listTextBox.InvokeRequired)
      {
        Invoke(new addItemsToListBoxDelegate(addItemsToListBox), new object[] { lines });
        return;
      }
      if (lines == null) return;
      foreach (string ln in lines)
      {
        listTextBox.Items.Add(ln.Trim());
      }
    }
    /// <summary>
    /// Clears the selected display in the chart (unless locked).
    /// </summary>
    /// <param name="hDisplay">The display handle of the curve to clear (returned from Draw() method). '-1' clears all curves.</param>
    /// <param name="KeepDepth">The number of cleared curves to keep and display in the 'keep color'.</param>
    public void ClearScreen(int hDisplay, int KeepDepth)
    {
      int i, j, num, tmp;
      Boolean textbox = false;
      if (aFrame.drawFlag == false) return;
      m_keep = KeepDepth; // number of kepted histogram
      if (m_keep < 0 || m_keep >= n_display) m_keep = 0;
      num = hDisplay; // histo number to be turned off
      if (num < 0 || num >= n_display) num = -1;
      // RedrawTextHist = 1;
      if (m_keep == 0 && num < 0) // turn all off, if not locked
      {
        if (m_lock == 0) // no locked histo, then reset
        {
          if (textFlag == false) drawTicks = true;
          aFrame.drawFlag = false;
          m_filled = 0;
          m_histstart = 0;
          loadXYindex = 0; // reset index, make displayflag to FALSE
          // if ( modeChange == TRUE )
          // {
          // drawTicks = TRUE;
          // modeChange = FALSE;
          // }
        }
        for (i = 0; i < n_display; i++)
        {
          if (histo[i] == null) continue;
          if (histo[i].displayON != 0 && histo[i].dismode == AcopConst.mode_textbox) textbox = true;
          if (histo[i] != null && histo[i].lockFlag == 0) histo[i].displayON = 0;
        }
      }
      else
      {
        if (num >= 0) // clear hist num
        {
          if (histo[num] != null && histo[num].displayON != 0 && histo[num].lockFlag == 0)
          {
            if (histo[num].dismode == AcopConst.mode_textbox) textbox = true;
            histo[num].displayON = 0;
            if (num == m_histstart) // change m_histstart to next visible histo
            {
              for (i = 0, j = m_histstart; i < n_display; i++, j++) // is all
              // histo off?
              {
                if (j >= n_display) j = 0;
                if (histo[j] != null && histo[j].displayON != 0)
                {
                  m_histstart = num;
                  break;
                }
              }
            }
          }
          else if (m_keep == 0) return; // already off -> nothing changed
        }
        if (m_keep > n_display - m_lock) m_keep = n_display - m_lock;
        if (m_keep != 0) // keep # of background histograms
        { // find keep start
          for (m_numberkeep = tmp = j = 0, i = loadXYindex + 1; j < m_keep;)
          {
            if (--i < 0) i += n_display;
            if (histo[i] == null || histo[i].lockFlag == 0) j++; // keep empty or
            // notlocked
            if (histo[i] != null && histo[i].displayON != 0)
            {
              tmp++; // # of displayON
              if (histo[i].lockFlag == 0)
              {
                // turn keep to keep-pen, -color....
                histo[i].keephisto();
                m_numberkeep++;
                m_keepstart = i; // keephisto start #
                // hide tagging display for this keeped histogram!
                if (histo[i].dismode == AcopConst.mode_histogram
                    || histo[i].dismode == AcopConst.mode_histogram_rastoring
                    || histo[i].dismode == AcopConst.mode_dots || histo[i].dismode == AcopConst.mode_rectangle
                    || histo[i].dismode == AcopConst.mode_circle) histo[i].tagHist = 0;
              }
            }
          }
          if (m_lock == 0 && m_numberkeep != 0) m_histstart = m_keepstart; // first
          // visible
          // histo
          aFrame.drawFlag = (m_lock != 0 || tmp != 0) ? true : false;
          if (textFlag == false && aFrame.drawFlag == false) drawTicks = true;
          for (j = loadXYindex + 1; ; j++) // turn rest off
          {
            if (j >= n_display) j = 0;
            if (j == i) break;
            if (histo[j] != null && histo[j].lockFlag == 0) histo[j].displayON = 0;
          }
        }
        else
        { // is all histo off?
          for (i = 0, j = m_histstart; i < n_display; i++, j++)
          {
            if (j >= n_display) j = 0;
            if (histo[j] != null && histo[j].displayON != 0) break;
          }
          if (i == n_display)
          {
            aFrame.drawFlag = false;
            if (textFlag == false) drawTicks = true;
          }
        }
      }
      clearTheScreen(textbox);
      //if (textbox == true) listTextBox.Items.Clear(); //textArea.Text = "";  //2012-1-9 clear textbox
      //if (drawTicks || histo[m_histstart].dismode >= AcopConst.mode_textbox || (aFrame.drawFlag == false && textFlag == false))
      //  this.Invalidate();
      //else
      //  repaintHisto();
    }
    /// <summary>
    /// Recalls a previously cleared display.
    /// </summary>
    /// <param name="hDisplay">The display handle of the display to recall.</param>
    public void RecallScreen(int hDisplay)
    {
      int num;
      num = hDisplay; // number to be turned on
      if (num < 0 || num >= n_display) return;
      if (histo[num] == null) return;
      if (aFrame.drawFlag == false && m_lock == 0) m_histstart = num;
      if (histo[num].displayON == 0)
      {
        // RedrawTextHist = 1;
        histo[num].displayON = 1;
        aFrame.drawFlag = true;
        if (histo[num].dismode == AcopConst.mode_histogram
            || histo[num].dismode == AcopConst.mode_histogram_rastoring
            || histo[num].dismode == AcopConst.mode_dots || histo[num].dismode == AcopConst.mode_rectangle
            || histo[num].dismode == AcopConst.mode_circle)
        { // bring to top histogram!
          histo[num].tagHist = 1;
          lastTagHisto = num;
        }
        lastDisp = num;
        // find wrapindex
        if (wrapAround && sca[0].log == 0) histo[num].setwrapindex();
        // prepareDraw(FALSE,num,FALSE, 0);
        if (drawTicks)
        {
          this.Invalidate();
          drawTicks = false;
        }
        else
          if (drawOneHist(num) == false) repaintHisto();
      }
    }
    /// <summary>
    /// allowable lock screen modes
    /// </summary>
    public enum LockScreenMode
    {
      probe = -1,
      unlocked = 0,
      locked = 1
    }
    private LockScreenMode getLockScreenMode(int m)
    {
      if (Enum.IsDefined(typeof(LockScreenMode), m)) return (LockScreenMode)m;
      return LockScreenMode.probe;
    }
    /// <summary>
    /// Locks the given display screen according to the mode specified.
    /// </summary>
    /// <param name="mode">Is the desired lock mode. 'probe' is only reads and returns the current lock mode.  
    /// Otherwise 'unlocked' and 'locked' will set the screen to the desired lock mode if not already in that mode.
    /// </param>
    /// <param name="hDisplay">Is the desired screen to apply the lock settings. A '-1' will apply the setting to all
    /// display screens.
    /// </param>
    /// <returns>The current lock state as an integer (0: unlocked, 1: locked, -1: not applicable).</returns>
    public long LockScreen(LockScreenMode mode, int hDisplay)
    {
      int num, ende, locke, i;
      int LockOn = (int)mode;
      locke = LockOn; // lock all the histo you see! (<0, 0, >0)
      num = hDisplay; // or unlock them as user requested
      if (num < 0 || num >= n_display)
      {
        num = 0;
        ende = n_display - 1;
      }
      else
      {
        ende = num;
      }
      if (locke < 0) // return current lock flag (ON or OFF) -> read only
      {
        if (num != ende)
          return m_lock; // number of locked histos
        else
          return histo[num] != null ? histo[num].lockFlag : -1;
      }
      else if (locke > 0 && aFrame.drawFlag == false) return -1; // nothing to lock
      for (i = num; num <= ende; num++)
      {
        if (histo[num] == null) continue;
        if (locke == 0) // unlock
        {
          if (histo[num].lockFlag == 1)
          {
            histo[num].lockFlag = 0;
            m_lock--;
          }
        }
        else if (histo[num].displayON != 0) // lock it if on the screen
        {
          if (histo[num].lockFlag == 0)
          {
            histo[num].lockFlag = 1;
            // first locked as histstart
            if (m_lock++ == 0 && num != m_histstart) m_histstart = num;
          }
        }
      }
      return (i != ende) ? m_lock : (histo[num] == null ? 0 : histo[ende].lockFlag);
    }
    /// <summary>
    /// Prints the given text at the last text position.
    /// </summary>
    /// <param name="Text">The desired text to display on the screen.</param>
    /// <returns>A handle to the printed text (can be used in ClearText(), RecallText(), or RefreshText())</returns>
    public int PrintText(String Text)
    {
      return callPrintText(Text, 0, 0, false);
    }
    /// <summary>
    /// Prints the given text at the given screen coordinates.
    /// </summary>
    /// <param name="Text">The desired text to display on the screen.</param>
    /// <param name="Xposition">The horizontal (X) axis position used to place the text.</param>
    /// <param name="Yposition">The vertical (Y) axis position used to place the text.</param>
    /// <returns>A handle to the printed text (can be used in ClearText(), RecallText(), or RefreshText())</returns>
    public int PrintText(String Text, double Xposition, double Yposition)
    {
      return callPrintText(Text, Xposition, Yposition, true);
    }
    protected int callPrintText(String Text, double Xposition, double Yposition, Boolean positionFlag)
    {
      int resca, i, firstDraw;
      if (Text.IndexOf((char)13) == 0) return -1; // linefeed in the begining
      // the current visible slot should not be overwrite
      if (textFlag == true && ptext[loadTextIndex] != null && ptext[loadTextIndex].textON == true)
      {
        // find next free slot
        for (i = loadTextIndex + 1, resca = 0; resca < n_text; i++, resca++)
        {
          if (i == n_text) i = 0;
          if (ptext[i] == null)
          {
            ptext[i] = new AcopText(this);
            break;
          }
          else if (ptext[i].textON == false)
            break;
          else if (reuseText) break;
        }
        if (resca < n_text)
        {
          loadTextIndex = i;
        }
        else
        {
          return -1; // no free slot to prntText
        }
      }
      firstDraw = 0;
      if (ptext[loadTextIndex] == null)
      {
        ptext[loadTextIndex] = new AcopText(this);
        if (loadTextIndex == 0 && (aFrame.drawFlag == false || firstText == true))
        {
          firstDraw = 1;
          setlimit(); // load m_xmin... ...
          sca[0].scaleToGrid();
          for (i = 0; i < 3; i++)
            sca[i].xyscale(true); // set new min max
          scaleframe();
          aFrame.xleft = 0;
          aFrame.xright = aFrame.histRect.Width;
          aFrame.dxwidth = aFrame.xright - aFrame.xleft;
          aFrame.absxleft = aFrame.xleft + aFrame.histRect.X;
        }
      }
      if (positionFlag == false) // load last positions
      {
        Xposition = lastTextx;
        Yposition = lastTexty;
      }
      if (ptext[loadTextIndex].printText(Text, Xposition, Yposition, foreColor, this.Font) == 0)
      {
        // i = loadTextIndex;
        // if ( ++loadTextIndex == n_text ) loadTextIndex = 0;
        // return i;
        // store last positions
        lastTextx = ptext[loadTextIndex].lastTextx;
        lastTexty = ptext[loadTextIndex].lastTexty;
        if (firstDraw != 0) Invalidate();
        // resca = loadTextIndex;
        // if ( ++loadTextIndex == n_text ) loadTextIndex = 0;
        // if ( disp[0] == 0 && scalecall < 2 ) {
        // InvalidateControl(NULL); // draw ticks and grid...if no histo at all
        // scalecall = 2;
        // }
        return (loadTextIndex);
      }
      firstText = false;
      return -1;
    }
    /// <summary>
    /// Clears the acop chart of all displayed text.
    /// </summary>
    public void ClearText()
    {
      ClearText(-1);
    }
    /// <summary>
    /// Clears the text shown in the given text handle location.
    /// </summary>
    /// <param name="hText">A handle to the text to be displayed (given by initial call to PrintText()).</param>
    public void ClearText(int hText)
    {
      int start, ende, i, cnt;
      start = hText;
      if (start < 0 || start >= n_text)
      {
        start = 0;
        ende = n_text - 1;
      }
      else
        ende = start;
      for (cnt = 0, i = 0; i < n_text; i++)
      {
        if (ptext[i] == null) continue;
        if (ptext[i].textON == false) continue;
        if (i >= start && i <= ende)
        {
          ptext[i].textON = false;
          if (ptext[i].outside == false)
            this.Invalidate();
        }
        else
          cnt++;
      }
      textFlag = cnt != 0 ? true : false;
      if (textFlag == false)
      {
        // scalecall = 0;
        if (aFrame.drawFlag == false)
        {
          this.Invalidate();
          drawTicks = true;
        }
      }
      if (start != ende) loadTextIndex = 0;
    }
    /// <summary>
    /// Recalls the previously cleared text in the given text handle location.
    /// </summary>
    /// <param name="hText">A handle to the text to be displayed (given by initial call to PrintText()).</param>
    public void RecallText(int hText)
    {
      int start;
      start = hText;
      if (start < 0 || start >= n_text) return;
      if (ptext[start] == null || ptext[start].textON == true) return;
      // if ( ptext[start].moveable && ptext[start].rescaled ) rescaleText(start,
      // ptext[start]->moveable, FALSE, ptext[start]->scalable);
      textFlag = true;
      ptext[start].textON = true;
      ptext[start].rescaleText(0); // use intern flag
      if (ptext[start].outside == true) return;
      if (drawTicks)
      {
        this.Invalidate();
        drawTicks = false;
      }
      else
        ptext[start].printUserText(null);
    }
    /// <summary>
    /// Refreshes the current text in the given text handle location.
    /// </summary>
    /// <param name="Text">Is the new text to be used in the text location.</param>
    /// <param name="hText">A handle to the text to be displayed (given by initial call to PrintText()).</param>
    public int RefreshText(String Text, int hText)
    {
      if (hText < 0 || hText >= n_text || ptext[hText] == null) return -1;
      ptext[hText].refreshText(Text);
      return hText;
    }
    public void SetAveragingDepth(int averagingDepth)
    {
      if (this.averagingDepth == averagingDepth) return;
      if (averagingDepth < 2 || averagingDepth > AcopConst.N_DEF_DISPLAY) averagingDepth = 0;
      averagingIndex = 0;
      averagingLength = 0;
      NumberAveragingData = 0;
      int oldValue = this.averagingDepth;
      this.averagingDepth = averagingDepth;
      OnPropertyChanged("averagingDepth");
    }
    public int GetAveragingDepth()
    {
      return this.averagingDepth;
    }
    public void SetAveragingMode(int averagingMode)
    {
      if (this.averagingMode == averagingMode || averagingMode < 0 || averagingMode > 1) return;
      int oldValue = this.averagingMode;
      this.averagingMode = averagingMode;
      OnPropertyChanged("averagingMode");
    }
    public int GetAveragingMode()
    {
      return this.averagingMode;
    }
    private void setCaption(String caption)
    {
      captionChanged = true;
      String oldValue = this.caption;
      this.caption = caption;
      this.Invalidate(titleRect);
      OnPropertyChanged("caption");
    }
    private String getCaption()
    {
      return this.caption;
    }
    public enum AcopCaptionPosition
    {
      left = -1,
      center = 1,
      right = 2
    }
    AcopCaptionPosition getAcopCaptionPosition(int m)
    {
      if (Enum.IsDefined(typeof(AcopCaptionPosition), m)) return (AcopCaptionPosition)m;
      return AcopCaptionPosition.center;
    }
    AcopCaptionPosition getAcopCaptionPosition()
    {
      return getAcopCaptionPosition(captionPosition);
    }
    private void setAcopCaptionPosition(AcopCaptionPosition m)
    {
      setCaptionLocation((int)m);
    }
    private void setCaptionLocation(int captionPosition)
    {
      if (this.captionPosition == captionPosition) return;
      int oldValue = this.captionPosition;
      this.captionPosition = captionPosition;
      this.Invalidate(titleRect);
      OnPropertyChanged("captionPosition");
    }
    private int getCaptionLocation()
    {
      return this.captionPosition;
    }
    private void setDisplayMode(int displayMode)
    // throws PropertyVetoException
    {
      if (this.displayMode == displayMode) return;
      /*
       * Integer oldValue = new Integer(this.displayMode); Integer newValue = new
       * Integer(displayMode); veto.fireVetoableChange("displayMode" ,oldValue,
       * newValue); this.displayMode = displayMode;
       * changes.OnPropertyChanged("displayMode" ,oldValue, newValue); if (
       * displayMode < AcopConst.mode_polyline ) displayMode =
       * AcopConst.mode_polyline; if ( displayMode > AcopConst.mode_textbox )
       * displayMode = AcopConst.mode_textbox;
       */
      if (displayMode < AcopConst.mode_polyline || displayMode > AcopConst.mode_status) return;
      int oldValue = this.displayMode;
      this.displayMode = displayMode;
      setGlobalDisplayMode();
      if (randomData == true)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("displayMode");
    }
    private int getDisplayMode()
    {
      return this.displayMode;
    }
    private void setDrawWidth(int drawWidth)
    {
      if (this.drawWidth == drawWidth) return;
      if (drawWidth < 1) drawWidth = 1;
      int oldValue = this.drawWidth;
      this.drawWidth = drawWidth;
      if (randomData == true) repaintHisto();
      // prepareDraw(2, -1); // rescale and reset limit
      OnPropertyChanged("drawWidth");
    }
    private int getDrawWidth()
    {
      return this.drawWidth;
    }
    private void checkRange(int flag, double value)
    {
      if (flag == 1)  // xMin input
      {
        if (sca[0].usermax <= value + AcopConst.zero_check)
        {
          if (Math.Abs(value) < AcopConst.zero_check)
            sca[0].usermax = value + 10;
          else
            sca[0].usermax = value + 0.5 * Math.Abs(value);
        }
        sca[0].setUserscale(value, sca[0].usermax);
      }
      else if (flag == 2)  // xMax input
      {
        if (value <= sca[0].usermin + AcopConst.zero_check)
        {
          if (Math.Abs(value) < AcopConst.zero_check)
            sca[0].usermin = value - 10;
          else
            sca[0].usermin = value - 0.5 * Math.Abs(value);
        }
        sca[0].setUserscale(sca[0].usermin, value);
      }
      else if (flag == 3)
      {
        if (sca[1].usermax <= value + AcopConst.zero_check)
        {
          if (Math.Abs(value) < AcopConst.zero_check)
            sca[1].usermax = value + 10;
          else
            sca[1].usermax = value + 0.5 * Math.Abs(value);
        }
        sca[1].setUserscale(value, sca[1].usermax);
      }
      else if (flag == 4)
      {
        if (value <= sca[1].usermin + AcopConst.zero_check)
        {
          if (Math.Abs(value) < AcopConst.zero_check)
            sca[1].usermin = value - 10;
          else
            sca[1].usermin = value - 0.5 * Math.Abs(value);
        }
        sca[1].setUserscale(sca[1].usermin, value);
      }
    }
    /// <summary>
    /// Sets the minimum and maximum horizontal (X-axis) display values.
    /// </summary>
    /// <param name="xMin">The desired minimum display value.</param>
    /// <param name="xMax">The desired maximum display value.</param>
    public void SetXRange(double xMin, double xMax)
    {
      if (Math.Abs(sca[0].usermin - xMin) < AcopConst.zero_check && Math.Abs(sca[0].usermax - xMax) < AcopConst.zero_check) return;
      double oldValue = sca[0].usermin;
      double oldValueMax = sca[0].usermax;
      drawTicks = true;
      checkRange(1, xMin);
      checkRange(2, xMax);
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw();
      if (Math.Abs(sca[0].usermin - xMin) < AcopConst.zero_check) OnPropertyChanged("xMin");
      if (Math.Abs(sca[0].usermax - xMax) < AcopConst.zero_check) OnPropertyChanged("xMax");
    }
    /// <summary>
    /// Sets the minimum and maximum vertical (Y-axis) display values.
    /// </summary>
    /// <param name="yMin">The desired minimum display value.</param>
    /// <param name="yMax">The desired maximum display value.</param>
    public void SetYRange(double yMin, double yMax)
    {
      if (Math.Abs(sca[1].usermin - yMin) < AcopConst.zero_check && Math.Abs(sca[1].usermax - yMax) < AcopConst.zero_check) return;
      double oldValue = sca[1].usermin;
      double oldValueMax = sca[1].usermax;
      drawTicks = true;
      checkRange(3, yMin);
      checkRange(4, yMax);
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw();
      if (Math.Abs(sca[1].usermin - yMin) < AcopConst.zero_check) OnPropertyChanged("yMin");
      if (Math.Abs(sca[1].usermax - yMax) < AcopConst.zero_check) OnPropertyChanged("yMax");
    }
    /// <summary>
    /// Sets the minimum and maximum horizontal (X-axis) and vertical (Y-axis) display values.
    /// </summary>
    /// <param name="xMin">The desired minimum horizontal display value.</param>
    /// <param name="xMax">The desired maximum horizontal display value.</param>
    /// <param name="yMin">The desired minimum vertical display value.</param>
    /// <param name="yMax">The desired maximum vertical display value.</param>
    public void SetXYRange(double xMin, double xMax, double yMin, double yMax)
    {
      if (Math.Abs(sca[0].usermin - xMin) < AcopConst.zero_check && Math.Abs(sca[0].usermax - xMax) < AcopConst.zero_check &&
        Math.Abs(sca[1].usermin - yMin) < AcopConst.zero_check && Math.Abs(sca[1].usermax - yMax) < AcopConst.zero_check) return;
      double oldValue = sca[0].usermin;
      double oldValueMax = sca[0].usermax;
      double oldValueY = sca[1].usermin;
      double oldValueYMax = sca[1].usermax;
      drawTicks = true;
      checkRange(1, xMin);
      checkRange(2, xMax);
      checkRange(3, yMin);
      checkRange(4, yMax);
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw();
      if (Math.Abs(sca[0].usermin - xMin) < AcopConst.zero_check) OnPropertyChanged("xMin");
      if (Math.Abs(sca[0].usermax - xMax) < AcopConst.zero_check) OnPropertyChanged("xMax");
      if (Math.Abs(sca[1].usermin - yMin) < AcopConst.zero_check) OnPropertyChanged("yMin");
      if (Math.Abs(sca[1].usermax - yMax) < AcopConst.zero_check) OnPropertyChanged("yMax");
    }
    private Boolean xScaleSetByUser = false;
    private void setXMin(double xMin)
    {
      if (Math.Abs(sca[0].usermin - xMin) < AcopConst.zero_check) return;
      if (xMin != 0) xScaleSetByUser = true;
      double oldValue = sca[0].usermin;
      drawTicks = true;
      if (sca[0].usermax <= xMin + AcopConst.zero_check)
      {
        if (Math.Abs(xMin) < AcopConst.zero_check)
          sca[0].usermax = xMin + 10;
        else
          sca[0].usermax = xMin + 0.5 * Math.Abs(xMin);
      }

      sca[0].setUserscale(xMin, sca[0].usermax);
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw();
      OnPropertyChanged("xMin");
      // prepareDraw(TRUE, -1, TRUE, 0);
    }
    private double getXMin()
    {
      return sca[0].usermin;
    }
    private void setXMax(double xMax)
    {
      if (Math.Abs(sca[0].usermax - xMax) < AcopConst.zero_check) return;
      if (xMax != 100) xScaleSetByUser = true;
      double oldValue = sca[0].usermax;
      drawTicks = true;
      if (xMax <= sca[0].usermin + AcopConst.zero_check)
      {
        if (Math.Abs(xMax) < AcopConst.zero_check)
          sca[0].usermin = xMax - 10;
        else
          sca[0].usermin = xMax - 0.5 * Math.Abs(xMax);
      }

      sca[0].setUserscale(sca[0].usermin, xMax);
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw();
      OnPropertyChanged("xMax");
    }
    private double getXMax()
    {
      return sca[0].usermax;
    }
    private Boolean yScaleSetByUser = false;
    private void setYMin(double yMin)
    {
      if (Math.Abs(sca[1].usermin - yMin) < AcopConst.zero_check) return;
      if (yMin != -100) yScaleSetByUser = true;
      double oldValue = sca[1].usermin;
      if (m_marker == 2) setmarkerflag(2); // store origin value
      drawTicks = true;
      if (sca[1].usermax <= yMin + AcopConst.zero_check)
      {
        if (Math.Abs(yMin) < AcopConst.zero_check)
          sca[1].usermax = yMin + 10;
        else
          sca[1].usermax = yMin + 0.5 * Math.Abs(yMin);
      }

      sca[1].setUserscale(yMin, sca[1].usermax);
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw();
      OnPropertyChanged("yMin");
    }
    private double getYMin()
    {
      return sca[1].usermin;
    }
    private void setYMax(double yMax)
    {
      if (Math.Abs(sca[1].usermax - yMax) < AcopConst.zero_check) return;
      if (yMax != 100) yScaleSetByUser = true;
      double oldValue = sca[1].usermax;
      if (m_marker == 2) setmarkerflag(2); // store origin value
      drawTicks = true;
      if (yMax <= sca[1].usermin + AcopConst.zero_check)
      {
        if (Math.Abs(yMax) < AcopConst.zero_check)
          sca[1].usermin = yMax - 10;
        else
          sca[1].usermin = yMax - 0.5 * Math.Abs(yMax);
      }

      sca[1].setUserscale(sca[1].usermin, yMax);
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw();
      OnPropertyChanged("yMax");
    }
    private double getYMax()
    {
      return sca[1].usermax;
    }
    private void setSecondaryYMin(double SecondaryYMin)
    {
      if (Math.Abs(sca[2].usermin - SecondaryYMin) < AcopConst.zero_check) return;
      double oldValue = sca[2].usermin;
      if (sca[2].usermax <= SecondaryYMin + AcopConst.zero_check)
      {
        if (Math.Abs(SecondaryYMin) < AcopConst.zero_check)
          sca[2].usermax = SecondaryYMin + 10;
        else
          sca[2].usermax = SecondaryYMin + 0.5 * Math.Abs(SecondaryYMin);
      }

      sca[2].setUserscale(SecondaryYMin, sca[2].usermax);
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw();
      OnPropertyChanged("secondaryYMin");
    }
    private double getSecondaryYMin()
    {
      return sca[2].usermin;
    }
    private void setSecondaryYMax(double setSecondaryYMax)
    {
      if (Math.Abs(sca[2].usermax - setSecondaryYMax) < AcopConst.zero_check) return;
      double oldValue = sca[2].usermax;
      if (setSecondaryYMax <= sca[2].usermin + AcopConst.zero_check)
      {
        if (Math.Abs(setSecondaryYMax) < AcopConst.zero_check)
          sca[2].usermin = setSecondaryYMax - 10;
        else
          sca[2].usermin = setSecondaryYMax - 0.5 * Math.Abs(setSecondaryYMax);
      }

      sca[2].setUserscale(sca[2].usermin, setSecondaryYMax);
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw();
      OnPropertyChanged("secondaryYMax");
    }
    private double getSecondaryYMax()
    {
      return sca[2].usermax;
    }
    private void scaleFrameDraw()
    {
      if (sca[0] == null) return;  // acopp not loaded yet
      scaleframe();
      //    rescaleFlag = 1; //2005-Feb
      drawTicks = true;     // 2009-4 fix problem of ""The AcopChart is not repainted or validated when its size changes."
      rescaleTextFlag = AcopConst.NEW_TEXT_WINDOW;
      if (aFrame.drawFlag)
        prepareDraw();
      else
        changeScaleWidth = 0;
    }
    private void setFrameWidth(int frameWidth)
    {
      if (this.frameWidth == frameWidth) return;
      int oldValue = this.frameWidth;
      this.frameWidth = frameWidth;
      scaleFrameDraw();
      OnPropertyChanged("frameWidth");
    }
    private int getFrameWidth()
    {
      return this.frameWidth;
    }
    private void setFrameLeftOffset(int frameLeftOffset)
    {
      if (this.frameLeftOffset == frameLeftOffset) return;
      int oldValue = this.frameLeftOffset;
      this.frameLeftOffset = frameLeftOffset;
      scaleFrameDraw();
      OnPropertyChanged("frameLeftOffset");
    }
    private int getFrameLeftOffset()
    {
      return this.frameLeftOffset;
    }
    private void setFrameRightOffset(int frameRightOffset)
    {
      if (this.frameRightOffset == frameRightOffset) return;
      int oldValue = this.frameRightOffset;
      this.frameRightOffset = frameRightOffset;
      scaleFrameDraw();
      OnPropertyChanged("frameRightOffset");
    }
    private int getFrameRightOffset()
    {
      return this.frameRightOffset;
    }
    private void setFrameTopOffset(int frameTopOffset)
    {
      if (this.frameTopOffset == frameTopOffset) return;
      int oldValue = this.frameTopOffset;
      this.frameTopOffset = frameTopOffset;
      scaleFrameDraw();
      OnPropertyChanged("frameTopOffset");
    }
    private int getFrameTopOffset()
    {
      return this.frameTopOffset;
    }
    private void setFrameBottomOffset(int frameBottomOffset)
    {
      if (this.frameBottomOffset == frameBottomOffset) return;
      int oldValue = this.frameBottomOffset;
      this.frameBottomOffset = frameBottomOffset;
      scaleFrameDraw();
      OnPropertyChanged("frameBottmOffset");
    }
    private int getFrameBottomOffset()
    {
      return this.frameBottomOffset;
    }
    private void setFrameForeColor(Color frameForeColor)
    {
      if (aFrame.frameForeColor != null && aFrame.frameForeColor.Equals(frameForeColor)) return;
      Color oldValue = aFrame.frameForeColor;
      aFrame.frameForeColor = frameForeColor;
      aFrame.framBrush = new SolidBrush(aFrame.frameForeColor);
      stroke = new Pen(aFrame.frameForeColor, 1.0f);
      this.Invalidate();
      OnPropertyChanged("frameForColor");
    }
    private Color getFrameForeColor()
    {
      return aFrame.frameForeColor;
    }
    private void setXTickLabelColor(Color xTickLabelColor)
    {
      if (sca[0].tickLabelForeColor != null && sca[0].tickLabelForeColor.Equals(xTickLabelColor)) return;
      Color oldValue = sca[0].tickLabelForeColor;
      sca[0].tickLabelForeColor = xTickLabelColor;
      sca[0].tickLabelBrush = new SolidBrush(sca[0].tickLabelForeColor);
      this.Invalidate(sca[0].ticksRect);
      if (sca[0].leftBottom != sca[0].leftBottLabel)
        this.Invalidate(sca[0].labelRect);
      OnPropertyChanged("xTickLabelColor");
    }
    private Color getXTickLabelColor()
    {
      return sca[0].tickLabelForeColor;
    }
    private void setYTickLabelColor(Color yTickLabelColor)
    {
      if (sca[1].tickLabelForeColor != null && sca[1].tickLabelForeColor.Equals(yTickLabelColor)) return;
      Color oldValue = sca[1].tickLabelForeColor;
      sca[1].tickLabelForeColor = yTickLabelColor;
      sca[1].tickLabelBrush = new SolidBrush(sca[1].tickLabelForeColor);
      this.Invalidate(sca[1].ticksRect);
      if (sca[1].leftBottom != sca[1].leftBottLabel)
        this.Invalidate(sca[1].labelRect);
      OnPropertyChanged("yTickLabelColor");
    }
    private Color getYTickLabelColor()
    {
      return sca[1].tickLabelForeColor;
    }
    private void setSecondaryYTickLabelColor(Color secondaryYTickLabelColor)
    {
      if (sca[2].tickLabelForeColor != null && sca[2].tickLabelForeColor.Equals(secondaryYTickLabelColor)) return;
      Color oldValue = sca[2].tickLabelForeColor;
      sca[2].tickLabelForeColor = secondaryYTickLabelColor;
      sca[2].tickLabelBrush = new SolidBrush(sca[2].tickLabelForeColor);
      OnPropertyChanged("secondaryYTickLabelColor");
      if (sca[2].OnFlag == false) return;
      this.Invalidate(sca[2].ticksRect);
      if (sca[2].leftBottom != sca[2].leftBottLabel)
        this.Invalidate(sca[2].labelRect);
    }
    private Color getSecondaryYTickLabelColor()
    {
      return sca[2].tickLabelForeColor;
    }
    private void setSecondaryYAxisOn(Boolean secondaryYAxisOn)
    {
      if (sca[2].OnFlag == secondaryYAxisOn) return;
      sca[2].OnFlag = secondaryYAxisOn;
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      if (aFrame.drawFlag == false) return;
      prepareDraw(); // rescale and reset limit
      OnPropertyChanged("secondaryYAxisOn");
    }
    private Boolean isSecondaryYAxisOn()
    {
      return sca[2].OnFlag;
    }
    private void setSecondaryYLogOn(Boolean secondaryYLogOn)
    {
      int temp = secondaryYLogOn ? 1 : 0;
      if (temp == sca[2].log) return;
      int oldValue = sca[2].log;
      sca[2].log = temp;
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      if (aFrame.drawFlag == false) return;
      prepareDraw(); // rescale and reset limit
      OnPropertyChanged("secondaryYLogOn");
    }
    private Boolean isSecondaryYLogOn()
    {
      return sca[2].log != 0 ? true : false;
    }
    private void setFrameFontSize(float frameFontSize)
    {
      if (Math.Abs(aFrame.frameFont.Size - frameFontSize) < 0.01) return;
      Font tmpFont = new Font(aFrame.frameFont.Name, frameFontSize, aFrame.frameFont.Style, aFrame.frameFont.Unit);
      setFrameFont(tmpFont);
    }
    private float getFrameFontSize()
    {
      return aFrame.frameFont.SizeInPoints;
    }
    private void setFrameFont(Font frameFont)
    {
      if (aFrame.frameFont != null && aFrame.frameFont.Equals(frameFont)) return;
      Font oldValue = aFrame.frameFont;
      aFrame.frameFont = frameFont;
      this.Invalidate();
      OnPropertyChanged("frameFont");
    }
    private Font getFrameFont()
    {
      return aFrame.frameFont;
    }
    AcopDrawStyle getAcopDrawStyle(int m)
    {
      if (Enum.IsDefined(typeof(AcopDrawStyle), m)) return (AcopDrawStyle)m;
      return AcopDrawStyle.PS_SOLID;
    }
    AcopDrawStyle getAcopDrawStyle()
    {
      return getAcopDrawStyle(drawStyle);
    }
    private void setAcopDrawStyle(AcopDrawStyle m)
    {
      setDrawStyle((int)m);
    }
    AcopDrawStyle getAcopKeepStyle()
    {
      return getAcopDrawStyle(keepStyle);
    }
    private void setAcopKeepStyle(AcopDrawStyle m)
    {
      setKeepStyle((int)m);
    }
    AcopDrawStyle getAcopGridStyle()
    {
      return getAcopDrawStyle(getGridStyle());
    }
    private void setAcopGridStyle(AcopDrawStyle m)
    {
      setGridStyle((int)m);
    }
    AcopDrawStyle getAcopLeadingEdgeStyle()
    {
      return getAcopDrawStyle(_LeadingEdgeStyle);
    }
    private void setAcopLeadingEdgeStyle(AcopDrawStyle m)
    {
      setLeadingEdgeStyle((int)m);
    }
    AcopDrawStyle getAcopMarkerStyle()
    {
      return getAcopDrawStyle(m_markerStyle);
    }
    private void setAcopMarkerStyle(AcopDrawStyle m)
    {
      setMarkerStyle((int)m);
    }
    AcopDrawStyle getAcopCursorMarkerStyle()
    {
      return getAcopDrawStyle(m_cursorMarkerStyle);
    }
    private void setAcopCursorMarkerStyle(AcopDrawStyle m)
    {
      setCursorMarkerStyle((int)m);
    }
    private void setDrawStyle(int drawStyle)
    // throws PropertyVetoException
    {
      if (this.drawStyle != drawStyle)
      {
        /*
         * Integer oldValue = new Integer(this.drawStyle); Integer newValue = new
         * Integer(drawStyle); veto.fireVetoableChange("drawStyle" ,oldValue,
         * newValue); this.drawStyle = drawStyle;
         * changes.OnPropertyChanged("drawStyle" ,oldValue, newValue);
         */
        if (drawStyle < AcopConst.PS_SOLID || drawStyle > AcopConst.PS_DASH_DOT_DOT) return;
        int oldValue = this.drawStyle;
        this.drawStyle = drawStyle;
        if (randomData == true)
        {
          rescaleFlag = 2;
          prepareDraw(); // rescale and reset limit
        }
        OnPropertyChanged("drawStyle");
      }
    }
    private int getDrawStyle()
    {
      return this.drawStyle;
    }
    public enum AcopFitStyle
    {
      NONE = 0x0,
      FFT_SPECTRUM = 0x1,
      FFT_PHASE = 0x2,
      FFT_SPECTRUM_PHASE = 0x3,
      FFT_REAL_IMAGINARY = 0x4,
      FFT_REAL = 0x5,
      FFT_IMAGINARY = 0x6,
      FFT_INVERSE = 0x7,
      DIFFERTIAL_STATISTICS = 0x8,
      INTEGRAL_STATISTICS = 0x9,
      LINE_FIT = 0xa,
      EXPONENTIAL_FIT = 0xb,
      GAUSSIAN_FIT = 0xc,
      PARABOLIC_FIT = 0xd,
      CUBIC_FIT = 0xe,
      QUARTIC_FIT = 0xf
    }
    private AcopFitStyle getAcopFitStyle(int m)
    {
      if (Enum.IsDefined(typeof(AcopFitStyle), m)) return (AcopFitStyle)m;
      return AcopFitStyle.NONE;
    }
    private AcopFitStyle getAcopFitStyle()
    {
      return getAcopFitStyle(FFT);
    }
    private void setAcopFitStyle(AcopFitStyle m)
    {
      setFFT((int)m);
    }
    private void setFFT(int fFT)
    {
      //    if (fFT < 0 || fFT > AcopConst.FFT_RI_INVERSE) fFT = 0;
      if (fFT < 0 || fFT > AcopConst.FFT_POLYNORM_QUARTIC_FIT) fFT = 0;
      if (this.FFT == fFT) return;
      int oldValue = this.FFT;
      this.FFT = fFT;
      if (randomData == true)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("fFT");
    }
    private int getFFT()
    {
      return this.FFT;
    }
    public enum AcopGraphStyle
    {
      LIN_LIN = 0,
      LIN_LOG = 1,
      LOG_LIN = 2,
      LOG_LOG = 3,
      TIME_LIN = 4,
      TIME_LOG
    }
    AcopGraphStyle getAcopGraphStyle(int m)
    {
      if (Enum.IsDefined(typeof(AcopGraphStyle), m)) return (AcopGraphStyle)m;
      return AcopGraphStyle.LIN_LIN;
    }
    AcopGraphStyle getAcopGraphStyle()
    {
      return getAcopGraphStyle(graphStyle);
    }
    private void setAcopGraphStyle(AcopGraphStyle m)
    {
      setGraphStyle((int)m);
    }
    private void setGraphStyle(int graphStyle)
    {
      int changeYlog = 0;
      if (this.graphStyle == graphStyle) return;
      int oldValue = this.graphStyle;
      if (graphStyle < 0 || graphStyle > 5) graphStyle = 0;
      switch (graphStyle)
      {
        default:
        case 0: // lin-lin
          if (sca[1].log != 0) changeYlog = 1;
          sca[0].log = 0;
          sca[1].log = 0;
          sca[0].xtime = 0;
          break;
        case 1: // lin-log
          if (sca[1].log == 0) changeYlog = 1;
          sca[0].log = 0;
          sca[1].log = 1;
          sca[0].xtime = 0;
          break;
        case 2: // log-lin
          if (sca[1].log != 0) changeYlog = 1;
          sca[0].log = 1;
          sca[1].log = 0;
          sca[0].xtime = 0;
          break;
        case 3: // log-log
          if (sca[1].log == 0) changeYlog = 1;
          sca[0].log = 1;
          sca[1].log = 1;
          sca[0].xtime = 0;
          break;
        case 4: // time-lin
          if (sca[1].log != 0) changeYlog = 1;
          sca[0].log = 0;
          sca[1].log = 0;
          sca[0].xtime = 1;
          break;
        case 5: // time-log
          if (sca[1].log == 0) changeYlog = 1;
          sca[0].log = 0;
          sca[1].log = 1;
          sca[0].xtime = 1;
          break;
      }
      if (changeYlog != 0 && m_marker == 2) setmarkerflag(2); // recalculate
      // marker array
      this.graphStyle = graphStyle;
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw(); // rescale and reset limit
      OnPropertyChanged("graphStyle");
    }
    private int getGraphStyle()
    {
      return this.graphStyle;
    }
    private void setGridStyle(int gridStyle)
    {
      if (sca[0].gridLineMode == gridStyle) return;
      int oldValue = sca[0].gridLineMode;
      for (int i = 0; i < 2; i++)
      {
        sca[i].gridLineMode = gridStyle;
        sca[i].gridStroke = AcopConst.createStroke(sca[i].gridLineColor, sca[i].gridLineWidth, sca[i].gridLineMode);
      }
      if (aFrame.drawFlag) repaintHisto();
      OnPropertyChanged("gridStyle");
    }
    private int getGridStyle()
    {
      return sca[0].gridLineMode;
    }
    private void setGridColor(Color gridColor)
    {
      if (sca[0].gridLineColor == gridColor) return;
      Color oldValue = sca[0].gridLineColor;
      for (int i = 0; i < 2; i++)
      {
        sca[i].gridLineColor = gridColor;
        sca[i].gridStroke = AcopConst.createStroke(sca[i].gridLineColor, sca[i].gridLineWidth, sca[i].gridLineMode);
      }
      if (aFrame.drawFlag) repaintHisto();
      OnPropertyChanged("gridColor");
    }
    private Color getGridColor()
    {
      return sca[0].gridLineColor;
    }
    private void setGridWidth(int gridWidth)
    {
      if (sca[0].gridLineWidth == gridWidth) return;
      if (gridWidth < 1) gridWidth = 1;
      int oldValue = sca[0].gridLineWidth;
      for (int i = 0; i < 2; i++)
      {
        sca[i].gridLineWidth = gridWidth;
        sca[i].gridStroke = AcopConst.createStroke(sca[i].gridLineColor, sca[i].gridLineWidth, sca[i].gridLineMode);
      }
      if (aFrame.drawFlag) repaintHisto();
      OnPropertyChanged("gridWidth");
    }
    private int getGridWidth()
    {
      return sca[0].gridLineWidth;
    }
    private void setKeepStyle(int keepStyle)
    {
      if (this.keepStyle == keepStyle) return;
      int oldValue = this.keepStyle;
      this.keepStyle = keepStyle;
      if (aFrame.drawFlag && m_keep != 0) repaintHisto();
      OnPropertyChanged("keepStyle");
    }
    private int getKeepStyle()
    {
      return this.keepStyle;
    }
    private void setKeepColor(Color keepColor)
    {
      if (this.keepColor != null && this.keepColor.Equals(keepColor)) return;
      Color oldValue = this.keepColor;
      this.keepColor = keepColor;
      if (aFrame.drawFlag && m_keep != 0) repaintHisto();
      OnPropertyChanged("keepColor");
    }
    private Color getKeepColor()
    {
      return this.keepColor;
    }
    private void setKeepWidth(int keepWidth)
    {
      if (keepWidth == this.keepWidth) return;
      if (keepWidth < 1) keepWidth = 1;
      int oldValue = this.keepWidth;
      this.keepWidth = keepWidth;
      if (aFrame.drawFlag && m_keep != 0) repaintHisto();
      OnPropertyChanged("keepWidth");
    }
    private int getKeepWidth()
    {
      return this.keepWidth;
    }
    private void setHistogramPosition(int histogramPosition)
    {
      if (aFrame.histogramPosition == histogramPosition) return;
      int oldValue = aFrame.histogramPosition;
      aFrame.histogramPosition = histogramPosition;
      if (randomData == true)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("histogramPosition");
    }
    private int getHistogramPosition()
    {
      return aFrame.histogramPosition;
    }
    private void setInvert(Boolean invert)
    {
      if (this.invert == invert) return;
      this.invert = invert;
      if (randomData == true)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("invert");
    }
    private Boolean isInvert()
    {
      return this.invert;
    }

    private void setFrameBorderOn(Boolean frameBorderOn)
    {
      if (this.frameBorderOn == frameBorderOn) return;
      this.frameBorderOn = frameBorderOn;
      if (randomData == true)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("frameBorderOn");
    }
    private Boolean isFrameBorderOn()
    {
      return this.frameBorderOn;
    }

    public void SetRandomData(Boolean randomData)
    {
      if (this.randomData == randomData) return;
      this.randomData = randomData;
      if (randomData)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      else
        ClearScreen(-1, 0);

      OnPropertyChanged("randomData");
    }
    public Boolean IsRandomData()
    {
      return this.randomData;
    }
    public void SetRandomText(Boolean randomText)
    {
      if (this.randomText == randomText) return;
      this.randomText = randomText;
      if (randomData)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      else
        ClearScreen(-1, 0);
      OnPropertyChanged("randomText");
    }
    public Boolean IsRandomText()
    {
      return this.randomText;
    }
    private void setReuseScreen(Boolean reuseScreen)
    {
      if (this.reuseScreen == reuseScreen) return;
      this.reuseScreen = reuseScreen;
      OnPropertyChanged("reuseScreen");
    }
    private Boolean isReuseScreen()
    {
      return this.reuseScreen;
    }
    private void setReuseText(Boolean reuseText)
    {
      if (this.reuseText == reuseText) return;
      this.reuseText = reuseText;
      OnPropertyChanged("reuseText");
    }
    private Boolean isReuseText()
    {
      return this.reuseText;
    }
    private void setDrawWidthPointsLimit(int drawWidthPointsLimit)
    {
      if (this.drawWidthPointsLimit == drawWidthPointsLimit) return;

      if (drawWidthPointsLimit < 5000) drawWidthPointsLimit = 5000;
      this.drawWidthPointsLimit = drawWidthPointsLimit;
      OnPropertyChanged("drawWidthPointsLimit");
    }
    private int getDrawWidthPointsLimit()
    {
      return this.drawWidthPointsLimit;
    }
    private void setScreenDepth(int screenDepth)
    {
      if (this.screenDepth == screenDepth) return;

      int itmp = screenDepth;
      // if ( Beans.isDesignTime() == false ) return;
      // design mode
      if (itmp > AcopConst.MAX_DISPLAY)
        itmp = AcopConst.MAX_DISPLAY;
      else if (itmp < 1) itmp = 1;
      if (histo[itmp - 1] != null) return;
      screenDepth = itmp;
      int oldValue = this.screenDepth;
      n_display = screenDepth;
      this.screenDepth = screenDepth;
      OnPropertyChanged("screenDepth");
    }
    private int getScreenDepth()
    {
      return this.screenDepth;
    }
    private void setTextDepth(int textDepth)
    {

      int itmp = textDepth;
      // if ( Beans.isDesignTime() == false ) return;
      // design mode
      if (itmp > AcopConst.MAX_TEXT)
        itmp = AcopConst.MAX_TEXT;
      else if (itmp < 1) itmp = 1;
      if (ptext[itmp - 1] != null) return;
      textDepth = itmp;
      if (this.textDepth == textDepth) return;
      n_text = textDepth;
      int oldValue = this.textDepth;
      this.textDepth = textDepth;
      OnPropertyChanged("textDepth");
    }
    private int getTextDepth()
    {
      return this.textDepth;
    }
    private void setWrapAround(Boolean wrapAround)
    {
      int i;
      if (this.wrapAround == wrapAround) return;
      this.wrapAround = wrapAround;
      if (wrapAround) for (i = 0; i < n_display; i++)
          if (histo[i] != null && histo[i].displayON != 0)
            histo[i].getMaxWindow();
          else
            for (i = 0; i < n_display; i++)
              if (histo[i] != null && histo[i].displayON != 0) histo[i].wrapindex = 0;
      if (aFrame.drawFlag || textFlag)
      {
        // if ( wrapAround == false ) rescaleFlag = 1;
        // rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
        rescaleFlag = wrapAround == false ? 2 : 0;
        rescaleTextFlag = wrapAround == false ? AcopConst.NEW_ZOOM_WINDOW : 0;
        prepareDraw();
      }
      else if (wrapAround == false) drawTicks = true;
      OnPropertyChanged("wrapAround");
    }
    private Boolean isWrapAround()
    {
      return this.wrapAround;
    }
    public enum AcopZoomModes
    {
      none = 0,
      x_axis_unbuffered = 1,
      y_axis_unbuffered = 2,
      xy_axes_unbuffered = 3,
      x_axis = 5,
      y_axis = 6,
      xy_axes = 7
    }
    AcopZoomModes getAcopZoomMode(int m)
    {
      if (Enum.IsDefined(typeof(AcopZoomModes), m)) return (AcopZoomModes)m;
      return AcopZoomModes.none;
    }
    AcopZoomModes getAcopZoomMode()
    {
      return getAcopZoomMode(zooming);
    }
    private void setAcopZoomMode(AcopZoomModes m)
    {
      setZooming((int)m);
    }
    private void setZooming(int zooming)
    {
      if (this.zooming == zooming) return;
      int oldValue = this.zooming;
      if (zooming <= 7 && zooming >= 4)
        zoomIndex = 0;
      else if (zooming < 0 || zooming > 3) zooming = 0;
      if ((zooming & 0x7) != 0) setZoomingWindow(zooming & 0x4);
      if ((zooming & 0x7) == 0 && isZoomedFlag == true)
      {
        if (m_marker == 2) setmarkerflag(2); // restore marker array
        // prepareDraw(TRUE, -1, TRUE, nScaleText); // rescale and set max limit
        rescaleFlag = 2;
        rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
        prepareDraw();
        isZoomedFlag = false;
        zoomXmaxFlag = 0;
        zoomIndex = 0;
      }
      this.zooming = zooming;
      OnPropertyChanged("zooming");
    }
    private int getZooming()
    {
      return this.zooming;
    }
    private void setXAxisLabel(String xAxisLabel)
    {
      if (sca[0].AxisLabel != null && sca[0].AxisLabel.Equals(xAxisLabel)) return;
      String oldValue = sca[0].AxisLabel;
      sca[0].AxisLabel = xAxisLabel;
      this.Invalidate(sca[0].labelRect);
      OnPropertyChanged("xAxisLabel");
    }
    private String getXAxisLabel()
    {
      return sca[0].AxisLabel;
    }
    private void setYAxisLabel(String YAxisLabel)
    {
      if (sca[1].AxisLabel != null && sca[1].AxisLabel.Equals(YAxisLabel)) return;
      String oldValue = sca[1].AxisLabel;
      sca[1].AxisLabel = YAxisLabel;
      this.Invalidate(sca[1].labelRect);
      OnPropertyChanged("yAxisLabel");
    }
    private String getYAxisLabel()
    {
      return sca[1].AxisLabel;
    }
    private void setSecondaryYAxisLabel(String SecondaryYAxisLabel)
    {
      if (sca[2].AxisLabel != null && sca[2].AxisLabel.Equals(SecondaryYAxisLabel)) return;
      String oldValue = sca[2].AxisLabel;
      sca[2].AxisLabel = SecondaryYAxisLabel;
      this.Invalidate(sca[2].labelRect);
      OnPropertyChanged("secondaryYAxisLabel");
    }

    private String getSecondaryYAxisLabel()
    {
      return sca[2].AxisLabel;
    }
    private void setXBestScale(Boolean XBestScale)
    {
      if (sca[0].bestScale == XBestScale) return;
      sca[0].bestScale = XBestScale;
      OnPropertyChanged("xBestScale");
      if (sca[0].log != 0) return;
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw(); // rescale and reset limit
    }
    private Boolean isXBestScale()
    {
      return sca[0].bestScale;
    }
    private void setYBestScale(Boolean YBestScale)
    {
      if (sca[1].bestScale == YBestScale) return;
      sca[1].bestScale = YBestScale;
      OnPropertyChanged("yBestScale");
      if (sca[1].log != 0) return;
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw(); // rescale and reset limit
    }
    private Boolean isYBestScale()
    {
      return sca[1].bestScale;
    }
    private void setSecondaryYBestScale(Boolean SecondaryYBestScale)
    {
      if (sca[2].bestScale == SecondaryYBestScale) return;
      sca[2].bestScale = SecondaryYBestScale;
      if (sca[2].log != 0) return;
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw(); // rescale and reset limit
      OnPropertyChanged("secondaryYBestScale");
    }
    private Boolean isSecondaryYBestScale()
    {
      return sca[2].bestScale;
    }
    private void setXExtent(double XExtent)
    {
      if (this._XExtent == XExtent) return;
      double oldValue = this._XExtent;
      this._XExtent = XExtent;
      if (randomData == true)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("xExtent");
    }
    private double getXExtent()
    {
      return this._XExtent;
    }
    private void setYExtent(double YExtent)
    {
      if (this._YExtent == YExtent) return;
      double oldValue = this._YExtent;
      this._YExtent = YExtent;
      if (randomData == true)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("yExtent");
    }
    private double getYExtent()
    {
      return this._YExtent;
    }
    private void setXFineTicks(int XFineTicks)
    {
      if (sca[0].fineTicks == XFineTicks) return;
      int oldValue = sca[0].fineTicks;
      sca[0].fineTicks = XFineTicks;
      if (randomData == true || sca[0].log == 0)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("xFineTicks");
    }
    private int getXFineTicks()
    {
      return sca[0].fineTicks;
    }
    private void setYFineTicks(int YFineTicks)
    {
      if (sca[1].fineTicks == YFineTicks) return;
      int oldValue = sca[1].fineTicks;
      sca[1].fineTicks = YFineTicks;
      if (randomData == true || sca[1].log == 0)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("yFineTicks");
    }
    private int getYFineTicks()
    {
      return sca[1].fineTicks;
    }
    private void setSecondaryYFineTicks(int SecondaryYFineTicks)
    {
      if (sca[2].fineTicks == SecondaryYFineTicks) return;
      int oldValue = sca[2].fineTicks;
      sca[2].fineTicks = SecondaryYFineTicks;
      if (randomData == true || sca[2].log == 0)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("secondaryYFineTicks");
    }
    private int getSecondaryYFineTicks()
    {
      return sca[2].fineTicks;
    }
    private void setXGrid(Boolean XGrid)
    {
      if (sca[0].grid == XGrid) return;
      sca[0].grid = XGrid;
      repaintHisto();
      OnPropertyChanged("xGrid");
    }
    private Boolean isXGrid()
    {
      return sca[0].grid;
    }
    private void setYGrid(Boolean YGrid)
    {
      if (sca[1].grid == YGrid) return;
      sca[1].grid = YGrid;
      repaintHisto();
      OnPropertyChanged("yGrid");
    }
    private Boolean isYGrid()
    {
      return sca[1].grid;
    }
    private void setXScale(double XScale)
    {
      if (this._XScale == XScale) return;
      double oldValue = this._XScale;
      this._XScale = XScale;
      if (randomData == true)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("xScale");
    }
    private double getXScale()
    {
      return this._XScale;
    }
    private void setYScale(double YScale)
    {
      if (this._YScale == YScale) return;
      double oldValue = this._YScale;
      this._YScale = YScale;
      if (randomData == true)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("yScale");
    }
    private double getYScale()
    {
      return this._YScale;
    }
    private void setXShift(double XShift)
    {
      if (this._XShift == XShift) return;
      double oldValue = this._XShift;
      this._XShift = XShift;
      if (randomData == true)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("xShift");
    }
    private double getXShift()
    {
      return this._XShift;
    }
    private void setYShift(double YShift)
    {
      if (this._YShift == YShift) return;
      double oldValue = this._YShift;
      this._YShift = YShift;
      if (randomData == true)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("yShift");
    }
    private double getYShift()
    {
      return this._YShift;
    }
    private void setXTicks(int XTicks)
    {
      if (sca[0].ticks == XTicks) return;
      int oldValue = sca[0].ticks;
      sca[0].ticks = XTicks;
      if (randomData == true || sca[0].log == 0)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("xTicks");
    }
    private int getXTicks()
    {
      return sca[0].ticks;
    }
    private void setYTicks(int YTicks)
    {
      if (sca[1].ticks == YTicks) return;
      int oldValue = sca[1].ticks;
      sca[1].ticks = YTicks;
      if (randomData == true || sca[1].log == 0)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("yTicks");
    }
    private int getYTicks()
    {
      return sca[1].ticks;
    }
    private void setSecondaryYTicks(int SecondaryYTicks)
    {
      if (sca[2].ticks == SecondaryYTicks) return;
      int oldValue = sca[2].ticks;
      sca[2].ticks = SecondaryYTicks;
      if (randomData == true || sca[2].log == 0)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("secondaryYTicks");
    }
    private int getSecondaryYTicks()
    {
      return sca[2].ticks;
    }
    private void setXTicksBottom(Boolean XTicksBottom)
    {
      if (sca[0].leftBottom == XTicksBottom) return;
      sca[0].leftBottom = XTicksBottom;
      setTickRectangle(0);
      this.Invalidate();
      OnPropertyChanged("xTicksBottom");
    }
    private Boolean getXTicksBottom()
    {
      return sca[0].leftBottom;
    }
    private void setYTicksLeft(Boolean YTicksLeft)
    {
      if (sca[1].leftBottom == YTicksLeft) return;
      sca[1].leftBottom = YTicksLeft;
      setTickRectangle(1);
      this.Invalidate();
      OnPropertyChanged("yTicksLeft");
    }
    private Boolean getYTicksLeft()
    {
      return sca[1].leftBottom;
    }
    private void setXTickText(Boolean XTickText)
    {
      sca[0].ticktext = XTickText;
      this.Invalidate(sca[0].ticksRect);
      OnPropertyChanged("xTickText");
    }
    private Boolean isXTickText()
    {
      return sca[0].ticktext;
    }
    private void setYTickText(Boolean YTickText)
    {
      if (sca[1].ticktext == YTickText) return;
      sca[1].ticktext = YTickText;
      this.Invalidate(sca[1].ticksRect);
      OnPropertyChanged("yTickText");
    }
    private Boolean isYTickText()
    {
      return sca[1].ticktext;
    }
    private void setSecondaryYTickText(Boolean SecondaryYTickText)
    {
      if (sca[2].ticktext == SecondaryYTickText) return;
      sca[2].ticktext = SecondaryYTickText;
      this.Invalidate(sca[2].ticksRect);
      OnPropertyChanged("secondaryYTickText");
    }
    private Boolean isSecondaryYTickText()
    {
      return sca[2].ticktext;
    }
    /// <summary>
    /// Bind the given display to the secondary vertical (Y) axis.
    /// </summary>
    /// <param name="hDisplay">The display handle of the curve to be bound to secondary axis (returned from Draw() method).</param>
    /// <param name="bind">
    /// If 'true' the data associated with the display will be drawn according to the secondary axis criteria. 
    /// If 'false' the display will be associated with the primary Y axis.
    /// </param>
    /// <returns>0 upon success or -1 if the given display handle does not refer to a displayed curve.</returns>
    public int BindToSecondaryYScale(int hDisplay, Boolean bind)
    {
      int ret = 0;
      if (hDisplay < 0 || hDisplay >= n_display) return -1;
      if (histo[hDisplay] != null && histo[hDisplay].displayON != 0 && histo[hDisplay].lockFlag == 0)
      {
        histo[hDisplay].bindSecondaryY = bind;
        ret = bind ? 1 : 0;
        prepareDraw();
      }
      else ret = -1;
      return ret;
    }
    /// <summary>
    /// Bind the given display to the secondary vertical (Y) axis.
    /// </summary>
    /// <param name="hDisplay">The display handle of the curve to be bound to secondary axis (returned from Draw() method).</param>
    /// <returns>0 upon success or -1 if the given display handle does not refer to a displayed curve.</returns>
    public int BindToSecondaryYScale(int hDisplay)
    {
      return BindToSecondaryYScale(hDisplay, true);
    }
    private void setColorFilled(Boolean colorFilled)
    {
      if (this.colorFilled == colorFilled) return;
      this.colorFilled = colorFilled;
      if (randomData == true)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      OnPropertyChanged("colorFilled");
    }
    private Boolean isColorFilled()
    {
      return this.colorFilled;
    }
    private void setLeftTimeLabel(Boolean leftTimeLabel)
    {
      if (aFrame.leftTimeLabel == leftTimeLabel) return;
      aFrame.leftTimeLabel = leftTimeLabel;
      if (sca[0].xtime != 0)
      {
        sca[0].scaleToGrid();
        if (fBottom > 0) Invalidate(xRect);
      }
      OnPropertyChanged("leftTimeLabel");
    }
    private Boolean isLeftTimeLabel()
    {
      return aFrame.leftTimeLabel;
    }
    private void setAbsTimeDisplay(Boolean absTimeDisplay)
    {
      if (aFrame.absTimeDisplay == absTimeDisplay) return;
      aFrame.absTimeDisplay = absTimeDisplay;
      if (sca[0].xtime != 0)
      {
        sca[0].scaleToGrid();
        if (fBottom > 0) Invalidate(xRect);
      }
      OnPropertyChanged("absTimeDisplay");
    }
    private Boolean isAbsTimeDisplay()
    {
      return aFrame.absTimeDisplay;
    }
    private void setLeftYLabel(Boolean leftYLabel)
    {
      if (sca[1].leftBottLabel == leftYLabel) return;
      sca[1].leftBottLabel = leftYLabel;
      setTickRectangle(1);
      if (aFrame.drawFlag == false || randomData == false) return;
      this.Invalidate();
      OnPropertyChanged("leftYLabel");
    }
    private Boolean isLeftYLabel()
    {
      return sca[1].leftBottLabel;
    }
    private void setBottomXLabel(Boolean bottomXLabel)
    {
      if (sca[0].leftBottLabel == bottomXLabel) return;
      sca[0].leftBottLabel = bottomXLabel;
      setTickRectangle(0);
      OnPropertyChanged("bottomXLabel");
      if (aFrame.drawFlag == false || randomData == false) return;
      this.Invalidate();
    }
    private AcopAxisLabelAnchor getXLabelAnchor()
    {
      return sca[0].labelAnchor;
    }
    private void setXLabelAnchor(AcopAxisLabelAnchor value)
    {
      if (sca[0].labelAnchor == value) return;
      sca[0].labelAnchor = value;
      setTickRectangle(0);
      OnPropertyChanged("XLabelAnchor");
      if (aFrame.drawFlag == false || randomData == false) return;
      this.Invalidate();
    }
    private Boolean isBottomXLabel()
    {
      return sca[0].leftBottLabel;
    }
    public enum AcopBarLineFilledStyle
    {
      fill_below = -1,
      no_fill = 0,
      fill_above = 1
    }
    AcopBarLineFilledStyle getAcopBarlineColorFilled(int m)
    {
      if (Enum.IsDefined(typeof(AcopBarLineFilledStyle), m)) return (AcopBarLineFilledStyle)m;
      return AcopBarLineFilledStyle.no_fill;
    }
    AcopBarLineFilledStyle getAcopBarlineColorFilled()
    {
      return getAcopBarlineColorFilled(barlineColorFilled);
    }
    private void setAcopBarlineColorFilled(AcopBarLineFilledStyle m)
    {
      setBarlineColorFilled((int)m);
    }
    private void setAcopBarlineColorFilled(int m)
    {
      setBarlineColorFilled(m);
    }
    private void setBarlineColorFilled(int barlineColorFilled)
    {
      if (this.barlineColorFilled == barlineColorFilled || this.barlineColorFilled * barlineColorFilled > 0) return;
      int oldValue = this.barlineColorFilled;
      this.barlineColorFilled = barlineColorFilled;
      if (aFrame.drawFlag) repaintHisto();
      OnPropertyChanged("barlineColorFilled");
    }
    private int getBarlineColorFilled()
    {
      return this.barlineColorFilled;
    }
    public enum AcopPinTextStyle
    {
      position_pinned = 0,
      y_pinned = 1,
      x_pinned = 2,
      scalable_unpinned = 3,
      unscalable_unpinned = 4
    }
    AcopPinTextStyle getAcopPinTextStyle(int m)
    {
      if (Enum.IsDefined(typeof(AcopPinTextStyle), m)) return (AcopPinTextStyle)m;
      return AcopPinTextStyle.position_pinned;
    }
    AcopPinTextStyle getAcopPinTextStyle()
    {
      return getAcopPinTextStyle(printTextStickyAttribute);
    }
    private void setAcopPinTextStyle(AcopPinTextStyle m)
    {
      setPrintTextStickyAttribute((int)m);
    }
    private void setAcopPinTextStyle(int m)
    {
      setPrintTextStickyAttribute(m);
    }
    private void setPrintTextStickyAttribute(int printTextStickyAttribute)
    {
      if (this.printTextStickyAttribute == printTextStickyAttribute) return;
      int oldValue = this.printTextStickyAttribute;
      this.printTextStickyAttribute = printTextStickyAttribute;
      OnPropertyChanged("printTextStickyAttribute");
    }
    private int getPrintTextStickyAttribute()
    {
      return this.printTextStickyAttribute;
    }
    public enum AcopTextLocation
    {
      bottom_left = 0,
      bottom_center = 1,
      bottom_right = 2,
      mid_left = 3,
      mid_center = 4,
      mid_right = 5,
      top_left = 6,
      top_center = 7,
      top_right = 8
    }
    AcopTextLocation getAcopTextLocation(int m)
    {
      if (Enum.IsDefined(typeof(AcopTextLocation), m)) return (AcopTextLocation)m;
      return AcopTextLocation.bottom_left;
    }
    AcopTextLocation getAcopTextLocation()
    {
      return getAcopTextLocation(printTextLocation);
    }
    private void setAcopTextLocation(AcopTextLocation m)
    {
      setPrintTextLocation((int)m);
    }
    private void setAcopTextLocation(int m)
    {
      setPrintTextLocation(m);
    }
    private void setPrintTextLocation(int printTextLocation)
    {
      if (this.printTextLocation == printTextLocation) return;
      int oldValue = this.printTextLocation;
      this.printTextLocation = printTextLocation;
      OnPropertyChanged("printTextLocation");
    }
    private int getPrintTextLocation()
    {
      return this.printTextLocation;
    }
    private void setPrintTextRotation(int printTextRotation)
    {
      if (this.printTextRotation == printTextRotation) return;
      int oldValue = this.printTextRotation;
      this.printTextRotation = printTextRotation;
      OnPropertyChanged("printTextRotation");
    }
    private int getPrintTextRotation()
    {
      return this.printTextRotation;
    }
    private void setXlabelRotation(int xlabelRotation)
    {
      xlabelRotation = xlabelRotation % 360;
      if (this.xlabelRotation == xlabelRotation) return;
      int oldValue = this.xlabelRotation;
      this.xlabelRotation = xlabelRotation;
      if (xlabelRotation == 90 || xlabelRotation == -270)
        xlabelAxis = 1;
      else if (xlabelRotation == 180 || xlabelRotation == -180)
        xlabelAxis = 2;
      else if (xlabelRotation == 270 || xlabelRotation == -90)
        xlabelAxis = 3;
      else
        xlabelAxis = 0;
      xlabelRotateGrad = xlabelRotation * Math.PI / 180;
      xlabelRotateDegree = xlabelRotation;
      xlabelcos = Math.Cos(xlabelRotateGrad);
      xlabelsin = Math.Sin(xlabelRotateGrad);
      if (xlabelsin > 0)
        xlabelQudrant = xlabelcos < 0 ? 2 : 1;
      else
        xlabelQudrant = xlabelcos < 0 ? 3 : 4;
      OnPropertyChanged("xLabelRotation");
    }
    private int getXlabelRotation()
    {
      return this.xlabelRotation;
    }
    public int LeadingEdge(int LeadingEdgeMode, int hDisplay)
    {
      int num, ende;
      if (LeadingEdgeMode < 0 || LeadingEdgeMode > 3) LeadingEdgeMode = 0;
      if (hDisplay < 0 || hDisplay >= n_display)
      {
        num = 0;
        ende = n_display - 1;
      }
      else
        ende = num = n_display;
      for (; num <= ende; num++)
      {
        if (histo[hDisplay] == null) continue;
        histo[num].edgeMode = LeadingEdgeMode;
      }
      return LeadingEdgeMode;
    }
    public int LeadingEdge(int hDisplay)
    {
      if (hDisplay < 0 || hDisplay >= n_display)
        return _LeadingEdgeMode;
      else if (histo[hDisplay] == null)
        return 0;
      else
        return histo[hDisplay].edgeMode;
    }
    private void setLeadingEdgeColor(Color LeadingEdgeColor)
    {
      if (this._LeadingEdgeColor == LeadingEdgeColor) return;
      Color oldValue = this._LeadingEdgeColor;
      this._LeadingEdgeColor = LeadingEdgeColor;
      OnPropertyChanged("leadingEdgeColor");
    }
    private Color getLeadingEdgeColor()
    {
      return this._LeadingEdgeColor;
    }
    private void setLeadingEdgeGapSize(int gapSize)
    {
      if (this._LeadingEdgeGapSize == gapSize) return;
      int oldValue = this._LeadingEdgeGapSize;
      this._LeadingEdgeGapSize = gapSize;
      OnPropertyChanged("leadingEdgeGapSize");
    }
    private int getLeadingEdgeGapSize()
    {
      return this._LeadingEdgeGapSize;
    }
    // _LeadingEdgeMotion = 'moving' flag (0 = not moving)
    // make this a boolean !
    private void setLeadingEdgeMotion(int LeadingEdgeMotion)
    {
      if (this._LeadingEdgeMotion == LeadingEdgeMotion) return;
      int oldValue = this._LeadingEdgeMotion;
      this._LeadingEdgeMotion = LeadingEdgeMotion;
      if (aFrame.drawFlag) repaintHisto();
      OnPropertyChanged("leadingEdgeMotion");
    }
    private int getLeadingEdgeMotion()
    {
      return this._LeadingEdgeMotion;
    }
    private Boolean getLeadingEdgeFixed()
    {
      return this._LeadingEdgeMotion == 0;
    }
    private void setLeadingEdgeFixed(Boolean value)
    {
      setLeadingEdgeMotion(value ? 0 : 1);
    }
    private void setLeadingEdgeMode(int LeadingEdgeMode)
    {
      if (LeadingEdgeMode < 0 || LeadingEdgeMode > 3) LeadingEdgeMode = 0;
      if (this._LeadingEdgeMode == LeadingEdgeMode) return;
      int oldValue = this._LeadingEdgeMode;
      this._LeadingEdgeMode = LeadingEdgeMode;
      if (aFrame.drawFlag) repaintHisto();
      OnPropertyChanged("leadingEdgeMode");
    }
    public enum LeadingEdgeCursor
    {
      none = 0,
      horizontal = 1,
      vertical = 2,
      both = 3
    }

    LeadingEdgeCursor getLeadingEdgeMode(int m)
    {
      if (Enum.IsDefined(typeof(LeadingEdgeCursor), m)) return (LeadingEdgeCursor)m;
      return LeadingEdgeCursor.none;
    }
    LeadingEdgeCursor getLeadingEdgeMode()
    {
      return getLeadingEdgeMode(_LeadingEdgeMode);
    }
    private void setLeadingEdgeMode(LeadingEdgeCursor m)
    {
      setLeadingEdgeMode((int)m);
    }

    //private int getLeadingEdgeMode()
    //{
    //  return this._LeadingEdgeMode;
    //}
    private void setLeadingEdgeWidth(int LeadingEdgeWidth)
    {
      if (LeadingEdgeWidth < 0) LeadingEdgeWidth = 1;
      if (this._LeadingEdgeWidth == LeadingEdgeWidth) return;
      int oldValue = this._LeadingEdgeWidth;
      this._LeadingEdgeWidth = LeadingEdgeWidth;
      OnPropertyChanged("leadingEdgeWidth");
    }
    private int getLeadingEdgeWidth()
    {
      return this._LeadingEdgeWidth;
    }
    private void setLeadingEdgeStyle(int LeadingEdgeStyle)
    {
      if (LeadingEdgeStyle < AcopConst.PS_SOLID) LeadingEdgeStyle = AcopConst.PS_SOLID;
      if (this._LeadingEdgeStyle == LeadingEdgeStyle) return;
      int oldValue = this._LeadingEdgeStyle;
      this._LeadingEdgeStyle = LeadingEdgeStyle;
      OnPropertyChanged("leadingEdgeStyle");
    }
    private int getLeadingEdgeStyle()
    {
      return this._LeadingEdgeStyle;
    }
    private void setLeadingEdgeXExtent(double LeadingEdgeXExtent)
    {
      if (Math.Abs(this._LeadingEdgeXExtent - LeadingEdgeXExtent) < AcopConst.zero_check) return;
      double oldValue = this._LeadingEdgeXExtent;
      this._LeadingEdgeXExtent = LeadingEdgeXExtent;
      OnPropertyChanged("leadingEdgeXExtent");
    }
    private double getLeadingEdgeXExtent()
    {
      return this._LeadingEdgeXExtent;
    }
    private void setLeadingEdgeYExtent(double LeadingEdgeYExtent)
    {
      if (Math.Abs(this._LeadingEdgeYExtent - LeadingEdgeYExtent) < AcopConst.zero_check) return;
      double oldValue = this._LeadingEdgeYExtent;
      this._LeadingEdgeYExtent = LeadingEdgeYExtent;
      OnPropertyChanged("leadingEdgeYExtent");
    }
    private double getLeadingEdgeYExtent()
    {
      return this._LeadingEdgeYExtent;
    }
    /// <summary>
    /// Applies an autoscale to all axes on all displays
    /// </summary>
    /// <param name="autoscale">If true applies an autoscale.</param>
    public void AutoScale(Boolean autoscale)
    {
      AutoScale(autoscale, autoscale, autoscale, autoscale, -1);
    }
    /// <summary>
    /// Applies an autoscale on the axes indicated on all displays
    /// </summary>
    /// <param name="xmx">If true apply autoscale to the Horizontal (X) maximum.</param>
    /// <param name="xmn">If true apply autoscale to the Horizontal (X) minimum.</param>
    /// <param name="ymx">If true apply autoscale to the Vertical (Y) maximum.</param>
    /// <param name="ymn">If true apply autoscale to the Vertical (Y) minimum.</param>
    public void AutoScale(Boolean xmx, Boolean xmn, Boolean ymx, Boolean ymn)
    {
      AutoScale(xmx, xmn, ymx, ymn, -1);
    }
    /// <summary>
    /// Applies an autoscale on the axes indicated on the given display
    /// </summary>
    /// <param name="xmx">If true apply autoscale to the Horizontal (X) maximum.</param>
    /// <param name="xmn">If true apply autoscale to the Horizontal (X) minimum.</param>
    /// <param name="ymx">If true apply autoscale to the Vertical (Y) maximum.</param>
    /// <param name="ymn">If true apply autoscale to the Vertical (Y) minimum.</param>
    /// <param name="hDisplay">The display handle of the curve to apply an autoscale (returned from Draw() method). '-1' applies to all curves.</param>
    public void AutoScale(Boolean xmx, Boolean xmn, Boolean ymx, Boolean ymn, int hDisplay)
    {
      double autotmp, checkXmin, checkXmax, xMax, xMin;
      double[] yMin = new double[2];
      double[] yMax = new double[2];
      double[] autotmpY = new double[2];
      int[] yFlags = new int[2];
      int[] autoflgY = new int[2];
      int i, j, autoflg, start, stop, yIndex;
      if (!xmx && !xmn && !ymx && !ymn) return;
      if (histo[m_histstart] == null) return;
      if (hDisplay < -1 || hDisplay >= n_display) return;
      if (hDisplay != -1 && histo[hDisplay] == null) return;
      if (hDisplay != -1)
      {
        start = hDisplay;
        stop = hDisplay + 1;
        //      yIndex = histo[hIndex].bindSecondaryY ? 2 : 1;
      }
      else
      {
        start = 0;
        stop = n_display;
      }
      xMax = sca[0].usermax;
      if (xmx) for (i = start, autoflg = 0; i < stop && histo[i] != null; i++)
        {
          if (i != m_histstart && histo[i].displayON == 0) continue;
          autotmp = histo[i].maxOf(histo[i].x);
          if (autoflg == 0)
          {
            xMax = autotmp;
            autoflg = 1;
          }
          else if (xMax < autotmp) xMax = autotmp;
        }
      xMin = sca[0].usermin;
      if (xmn) for (i = start, autoflg = 0; i < stop && histo[i] != null; i++)
        {
          if (i != m_histstart && histo[i].displayON == 0) continue;
          autotmp = histo[i].minOf(histo[i].x);
          if (autoflg == 0)
          {
            xMin = autotmp;
            autoflg = 1;
          }
          else if (xMin > autotmp) xMin = autotmp;
        }
      for (i = 0; i < 2; i++)
      {
        yFlags[i] = autoflgY[i] = 0;
        yMax[i] = sca[i + 1].usermax;
      }
      //    yMax = sca[yIndex].usermax;
      if (ymx) for (i = start; i < stop && histo[i] != null; i++)
        {
          if (i != m_histstart && histo[i].displayON == 0) continue;
          yIndex = histo[i].bindSecondaryY ? 1 : 0;
          yFlags[yIndex]++;
          if (xmx && xmn)
            autotmpY[yIndex] = histo[i].maxOf(histo[i].y);
          else
          {
            checkXmin = sca[0].getMin();
            checkXmax = sca[0].getMax();
            autotmpY[yIndex] = -1.7E308;
            for (j = 0; j < histo[i].npoints; j++)
            {
              if (histo[i].disable[j] != 0) continue;
              if (xmx == false && histo[i].x[j] > checkXmax) continue;
              if (xmn == false && histo[i].x[j] < checkXmin) continue;
              if (histo[i].y[j] > autotmpY[yIndex]) autotmpY[yIndex] = histo[i].y[j];
            }
          }
          if (autoflgY[yIndex] == 0)
          {
            yMax[yIndex] = autotmpY[yIndex];
            autoflgY[yIndex] = 1;
          }
          else if (yMax[yIndex] < autotmpY[yIndex]) yMax[yIndex] = autotmpY[yIndex];
        }
      for (i = 0; i < 2; i++)
      {
        autoflgY[i] = 0;
        yMin[i] = sca[i + 1].usermin;
      }
      //    yMin = sca[yIndex].usermin;
      if (ymn)
        for (i = start; i < stop && histo[i] != null; i++)
        {
          if (i != m_histstart && histo[i].displayON == 0) continue;
          yIndex = histo[i].bindSecondaryY ? 1 : 0;
          yFlags[yIndex]++;
          if (xmx && xmn && sca[yIndex + 1].log == 0)
            autotmpY[yIndex] = histo[i].minOf(histo[i].y);
          else
          {
            checkXmin = sca[0].getMin();
            checkXmax = sca[0].getMax();
            autotmpY[yIndex] = 1.7E308;
            int mode = histo[i].dismode;
            if (mode == AcopConst.mode_status || mode == AcopConst.mode_annotation)
            {
              continue;
            }
            for (j = 0; j < histo[i].npoints; j++)
            {
              if (histo[i].disable[j] != 0) continue;
              if (xmx == false && histo[i].x[j] > checkXmax) continue;
              if (xmn == false && histo[i].x[j] < checkXmin) continue;
              if (histo[i].y[j] < autotmpY[yIndex])
                if (sca[yIndex + 1].log == 0 || histo[i].y[j] > 1.0e-30) autotmpY[yIndex] = histo[i].y[j];
            }
          }
          if (autoflgY[yIndex] == 0)
          {
            yMin[yIndex] = autotmpY[yIndex];
            autoflgY[yIndex] = 1;
          }
          else if (yMin[yIndex] > autotmpY[yIndex]) yMin[yIndex] = autotmpY[yIndex];
        }
      if (xMax <= xMin + AcopConst.zero_check)
      {
        autotmp = Math.Abs(xMin);
        if (autotmp < AcopConst.zero_check)
        {
          xMin -= 5;
          xMax = xMin + 10;
        }
        else
        {
          xMin -= (0.5 * autotmp);
          xMax = xMin + autotmp;
        }
      }
      for (i = 0; i < 2; i++)
      {
        if (yFlags[i] == 0) continue;
        if (yMax[i] <= yMin[i] + AcopConst.zero_check)
        {
          if (!ymn && ymx)
          {
            autotmp = Math.Abs(yMin[i]);
            if (autotmp < AcopConst.zero_check) yMax[i] = yMin[i] + 10;
            else yMax[i] = yMin[i] + Math.Abs(yMin[i]);
          }
          else if (ymn && !ymx)
          {
            autotmp = Math.Abs(yMax[i]);
            if (autotmp < AcopConst.zero_check) yMin[i] = yMax[i] - 10;
            else yMin[i] = yMax[i] - Math.Abs(yMax[i]);
          }
          else
          {
            autotmp = Math.Abs(yMin[i]);
            if (autotmp < AcopConst.zero_check)
            {
              yMin[i] -= 5;
              yMax[i] = yMin[i] + 10;
            }
            else
            {
              yMin[i] -= (0.5 * autotmp);
              yMax[i] = yMin[i] + autotmp;
            }
          }
        }
      }
      if (xmx || xmn) sca[0].setUserscale(xMin, xMax);
      if (ymx || ymn) for (i = 0; i < 2; i++) if (yFlags[i] != 0) sca[i + 1].setUserscale(yMin[i], yMax[i]);
      // prepareDraw(TRUE, -1, TRUE, 0);
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw();
    }
    protected void onRButtonDown(Point point)
    {
      if (aFrame.drawFlag == false && textFlag == false) return;
      if (aFrame.drawFlag && histo[m_histstart].dismode == AcopConst.mode_textbox) return;
      mRightStart = point;
      if ((isZoomedFlag || (wrapAround && sca[0].log == 0)) && histRoundRect.Contains(point))
      {
        movie = true;
        moviepoint = point;
        saveBestFlag = (sca[0].bestScale ? 1 : 0) + (sca[1].bestScale ? 2 : 0);
        sca[0].bestScale = false;
        sca[1].bestScale = false;
      }
      if (isZoomedFlag) rButtonPoint = point;
    }
    private void doBufferedZoom(Object sender)
    {
      int i;
      if ((zooming & 0x4) != 0 && zoomIndex > 0)
      {
        zoomIndex--;
        for (i = 0; i < 3; i++)
        {
          sca[i].setDispscale(bufferedMin[zoomIndex, i], bufferedMax[zoomIndex, i]);
          if (sca[i].log != 0) sca[i].setDispscale(Math.Pow(10.0, sca[i].min), Math.Pow(10.0, sca[i].max));
        }
        zoomXmaxFlag = bufferedXtimeFlag[zoomIndex];
        bufferedZoomRatio = "Z" + zoomIndex;
        if (zoomIndex != 0) sca[0].scaleToGrid();
      }
      if (m_marker == 2) setmarkerflag(2); // recalculate marker array
      rescaleFlag = zoomIndex == 0 ? 2 : 1;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw(); // rescale and not set max limit
      if (zoomIndex == 0) isZoomedFlag = false;
      notifyAcop(sender, AcopEvent.ACOP_MOUSE_ZOOM_EVENT);
    }
    protected void onRButtonUp(Object sender, Point point)
    {
      if (movie == false)
      {
        if (!isZoomedFlag || (zooming & 0x4) == 0 || rButtonPoint != point) return;
        doBufferedZoom(sender);
        return;
      }
      movie = false;
      if (saveBestFlag != 0)
      {
        if ((saveBestFlag & 0x1) != 0) sca[0].bestScale = true;
        if ((saveBestFlag & 0x2) != 0) sca[1].bestScale = true;
      }
    }
    protected void onMouseMoveMovie(Object sender, Point point)
    {
      double mx, my, x, y, tx, ty, xcheckmin, xcheckmax;
      Boolean reScale;
      int i;
      double[] low = new double[3];
      double[] high = new double[3];
      reScale = true;
      // from log back to nomal for re-scaling
      for (i = 0; i < 3; i++)
      {
        if (i == 2 && sca[i].OnFlag == false) continue;
        low[i] = sca[i].getMin();
        high[i] = sca[i].getMax();
        // x = sca[0].getMin();
        // tx= sca[0].getMax();
        // y = sca[1].getMin();
        // ty= sca[1].getMax();
      }
      if (wrapAround == false || sca[0].log != 0)
      {
        xcheckmin = sca[0].usermin;
        xcheckmax = sca[0].usermax;
      }
      else
      {
        xcheckmin = wrapxmin - sca[0].dispSize - AcopConst.zero_check;
        xcheckmax = wrapxmax + sca[0].dispSize + AcopConst.zero_check;
      }
      if ((point.X < moviepoint.X && low[0] > xcheckmin) || (point.X > moviepoint.X && high[0] < xcheckmax)
          || (point.Y > moviepoint.Y && low[1] > sca[1].usermin)
          || (point.Y < moviepoint.Y && high[1] < sca[1].usermax))
      {
        for (i = 0; i < 3; i++)
        {
          if (i == 2 && sca[i].OnFlag == false) continue;
          if (sca[i].log != 0) sca[i].setDispscale(low[i], high[i]);
        }
        x = sca[0].dispSize * moviePercent; // shift 10 percent
        if (point.X < moviepoint.X)
        {
          if (sca[0].log != 0)
          {
            if ((++xCnt < movieLogCnt) || (sca[0].usermin < AcopConst.zero_check && sca[0].min < 0.1)
                || sca[0].min / 10 < sca[0].usermin)
              reScale = false;
            else
            {
              sca[0].setDispscale(sca[0].min / 10, sca[0].max / 10);
              xCnt = 0;
            }
          }
          else
          {
            if (sca[0].min - x < xcheckmin) x = sca[0].min - xcheckmin;
            sca[0].setDispscale(sca[0].min - x, sca[0].max - x);
            if (wrapAround && sca[0].max <= wrapxmin)
              sca[0].setDispscale(wrapxmax - sca[0].dispSize, wrapxmax);
          }
        }
        else if (point.X > moviepoint.X)
        {
          if (sca[0].log != 0)
          {
            if ((--xCnt <= -movieLogCnt) && sca[0].max * 10 <= sca[0].usermax)
            {
              sca[0].setDispscale(sca[0].min * 10, sca[0].max * 10);
              xCnt = 0;
            }
            else
              reScale = false;
          }
          else
          {
            if (sca[0].max + x > xcheckmax) x = xcheckmax - sca[0].max;
            sca[0].setDispscale(sca[0].min + x, sca[0].max + x);
            if (wrapAround && sca[0].min >= wrapxmax)
              sca[0].setDispscale(wrapxmin, wrapxmin + sca[0].dispSize);
          }
        }
        for (i = 1; i < 3; i++) // loop y and y2
        {
          if (i == 2 && sca[i].OnFlag == false) continue;
          y = sca[i].dispSize * moviePercent; // shift 10 percent
          if (point.Y > moviepoint.Y)
          {
            if (sca[i].log != 0)
            {
              if ((++yCnt < movieLogCnt) || (sca[i].usermin < AcopConst.zero_check && sca[i].min < 0.1)
                  || sca[i].min / 10 < sca[i].usermin)
                reScale = false;
              else
              {
                sca[i].setDispscale(sca[i].min / 10, sca[i].max / 10);
                yCnt = 0;
              }
            }
            else
            {
              if (sca[i].min - y < sca[i].usermin) y = sca[i].min - sca[i].usermin;
              sca[i].setDispscale(sca[i].min - y, sca[i].max - y);
            }
          }
          else if (point.Y < moviepoint.Y)
          {
            if (sca[i].log != 0)
            {
              if ((--yCnt <= -movieLogCnt) && sca[i].max * 10 <= sca[i].usermax)
              {
                sca[i].setDispscale(sca[i].min * 10, sca[i].max * 10);
                yCnt = 0;
              }
              else
                reScale = false;
            }
            else
            {
              if (sca[i].max + y > sca[i].usermax) y = sca[i].usermax - sca[i].max;
              sca[i].setDispscale(sca[i].min + y, sca[i].max + y);
            }
          }
        }
        if (reScale == true)
        {
          sca[0].scaleToGrid();
          if (m_marker == 2) setmarkerflag(2); // restore marker array
          rescaleFlag = 1;
          rescaleTextFlag = AcopConst.NEW_MOVE_WINDOW;
          prepareDraw(); // rescale but keep present limit
          // prepareDraw(TRUE, -1, FALSE, 0); // rescale but keep present limit
          if (isZoomedFlag && zooming != 0x4)
          {
            notifyAcop(sender, AcopEvent.ACOP_MOUSE_ZOOM_EVENT);
          }
          // if ( isZoomedFlag ) FireCursorZoom(s_xmax, s_xmin, s_ymax, s_ymin);
        }
        else
          for (i = 0; i < 3; i++)
          {
            if (i == 2 && sca[i].OnFlag == false) continue;
            if (sca[i].log != 0)
              sca[i].setDispscale(Math.Log(sca[i].min) / Math.Log(10), Math.Log(sca[i].max) / Math.Log(10));
          }
      }
      moviepoint = point;
    }
    protected void onLButtonDown(Point point, Point dashPoint)
    {
      if (histo[m_histstart] == null || aFrame.drawFlag == false) return;
      if (histo[m_histstart].dismode == AcopConst.mode_textbox) return;
      if ((zooming & 0x7) != 0)
      {
        zoomFlag = true;
        //      zoomRect.setBounds(point.X, point.Y, 0, 0);
        zoomRect = new Rectangle(point.X, point.Y, 0, 0);
        mStart = point;
        mEnd = point;
        mdashStart = dashPoint;
        mdashEnd = dashPoint;
        //      Graphics a = (Graphics)CreateGraphics();
        //      a.setXORMode(Color.DarkGray);
        //      BasicGraphicsUtils.drawDashedRect(a, point.X, point.Y, 0, 0);
        theRectangle = new Rectangle(dashPoint, new Size(0, 0));
        //      ControlPaint.DrawReversibleFrame(theRectangle, Color.DarkGray, FrameStyle.Dashed);
        //      a.setPaintMode();
        //      a.Dispose();
        // mEnd = mStart = point;
        // zoomRect2 = zoomRect;
        // CClientDC dc(this); // draw zoom rectangle
        // dc.DrawDragRect( &zoomRect2, size, NULL, size, NULL, NULL );
      }
      else
      {
        // mClickPoint = point;
        // mDoubleClickPoint = mClickPoint;
        // mDoubleClickPoint.x++;
      }
    }
    protected void onLButtonUp(Object sender, Point point, Point dashPoint)
    {
      double ftmp, curPos;
      double x, y;
      double[] storemin = new double[3];
      double[] storemax = new double[3];
      int i;
      if (zoomFlag == false) return;
      zoomFlag = false;
      if (mEnd.Equals(point) == false || mStart == point) return;
      //    Graphics a = (Graphics) CreateGraphics(); // get rid of zoom drag
      // rectangle
      //    a.setXORMode(Color.DarkGray);
      //    BasicGraphicsUtils.drawDashedRect(a, zoomRect.X, zoomRect.Y, zoomRect.Width, zoomRect.Height);
      ControlPaint.DrawReversibleFrame(theRectangle, Color.DarkGray, FrameStyle.Dashed);
      //    theRectangle = new Rectangle(zoomRect.X, zoomRect.Y, zoomRect.Width, zoomRect.Height);
      //    ControlPaint.DrawReversibleFrame(theRectangle, Color.DarkGray, FrameStyle.Dashed);
      //    a.setPaintMode();
      //    a.Dispose();
      // zoom outside the histo rectangle
      if (zoomRect.X + zoomRect.Width < aFrame.histRect.X
          || zoomRect.X > aFrame.histRect.X + aFrame.histRect.Width
          || zoomRect.Y + zoomRect.Height < aFrame.histRect.Y
          || zoomRect.Y > aFrame.histRect.Y + aFrame.histRect.Height) return;
      // zoom inside the histo rectangle and 2 pixel at least
      if (zoomRect.Width > 2 && zoomRect.Height > 2
          && (zoomRect.Width < aFrame.histRect.Width || zoomRect.Height < aFrame.histRect.Height))
      {
        if ((zooming & 0x4) != 0 && zoomIndex < AcopConst.lengthZoom) for (i = 0; i < 3; i++)
          {
            storemin[i] = sca[i].min;
            storemax[i] = sca[i].max;
          }
        if ((zooming & 0x1) != 0 || zooming == 0x4) // x zooming
        {
          ftmp = (zoomRect.X - aFrame.absxleft) * sca[0].dispSize / aFrame.dxwidth + sca[0].min;
          curPos = (zoomRect.X + zoomRect.Width - aFrame.absxleft) * sca[0].dispSize / aFrame.dxwidth
              + sca[0].min;
          if (zoomXmaxFlag != 2) zoomXmaxFlag = curPos < sca[0].max ? 2 : 1;
          if (curPos < sca[0].max) sca[0].setDispscale(sca[0].min, curPos);
          if (ftmp > sca[0].min) sca[0].setDispscale(ftmp, sca[0].max);
        }
        if ((zooming & 0x2) != 0 || zooming == 0x4)
          // y and y2 zooming
          for (i = 1; i < 3; i++)
          {
            if (i == 2 && sca[i].OnFlag == false) continue;
            ftmp = (1.0 - (double)(zoomRect.Y - aFrame.histRect.Y) / aFrame.histRect.Height) * sca[i].dispSize
                + sca[i].min;
            curPos = (1.0 - (double)(zoomRect.Y + zoomRect.Height - aFrame.histRect.Y) / aFrame.histRect.Height)
                * sca[i].dispSize + sca[i].min;
            if (curPos > sca[i].min) sca[i].setDispscale(curPos, sca[i].max);
            if (ftmp < sca[i].max) sca[i].setDispscale(sca[i].min, ftmp);
          }
        for (i = 0; i < 3; i++) // from log back to nomal for re-scaling
        {
          if (sca[i].log != 0)
            sca[i].setDispscale(Math.Pow(10.0, sca[i].min), Math.Pow(10.0, sca[i].max));
          else if (sca[i].max < sca[i].min + AcopConst.zero_check)
            sca[i].setDispscale(sca[i].min, sca[i].min + AcopConst.zero_check);
        }
        if (wrapAround && sca[0].log == 0)
        {
          if (sca[0].min > wrapxmax)
          {
            ftmp = wrapxmax - wrapxmin;
            sca[0].max -= ftmp;
            sca[0].min -= ftmp;
          }
          else if (sca[0].max < wrapxmin)
          {
            ftmp = wrapxmax - wrapxmin;
            sca[0].max += ftmp;
            sca[0].min += ftmp;
          }
        }
        isZoomedFlag = true;
        sca[0].scaleToGrid();
        if (m_marker == 2) setmarkerflag(2); // recalculate marker array
        // prepareDraw(TRUE, -1, FALSE, nScaleText); // rescale and not set max
        // limit
        rescaleFlag = 1;
        rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
        prepareDraw(); // rescale and not set max limit
        yZoomRatio = "V" + (int)(sca[1].userSize / sca[1].dispSize + 0.5) + ":1";
        xZoomRatio = "H" + (int)(sca[0].userSize / sca[0].dispSize + 0.5) + ":1";
        if ((zooming & 0x4) != 0 && zoomIndex < AcopConst.lengthZoom)
        {
          bufferedXtimeFlag[zoomIndex] = zoomXmaxFlag;
          for (i = 0; i < 3; i++)
          {
            bufferedMin[zoomIndex, i] = storemin[i];
            bufferedMax[zoomIndex, i] = storemax[i];
          }
          zoomIndex++;
          bufferedZoomRatio = "Z" + zoomIndex;
        }
        notifyAcop(sender, AcopEvent.ACOP_MOUSE_ZOOM_EVENT);
        // FireCursorZoom(s_xmax, s_xmin, s_ymax, s_ymin);
      }
      // else if ( isZoomedFlag && aFrame.zoomIcon.contains(point) ) doBufferedZoom();
      else if (zoomRect.Width >= aFrame.histRect.Width && zoomRect.Height >= aFrame.histRect.Height)
        doBufferedZoom(sender); // return back to original setting
      // { // return back to original setting
      // if ( isZoomedFlag && (sca[0].isOriginMaxMin() == false ||
      // sca[1].isOriginMaxMin() == false) )
      // {
      // rescaleFlag = 2;
      // if ( m_marker == 2 ) setmarkerflag(2); // restore marker array
      // rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      // prepareDraw();
      // notifyAcop(AcopEvent.ACOP_MOUSE_ZOOM_EVENT);
      // }
      // isZoomedFlag = false;
      // }
      // else
      // {
      // InvalidateControl(&zoomRect);
      // if ( getMousePosition(point, x, y, TRUE) ) FireCursorClick(XarrayElement,
      // x, y);
      // }
      // }
    }
    // public void resize(int width, int height)
    // {
    // if ( changeScaleWidth == 0 ) return;
    // scaleframe();
    // this.repaint();
    // }
    //  protected void processComponentEvent(ComponentEvent componentEvent)
    //  {
    // make sue listeners are notified
    //    super.processComponentEvent(componentEvent);
    //    switch (componentEvent.getID())
    //    {
    //      case ComponentEvent.COMPONENT_RESIZED: // resized
    //        scaleFrameDraw();
    //        break;
    //      case ComponentEvent.COMPONENT_MOVED: // moved
    //        break;
    //      default:
    //        break;
    //    }
    //  }
    protected override void OnForeColorChanged(EventArgs e)
    {
      base.OnForeColorChanged(e);
      this.SetForeground(this.ForeColor);
    }
    protected override void OnBackColorChanged(EventArgs e)
    {
      base.OnBackColorChanged(e);
      this.setBackground(this.BackColor);
    }
    protected override void OnResize(EventArgs e)
    {
      base.OnResize(e);
      scaleFrameDraw();
    }
    private void Form1_Resize(object sender, System.EventArgs e)
    {
      scaleFrameDraw();
    }
    protected override void OnMouseDown(MouseEventArgs e)
    {
      base.OnMouseDown(e);
      //    processMouseEvent(e, MouseDown);
    }
    protected override void OnMouseClick(MouseEventArgs e)
    {
      base.OnMouseClick(e);
      //    processMouseEvent(e, MouseClick);
    }
    protected override void OnMouseDoubleClick(MouseEventArgs e)
    {
      base.OnMouseDoubleClick(e);
      //    processMouseEvent(e, MouseDoubleClick);
    }
    protected override void OnMouseEnter(EventArgs e)
    {
      base.OnMouseEnter(e);
      //    processMouseEvent(e, MouseEnter);
    }
    protected override void OnMouseHover(EventArgs e)
    {
      base.OnMouseHover(e);
      //    processMouseEvent(e, MouseHover);
    }
    protected override void OnMouseLeave(EventArgs e)
    {
      base.OnMouseLeave(e);
      //    processMouseEvent(e, MouseLeave);
    }
    protected override void OnMouseMove(MouseEventArgs e)
    {
      base.OnMouseMove(e);
      //    processMouseEvent(e, MouseMove);
    }
    protected override void OnMouseUp(MouseEventArgs e)
    {
      base.OnMouseUp(e);
      //    processMouseEvent(e, MouseUp);
    }
    protected override void OnPaint(PaintEventArgs e)
    {
      // Call the OnPaint method of the base class.
      base.OnPaint(e);
      // Call methods of the System.Drawing.Graphics object.
      paintComponent(e.Graphics);
      //e.Graphics.DrawString(Text, Font, new SolidBrush(ForeColor), ClientRectangle);
    }
    private void AcopMouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
    {
      mouseX = e.X;
      mouseY = e.Y;
      mousepoint = e.Location;
      Point dashPoint = ((Control)sender).PointToScreen(new Point(mousepoint.X, mousepoint.Y));
      switch (e.Button)
      {
        case MouseButtons.Left:
          onLButtonDown(mousepoint, dashPoint); // left button
          leftButton = 1;
          break;
        case MouseButtons.Right:
          onRButtonDown(mousepoint); // right button
          rightButton = 1;
          break;
        case MouseButtons.None:
        default:
          break;
      }
      notifyAcop(sender, AcopEvent.ACOP_MOUSE_PRESSED_EVENT);
    }
    private Boolean checkAnnotationArea(Point mPoint)
    {
      int i, annotationIndex, mIndex;
      double[] mConvt = new double[3];
      int xcheck, ycheck;

      annotationIndex = -1;
      for (i = 0; i < n_display; i++)
      {
        if (histo[i] == null) break;
        if (histo[i].dismode == AcopConst.mode_annotation)
        {
          annotationIndex = i;
          break;
        }
      }
      if (annotationIndex == -1) return false;
      mIndex = histo[annotationIndex].getMousePosition(mPoint, mConvt);
      xcheck = histo[annotationIndex].ix[mIndex] + histRoundRect.X - 3;
      ycheck = histRoundRect.Y;
      if (mPoint.X >= xcheck && mPoint.X <= xcheck + AcopConst.AnnotationSize &&
            mPoint.Y >= ycheck - 1 && mPoint.Y <= ycheck + AcopConst.AnnotationSize)
      {
        mouseIndex = mIndex;
        mouseConvert = mConvt;
        return true;
      }
      return false;
    }
    private void AcopMouseClick(object sender, System.Windows.Forms.MouseEventArgs e)
    {
      mouseX = e.X;
      mouseY = e.Y;
      mousepoint = e.Location;
      if (e.Clicks > 1) return;
      if (isZoomedFlag && aFrame.zoomIcon.Contains(mousepoint))
        doBufferedZoom(sender);
      else
      {
        mouseEvent = e;
        mouseArea = histRoundRect.Contains(mousepoint) ? 0 : 1;
        if (histRoundRect.Contains(mousepoint) && aFrame.drawFlag)
          mouseIndex = histo[m_histstart].getMousePosition(mousepoint, mouseConvert);
        else
          mouseIndex = -1;
        if (mousepoint.Equals(mStart) == true || mousepoint.Equals(mRightStart))
        {
          if (mouseIndex != -1 && checkAnnotationArea(mousepoint))
            notifyAcop(sender, AcopEvent.ACOP_ANNOATATION_EVENT);
          else
            notifyAcop(sender, AcopEvent.ACOP_MOUSE_CLICK_EVENT);
        }
      }
    }
    private void AcopMouseDoubleClick(object sender, System.Windows.Forms.MouseEventArgs e)
    {
      mouseX = e.X;
      mouseY = e.Y;
      mousepoint = e.Location;
      mouseEvent = e;
      mouseArea = histRoundRect.Contains(mousepoint) ? 0 : 1;
      if (histRoundRect.Contains(mousepoint) && aFrame.drawFlag)
        mouseIndex = histo[m_histstart].getMousePosition(mousepoint, mouseConvert);
      else
        mouseIndex = -1;
      //      mousepoint.X += aFrame.histRect.X;  // convert it back for detect zoomIcon
      //      mousepoint.Y += aFrame.histRect.Y;
      if (isZoomedFlag && aFrame.zoomIcon.Contains(mousepoint)) // return to original size
      {
        rescaleFlag = 2;
        if (m_marker == 2) setmarkerflag(2); // restore marker array
        rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
        prepareDraw();
        isZoomedFlag = false;
        zoomXmaxFlag = 0;
        notifyAcop(sender, AcopEvent.ACOP_MOUSE_ZOOM_EVENT);
      }
      notifyAcop(sender, AcopEvent.ACOP_MOUSE_DCLICK_EVENT);
    }
    private void AcopMouseEnter(object sender, System.EventArgs e)
    {
      mouseIndex = -1;
      notifyAcop(sender, AcopEvent.ACOP_MOUSE_ENTER_EVENT);
    }
    private void AcopMouseHover(object sender, System.EventArgs e)
    {
    }
    private void AcopMouseLeave(object sender, System.EventArgs e)
    {
      mouseIndex = -1;
      notifyAcop(sender, AcopEvent.ACOP_MOUSE_EXIT_EVENT);
    }
    private void AcopMouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
    {
      int rWidth, rHeight, recX, recY;
      // Update the mouse path that is drawn onto the Panel. 
      mouseX = e.X;
      mouseY = e.Y;
      mousepoint = e.Location;
      if (mMovePoint.X == mouseX && mMovePoint.Y == mouseY) return;
      mouseEvent = e;
      mouseArea = histRoundRect.Contains(mousepoint) ? 0 : 1;
      //if (Math.Abs(mMovePoint.X - mouseX) < 2 && Math.Abs(mMovePoint.Y - mouseY) < 2) return;
      Point dashPoint = ((Control)sender).PointToScreen(new Point(mousepoint.X, mousepoint.Y));
      if (e.Button == MouseButtons.Left || e.Button == MouseButtons.Right)    // drag
      {
        paintCursorMarker = true;
        if (zoomFlag)
        {
          //              Graphics a = (Graphics)CreateGraphics();
          //              a.setXORMode(Color.darkGray);
          //              BasicGraphicsUtils.drawDashedRect(a, zoomRect.x, zoomRect.y, zoomRect.Width, zoomRect.Height);
          ControlPaint.DrawReversibleFrame(theRectangle, Color.DarkGray, FrameStyle.Dashed);
          mEnd = mousepoint;
          rWidth = Math.Abs(mEnd.X - mStart.X);
          rHeight = Math.Abs(mEnd.Y - mStart.Y);
          recX = Math.Min(mEnd.X, mStart.X);
          recY = Math.Min(mEnd.Y, mStart.Y);
          //              zoomRect.setBounds(recX, recY, rWidth, rHeight);
          zoomRect = new Rectangle(recX, recY, rWidth, rHeight);

          mdashEnd = dashPoint;
          rWidth = Math.Abs(mdashEnd.X - mdashStart.X);
          rHeight = Math.Abs(mdashEnd.Y - mdashStart.Y);
          recX = Math.Min(mdashEnd.X, mdashStart.X);
          recY = Math.Min(mdashEnd.Y, mdashStart.Y);
          theRectangle = new Rectangle(recX, recY, rWidth, rHeight);
          //              BasicGraphicsUtils.drawDashedRect(a, recX, recY, rWidth, rHeight);
          ControlPaint.DrawReversibleFrame(theRectangle, Color.DarkGray, FrameStyle.Dashed);
          //          a.setPaintMode();
          //              a.Dispose();
        }
        else if (movie)
          onMouseMoveMovie(sender, mousepoint);
        else if (aFrame.drawFlag && m_cursorMarkerMode != 0 && cursorStay == 0
            && histRoundRect.Contains(mousepoint))
        {
          drawCursorMarker(null, mousepoint);
          mMovePoint.X = mousepoint.X;
          mMovePoint.Y = mousepoint.Y;
        }
        if (histo[m_histstart] != null) mouseIndex = histo[m_histstart].getMousePosition(mousepoint, mouseConvert);
        notifyAcop(sender, AcopEvent.ACOP_MOUSE_DRAG_EVENT);
      }
      else if (aFrame.drawFlag && histRoundRect.Contains(mousepoint))   // move
      {
        if (m_cursorMarkerMode != 0 && cursorStay == 0) drawCursorMarker(null, mousepoint);
        mMovePoint.X = mousepoint.X;
        mMovePoint.Y = mousepoint.Y;
        mouseIndex = histo[m_histstart].getMousePosition(mousepoint, mouseConvert);
        if (!paintCursorMarker)
        {
          paintCursorMarker = true;
          repaintHisto();
        }
        notifyAcop(sender, AcopEvent.ACOP_MOUSE_MOVE_EVENT);
      }
    }
    private void AcopMouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
    {
      mouseX = e.X;
      mouseY = e.Y;
      mousepoint = e.Location;
      Point dashPoint = ((Control)sender).PointToScreen(new Point(mousepoint.X, mousepoint.Y));
      if (leftButton != 0)
      {
        onLButtonUp(sender, mousepoint, dashPoint); // left button
        leftButton = 0;
      }
      if (rightButton != 0)
      {
        onRButtonUp(sender, mousepoint); // left button
        rightButton = 0;
      }
      /*      switch (e.Button) {
              case MouseButtons.Left:
                  onLButtonUp(mousepoint); // left button
                break;
              case MouseButtons.Right:
                  onRButtonUp(mousepoint); // right button
                break;
              default:
                break;
            }*/
    }
    private void AcopPaint(object sender, System.Windows.Forms.PaintEventArgs e)
    {
    }
    private void AcopResize(object sender, System.EventArgs e)
    {
      //   scaleFrameDraw();
    }
    /*
protected void processMouseEvent(MouseEventArgs mouseEvent)
{
// make sue listeners are notified
mouseX = mouseEvent.X;
mouseY = mouseEvent.Y;
mousepoint = mouseEvent.Location;
switch (mouseEvent.getID())
{
  case MouseEvent.MOUSE_ENTERED: // enter to de.desy.acop.chart area
    mouseIndex = -1;
    notifyAcop(AcopEvent.ACOP_MOUSE_ENTER_EVENT);
    break;
  case MouseEvent.MOUSE_EXITED: // go out of de.desy.acop.chart area
    mouseIndex = -1;
    notifyAcop(AcopEvent.ACOP_MOUSE_EXIT_EVENT);
    break;
  case MouseEvent.MOUSE_PRESSED: // mouse down
    if ((mouseEvent.getModifiers() & MouseEvent.BUTTON1_MASK) != 0)
      if (!mouseEvent.isControlDown()) onLButtonDown(mousepoint); // left button
    else if ((mouseEvent.getModifiers() & MouseEvent.BUTTON3_MASK) != 0) // right
                                                                          // button
      onRButtonDown(mousepoint); // left button
      notifyAcop(AcopEvent.ACOP_MOUSE_PRESSED_EVENT);
    break;
  case MouseEvent.MOUSE_RELEASED: // mouse up
    if ((mouseEvent.getModifiers() & MouseEvent.BUTTON1_MASK) != 0)
      onLButtonUp(mousepoint); // left button
    else if ((mouseEvent.getModifiers() & MouseEvent.BUTTON3_MASK) != 0) // right
                                                                          // button
      onRButtonUp(mousepoint); // left button
    break;
  case MouseEvent.MOUSE_CLICKED: // mouse click
    long mouseEventTime = mouseEvent.getWhen();
    long mouseButton = mouseEvent.getButton();
    Boolean doubleClick;
    if (mouseButton == previousButton && (mouseEventTime - mousePreviousClickTime < 300))
      doubleClick = true;
    else
      doubleClick = false;
    mousePreviousClickTime = mouseEventTime;
    previousButton = mouseEvent.getButton();
    if (doubleClick) // implement double click events
    {
      if (histRoundRect.contains(mousepoint) && aFrame.drawFlag)
        mouseIndex = histo[m_histstart].getMousePosition(mousepoint, mouseConvert);
      else
        mouseIndex = -1;
      mousepoint.x += aFrame.histRect.x;  // convert it back for detect zoomIcon
      mousepoint.y += aFrame.histRect.y;
      if (isZoomed && aFrame.zoomIcon.contains(mousepoint)) // return to original size
      {
        rescaleFlag = 2;
        if (m_marker == 2) setmarkerflag(2); // restore marker array
        rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
        prepareDraw();
        isZoomedFlag = false;
        zoomXmaxFlag = 0;
        notifyAcop(AcopEvent.ACOP_MOUSE_ZOOM_EVENT);
      }
      notifyAcop(AcopEvent.ACOP_MOUSE_DCLICK_EVENT);
    }
    // FireCursorClick(XarrayElement, x, y);
    // mouseEvent.notifyAll();
    else if (isZoomedFlag && aFrame.zoomIcon.contains(mousepoint))
      doBufferedZoom();
    // / {
    // / rescaleFlag = 2;
    // /// if ( m_marker == 2 ) setmarkerflag(2); // restore marker array
    // / rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
    // / prepareDraw();
    // / isZoomedFlag = false;
    // / notifyAcop(AcopEvent.ACOP_MOUSE_ZOOM_EVENT);
    // / }
    else
    {
      if (histRoundRect.contains(mousepoint) && aFrame.drawFlag)
        mouseIndex = histo[m_histstart].getMousePosition(mousepoint, mouseConvert);
      else
        mouseIndex = -1;
      notifyAcop(AcopEvent.ACOP_MOUSE_CLICK_EVENT);
    }
//		if (mouseEvent.getButton()==MouseEvent.BUTTON3) getPopupManager().showPopup(this,mouseEvent.getX(),mouseEvent.getY());
    break;
  default:
    break;
}
}
protected void processMouseMotionEvent(MouseEventArgs mouseMotionEvent)
{
int rWidth, rHeight, recX, recY;
// make sue listeners are notified
mouseX = mouseMotionEvent.X;
mouseY = mouseMotionEvent.Y;
mousepoint = mouseMotionEvent.Location;
switch (mouseMotionEvent.getID())
{
  case MouseEvent.MOUSE_MOVED: // mouse move
    if (aFrame.drawFlag && histRoundRect.contains(mousepoint))
    {
      if (m_cursorMarkerMode != 0 && cursorStay == 0) drawCursorMarker(null, mousepoint);
      mMovePoint.x = mousepoint.x;
      mMovePoint.y = mousepoint.y;
      mouseIndex = histo[m_histstart].getMousePosition(mousepoint, mouseConvert);
      if (!paintCursorMarker)
      {
          paintCursorMarker = true;
          repaintHisto();
      }
      notifyAcop(AcopEvent.ACOP_MOUSE_MOVE_EVENT);
    }
    // if ( getMousePosition(point, mx, my, TRUE) )
    // FireCursorMove(XarrayElement, mx, my);
    break;
  case MouseEvent.MOUSE_DRAGGED: // mouse dragging
    paintCursorMarker = true;
    if (zoomFlag)
    {
      Graphics a = (Graphics) CreateGraphics();
      a.setXORMode(Color.darkGray);
      BasicGraphicsUtils.drawDashedRect(a, zoomRect.x, zoomRect.y, zoomRect.Width, zoomRect.Height);
      mEnd = mousepoint;
      rWidth = Math.abs(mEnd.x - mStart.x);
      rHeight = Math.abs(mEnd.y - mStart.y);
      recX = Math.min(mEnd.x, mStart.x);
      recY = Math.min(mEnd.y, mStart.y);
      zoomRect.setBounds(recX, recY, rWidth, rHeight);
      BasicGraphicsUtils.drawDashedRect(a, recX, recY, rWidth, rHeight);
//          a.setPaintMode();
      a.dispose();
    }
    else if (movie)
      onMouseMoveMovie(mousepoint);
    else if (aFrame.drawFlag && m_cursorMarkerMode != 0 && cursorStay == 0
        && histRoundRect.contains(mousepoint))
    {
      drawCursorMarker(null, mousepoint);
      mMovePoint.x = mousepoint.x;
      mMovePoint.y = mousepoint.y;
    }
    break;
  default:
    break;
}
}
    */
    private void drawtext(Graphics g2d)
    {
      if (textFlag == false) return;
      RectangleF Cliprect = g2d.ClipBounds;
      if (Cliprect != null)
      {
        if (Cliprect.IntersectsWith(histRoundRect) == false) return;
      }
      g2d.SetClip(histRoundRect);// clipRect(histRoundRect.x, histRoundRect.y, histRoundRect.Width, histRoundRect.Height);
      g2d.TranslateTransform(aFrame.histRect.X, aFrame.histRect.Y);
      for (int i = 0; i < n_text; i++)
      {
        if (ptext[i] == null) break;
        ptext[i].printUserText(g2d);
      }
      g2d.TranslateTransform(-aFrame.histRect.X, -aFrame.histRect.Y);
      g2d.SetClip(Cliprect);
    }
    private void drawhist(Graphics g2d)
    {
      lock (g2d)
      {
        if (aFrame.drawFlag == false && textFlag == false) return;
        RectangleF Cliprect = g2d.ClipBounds;
        if (Cliprect != null)
        {
          if (Cliprect.IntersectsWith(histRoundRect) == false) return;
        }
        g2d.SetClip(histRoundRect);//.clipRect(histRoundRect.x, histRoundRect.y, histRoundRect.Width, histRoundRect.Height);
        g2d.TranslateTransform(aFrame.histRect.X, aFrame.histRect.Y);
        for (int i = 0; i < 2; i++)
          sca[i].drawGrid(g2d);
        for (int i = 0; i < 2; i++)
          axis[i].drawAxis(g2d);
        if (aFrame.drawFlag) for (int i = 0; i < n_display; i++)
          {
            if (histo[i] == null) break;
            histo[i].drawhist(g2d);
          }
        if (aFrame.drawFlag && m_cursorMarkerMode != 0 && histRoundRect.Contains(mMovePoint))
        {
          /* set pencolor to black (for first histo?) to avoid the color change of cursorMarker pen  */
          //2014-11 g2d.setColor(Cointersectlor.black);
          if (cursorStay > 0)  // 2009-5-4 tootip may change the mouse position, reload the original value
          {
            mMovePoint.X = sca[0].getScreenPosition(cursorXposition);
            mMovePoint.Y = sca[1].getScreenPosition(cursorYposition);
          }
          drawCursorMarker(g2d, mMovePoint);
        }
        else
          cursorMarkerFlag = 0; // no cursor drawn on screen!
        g2d.TranslateTransform(-aFrame.histRect.X, -aFrame.histRect.Y);
        g2d.SetClip(Cliprect);
      }
    }
    private void captionPaint(Graphics g2d)
    {
      //    FontMetrics fMetrix;
      int xPosition, len, hei;
      RectangleF Cliprect = g2d.ClipBounds;
      if (caption == null) return;  /* 2008-2 hwu*/
      if (Cliprect != null)
      {
        if (Cliprect.IntersectsWith(titleRect) == false) return;
      }
      if (captionFont == null || captionChanged == true || randomData == true)
      {
        captionFont = new Font(this.Font.Name, this.Font.Size, this.Font.Style);
        captionChanged = false;
      }
      //    Font tmpFont = g2d.getFont();
      //    AffineTransform transform = g2d.getTransform();
      g2d.SetClip(titleRect);//.clipRect(titleRect.x, titleRect.y, titleRect.Width + 1, titleRect.Height + 1);
      g2d.TranslateTransform(titleRect.X, titleRect.Y);
      //    g2d.setFont(captionFont);
      //    fMetrix = g2d.getFontMetrics();
      SizeF strSize = g2d.MeasureString(caption, captionFont);
      len = (int)strSize.Width;    // fMetrix.stringWidth(caption);
      hei = (int)strSize.Height;  // (fMetrix.getDescent() + fMetrix.getAscent()) / 2;
      if (captionPosition == 1)
        xPosition = (titleRect.Width - len) / 2;
      else if (captionPosition < 1)
        xPosition = 2;
      else
        xPosition = titleRect.Width - len - 2;
      //g2d.setColor(aFrame.frameForeColor);
      //    g2d.DrawString(caption, captionFont, aFrame.framBrush, xPosition, sca[0].leftBottom ? (fTop - 4) : (fTop - 4 - hei * 2));
      g2d.DrawString(caption, captionFont, aFrame.framBrush, xPosition, sca[0].leftBottom ? (fTop - hei - 4) : 4);
      //    g2d.setTransform(transform);
      //    g2d.setFont(tmpFont);
      g2d.TranslateTransform(-titleRect.X, -titleRect.Y);
      g2d.SetClip(Cliprect);
    }
    private void backgroundPaint(Graphics g2d, Rectangle Cliprect, Rectangle acopRect)
    {
      int i;
      if (nBackRegions == 0)
      {
        //2014-11 g2d.setColor(this.BackColor);
        //      g2dima.setBackground(g2d.getBackground());
        if (Cliprect == null)
          g2d.FillRectangle(backBrush, 0, 0, acopRect.Width, acopRect.Height);
        //        g2dima.clearRect(0, 0, acopRect.Width, acopRect.Height);
        else
          g2d.FillRectangle(backBrush, Cliprect.X, Cliprect.Y, Cliprect.Width, Cliprect.Height);
        //        g2dima.clearRect(Cliprect.x, Cliprect.y, Cliprect.Width, Cliprect.Height);
        return;
      }
      //2014-11     g2d.setColor(this.BackColor);
      //    g2dima.setBackground(g2d.getBackground());
      if (false) // what to do for the display gap?????
      {
        if (Cliprect == null || Cliprect.IntersectsWith(titleRect) == true)
          g2d.FillRectangle(backBrush, titleRect.X, titleRect.Y, titleRect.Width, titleRect.Height);
        //        g2dima.clearRect(titleRect.x, titleRect.y, titleRect.Width, titleRect.Height);
        if (Cliprect == null || Cliprect.IntersectsWith(xRect) == true)
          g2d.FillRectangle(backBrush, xRect.X, xRect.Y, xRect.Width, xRect.Height);
        //        g2dima.clearRect(xRect.x, xRect.y, xRect.Width, xRect.Height);
        if (Cliprect == null || Cliprect.IntersectsWith(yRect) == true)
          g2d.FillRectangle(backBrush, yRect.X, yRect.Y, yRect.Width, yRect.Height);
        //        g2dima.clearRect(yRect.x, yRect.y, yRect.Width, yRect.Height);
        if (Cliprect == null || Cliprect.IntersectsWith(yAxisRect) == true)
          g2d.FillRectangle(backBrush, yAxisRect.X, yAxisRect.Y, yAxisRect.Width, yAxisRect.Height);
        //        g2dima.clearRect(yAxisRect.x, yAxisRect.y, yAxisRect.Width, yAxisRect.Height);
      }
      else
      {
        if (Cliprect == null)
          g2d.FillRectangle(backBrush, 0, 0, acopRect.Width, acopRect.Height);
        //        g2dima.clearRect(0, 0, acopRect.Width, acopRect.Height);
        else
          g2d.FillRectangle(backBrush, Cliprect.X, Cliprect.Y, Cliprect.Width, Cliprect.Height);
        //        g2dima.clearRect(Cliprect.x, Cliprect.y, Cliprect.Width, Cliprect.Height);
      }
      g2d.SetClip(histRoundRect);//.clipRect(histRoundRect.x, histRoundRect.y, histRoundRect.Width, histRoundRect.Height);
      RectangleF tmpCliprect = g2d.ClipBounds;
      for (i = 0; i < nBackRegions; i++)
      {
        if (backkgroundRegionType[i] == 0) continue;
        if (tmpCliprect != null && tmpCliprect.IntersectsWith(backRegionRect[i]) == false) continue;
        if (backkgroundRegionType[i] == 1)
        {
          //2014-11         g2d.setColor(backRegionColor[i]);
          //        g2dima.setBackground(backRegionColor[i]);
          g2d.FillRectangle(backRegionBrush[i], backRegionRect[i].X, backRegionRect[i].Y, backRegionRect[i].Width,
            backRegionRect[i].Height);
          //        g2dima.clearRect(backRegionRect[i].x, backRegionRect[i].y, backRegionRect[i].Width,backRegionRect[i].Height);
        }
        else if (backkgroundRegionType[i] == 2)
          g2d.DrawImage(backRegionImage[i], backRegionRect[i].X, backRegionRect[i].Y, backRegionRect[i].Width, backRegionRect[i].Height);
      }
      g2d.SetClip(Cliprect);
    }

    private void drawLegendIcon(Graphics g, Brush b, Pen p, Font f, Point loc, AcopPlotMode mode)
    {
      switch (mode)
      {
        case AcopPlotMode.dots:
          goto case AcopPlotMode.polyline_dots;
        case AcopPlotMode.barline_histo_dots:
          goto case AcopPlotMode.polyline_dots;
        case AcopPlotMode.histogram_dots:
          goto case AcopPlotMode.polyline_dots;
        case AcopPlotMode.histogram_rastoring_dots:
          goto case AcopPlotMode.polyline_dots;
        case AcopPlotMode.barline_dots:
          goto case AcopPlotMode.polyline_dots;
        case AcopPlotMode.polyline_dots:
          g.FillEllipse(b, loc.X, loc.Y, 5, 5);
          break;
        case AcopPlotMode.polyline_cross:
          g.DrawString("X", f, b, loc.X - 2, loc.Y - 4);
          break;
        case AcopPlotMode.circle:
          g.DrawEllipse(p, loc.X, loc.Y, 5, 5);
          break;
        case AcopPlotMode.rectangle:
          g.DrawRectangle(p, loc.X, loc.Y, 5, 5);
          break;
      }
    }
    private void drawLegendItem(Graphics g, Point loc, String txt, Color c, AcopPlotMode mode)
    {
      SizeF txt_size = g.MeasureString(txt, this.Font);
      float c_size = g.MeasureString("X", this.Font).Width;
      float w = txt_size.Width + c_size * 3 + 2;
      float h = txt_size.Height + 2;
      Font f = new Font("Arial", 9, FontStyle.Regular);
      Brush b = new SolidBrush(c);
      Pen p = new Pen(c);
      Size s = new Size((int)w, (int)h);
      Rectangle r = new Rectangle(loc, s);
      g.FillRectangle(b, r.X, r.Y + h / 2, c_size * 3, 2);
      Point pt = new Point((int)(r.X + c_size*1.5), (int)(r.Y + 5 * h / 12));
      drawLegendIcon(g, b, p, f, pt, mode);
      g.DrawString(txt, f, b, r.X + c_size * 3 + 2, r.Top);
    }
    private Boolean lgdInFrame = false;
    private Boolean showLegend = false;
    private void setLegendInFrame(Boolean value)
    {
      lgdInFrame = value;
      Refresh();
    }
    private void setShowLegend(Boolean value)
    {
      showLegend = value;
      Refresh();
    }
    public enum LegendLocation
    {
      upper_right = 0,
      upper_left = 1,
      lower_right = 2,
      lower_left = 3,
      bottom = 4,
      top = 5,
    }
    private LegendLocation lgdLocation = LegendLocation.upper_right;
    private void setLegendLocation(LegendLocation value)
    {
      lgdLocation = value;
      Refresh();
    }
    /// <summary>
    /// Establishes the location of the chart legend
    /// </summary>
    [Category("Acop.Display.Legend")]
    [Description("Establishes the location of the chart legend")]
    public LegendLocation LegendPosition { get { return lgdLocation; } set { setLegendLocation(value); } }
    /// <summary>
    /// Establishes whether the chart legend should appear on the chart (false) or in the chart frame (true)
    /// </summary>
    [Category("Acop.Display.Legend")]
    [Description("Establishes whether the chart legend should appear on the chart (false) or in the chart frame (true)")]
    public Boolean LegendInFrame { get { return lgdInFrame; } set { setLegendInFrame(value); } }
    /// <summary>
    /// Determines whether or not a legend should appear on the chart
    /// </summary>
    [Category("Acop.Display.Legend")]
    [Description("Determines whether or not a legend should appear on the chart")]
    public Boolean ShowLegend { get { return showLegend; } set { setShowLegend(value); } }
    /// <summary>
    /// provides an array of plot descriptions to be used as a legend (if ShowLegend = 'true')
    /// </summary>
    [Category("Acop.Display.Legend")]
    [Description("provides an array of plot descriptions to be used as a legend (if ShowLegend = 'true')")]
    [DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
    [Editor("System.Windows.Forms.Design.StringArrayEditor, System.Design, Version = 2.0.0.0, Culture = neutral, PublicKeyToken = b03f5f7f11d50a3a", typeof(System.Drawing.Design.UITypeEditor))]
    public String[] LegendItems { get { return getLegendItems(); } set { setLegendItems(value); } }

    private SizeF lgdElementSize = new SizeF(0, 0);
    private float lgdLineSize = 0;
    private float lghHorzSplitSize = 0;

    protected class LegendItem
    {
      public String text;
      public SizeF size = SizeF.Empty;
      public AcopPlotMode mode = AcopPlotMode.polyline;
      public Color color = Color.Black;
      public LegendItem(String text, Color color, AcopPlotMode mode)
      {
        this.text = text;
        this.color = color;
        this.mode = mode;
      }
    }
    List<LegendItem> lgdItems = new List<LegendItem>();
    /// <summary>
    /// Add an item to the chart's legend (provide 'ShowLegend = true')
    /// </summary>
    /// <param name="text">The text to show for the next legend item</param>
    /// <param name="color">The color of the curve associated with the legend item</param>
    /// <param name="mode">The draw mode associated with the legend item</param>
    public void AddLegendItem(String text, Color color, AcopPlotMode mode)
    {
      AddLegendItem(text, color, mode, lgdItems.Count);
    }
    /// <summary>
    /// Add an item to the chart's legend at the position given (provide 'ShowLegend = true')
    /// </summary>
    /// <param name="text">The text to show for the next legend item</param>
    /// <param name="color">The color of the curve associated with the legend item</param>
    /// <param name="mode">The draw mode associated with the legend item</param>
    /// <param name="index">The legend index position which should display the legend text</param>
    public void AddLegendItem(String text, Color color, AcopPlotMode mode, int index)
    {
      if (index < 0) return;
      if (text == null) text = "";
      if (color == null) color = Color.Black;
      lock (lgdItems)
      {
        if (index < lgdItems.Count)
        {
          LegendItem itm = lgdItems.ElementAt(index);
          itm.text = text;
          itm.color = color;
          itm.mode = mode;
        }
        else
        {
          while (lgdItems.Count < index) lgdItems.Add(new LegendItem("", Color.Black, AcopPlotMode.polyline));
          lgdItems.Add(new LegendItem(text, color, mode));
        }
      }
      Refresh();
    }
    private String[] lgdItemList = new String[] { };
    private String[] getLegendItems()
    {
      return lgdItemList;
    }
    protected void setLegendItems(String[] items)
    {
      if (items == null) return;
      lgdItemList = items;
      lock (lgdItems)
      {
        lgdItems.Clear();
        int idx = 0;
        Color[] colors = GetColorList();
        Color c = GetForeground();
        AcopPlotMode m = getPlotMode();
        foreach (String text in items)
        {
          if (colors != null)
          {
            c = colors[idx];
            idx = (++idx) % colors.Length;
          }
          lgdItems.Add(new LegendItem(text, c, m));
        }
      }
      Refresh();
    }
    /// <summary>
    /// Add an item to the chart's legend (provide 'ShowLegend = true')
    /// </summary>
    /// <param name="text">The text to show for the next legend item</param>
    public void AddLegendItem(String text)
    {
      Color c = GetForeground();
      AcopPlotMode m = getPlotMode();
      AddLegendItem(text, c, m, lgdItems.Count);
    }
    /// <summary>
    /// Add an item to the chart's legend at the position given (provide 'ShowLegend = true')
    /// </summary>
    /// <param name="text">The text to show for the next legend item</param>
    /// <param name="index">The legend index position which should display the legend text</param>
    public void AddLegendItem(String text, int index)
    {
      Color c = GetForeground();
      AcopPlotMode m = getPlotMode();
      AddLegendItem(text, c, m, index);
    }
    /// <summary>
    /// Add an item to the chart's legend (provide 'ShowLegend = true')
    /// </summary>
    /// <param name="hDisplay">The display handle associated with the legend item</param>
    /// <param name="text">The text to show for the next legend item</param>
    public void AddLegendItem(int hDisplay, String text)
    {
      if (hDisplay < 0 || hDisplay >= histo.Length) return;
      Color c = histo[hDisplay].getCurveColor();
      AcopPlotMode m = GetPlotMode(histo[hDisplay].dismode);
      AddLegendItem(text, c, m, lgdItems.Count);
    }
    /// <summary>
    /// Add an item to the chart's legend at the position given (provide 'ShowLegend = true')
    /// </summary>
    /// <param name="hDisplay">The display handle associated with the legend item</param>
    /// <param name="text">The text to show for the next legend item</param>
    /// <param name="index">The legend index position which should display the legend text</param>
    public void AddLegendItem(int hDisplay, String text, int index)
    {
      Color c = histo[hDisplay].getCurveColor();
      AcopPlotMode m = GetPlotMode(histo[hDisplay].dismode);
      AddLegendItem(text, c, m, index);
    }
    /// <summary>
    /// Removes the legend item at the postion indicated
    /// </summary>
    /// <param name="index">The legend position index for the item to be removed</param>
    public void RemoveLegend(int index)
    {
      if (index < 0) return;
      lock (lgdItems)
      {
        if (index < lgdItems.Count)
        {
          lgdItems.RemoveAt(index);
        }
      }
      Refresh();
    }
    /// <summary>
    /// Removes all items from the chart legend.
    /// </summary>
    public void ClearLegend()
    {
      lock (lgdItems)
      {
        lgdItems.Clear();
      }
      Refresh();
    }
    private Point getLegendLocation(Graphics g)
    {
      Point p;
      SizeF siz = new SizeF(0, 0);
      float csiz = 0;
      lock (lgdItems)
      {
        foreach (LegendItem v in lgdItems)
        {
          if (v.size.Width == 0)
          {
            v.size = g.MeasureString(v.text, this.Font);
          }
          if (v.size.Width > siz.Width) siz = v.size;
          if (csiz == 0)
          {
            csiz = g.MeasureString("X", this.Font).Width;
          }
        }
        lgdElementSize = siz;
        lgdLineSize = csiz * 3 + 2;
        lghHorzSplitSize = csiz * 2;
        int xoffset = 0, yoffset = 0;
        int nitems = lgdItems.Count;
        switch (lgdLocation)
        {
          case LegendLocation.upper_right:
            xoffset = lgdInFrame ? 4 : FrameWidth + FrameRightOffset;
            p = new Point((int)(Width - xoffset - siz.Width - lgdLineSize - csiz), FrameTopOffset + FrameWidth);
            break;
          case LegendLocation.upper_left:
            xoffset = lgdInFrame ? 0 : FrameLeftOffset + FrameWidth;
            p = new Point((int)(xoffset + 2), FrameTopOffset + FrameWidth);
            break;
          case LegendLocation.lower_right:
            xoffset = lgdInFrame ? 4 : FrameWidth + FrameRightOffset;
            p = new Point((int)(Width - xoffset - siz.Width - lgdLineSize - csiz), (int)(Height - FrameBottomOffset - FrameWidth - (siz.Height + 2) * nitems));
            break;
          case LegendLocation.lower_left:
            xoffset = lgdInFrame ? 0 : FrameLeftOffset + FrameWidth;
            p = new Point((int)(xoffset + 2), (int)(Height - FrameBottomOffset - FrameWidth - (siz.Height + 2) * nitems));
            break;
          case LegendLocation.bottom:
            yoffset = lgdInFrame ? (int)(siz.Height) : FrameBottomOffset + FrameWidth;
            nitems = numLegendItems();
            p = new Point((int)(FrameRightOffset + 2 + FrameWidth + lgdLineSize), (int)(Height - yoffset - (siz.Height + 2) * nitems));
            break;
          case LegendLocation.top:
            yoffset = lgdInFrame ? 0 : FrameTopOffset + FrameWidth;
            p = new Point((int)(FrameRightOffset + 2 + FrameWidth + lgdLineSize), (int)(yoffset));
            break;
          default:
            p = new Point((int)(FrameLeftOffset + 2), this.FrameTopOffset);
            break;
        }
        return p;
      }
    }
    private int numLegendItems()
    {
      if (lgdLocation == LegendLocation.bottom)
      {
        int n = 1;
        float osiz = (FrameRightOffset + 2 + FrameWidth + lgdLineSize);
        float siz = osiz;
        foreach (LegendItem v in lgdItems)
        {
          if (siz + (int)(v.size.Width + lgdLineSize) > aFrame.histRect.Width)
          {
            siz = osiz;
            n++;
          }
          siz += v.size.Width + lgdLineSize + lghHorzSplitSize;
        }
        return n;
      }
      return lgdItems.Count;
    }
    private void applyLegend(Graphics g)
    {
      lock (lgdItems)
      {
        if (lgdItems.Count == 0) return;
        Point loc = getLegendLocation(g);
        int xStart = loc.X;
        foreach (LegendItem v in lgdItems)
        {
          if (lgdLocation == LegendLocation.bottom || lgdLocation == LegendLocation.top)
          {
            if (loc.X + (int)(v.size.Width + lgdLineSize) > aFrame.histRect.Width)
            {
              loc.X = xStart;
              loc.Y += (int)(lgdElementSize.Height + 2);
            }
          }
          drawLegendItem(g, loc, v.text, v.color, v.mode);
          if (lgdLocation == LegendLocation.bottom || lgdLocation == LegendLocation.top)
          {
            loc.X += (int)(v.size.Width + lgdLineSize + lghHorzSplitSize);
          }
          else
          {
            loc.Y += (int)(lgdElementSize.Height + 2);
          }
        }
      }
    }
    public void update(Graphics a)
    {
      this.paintComponent(a);
    }
    /* (non-Javadoc)
     * @see javax.swing.JComponent#paintComponent(java.awt.Graphics)
     */
    //  @Override
    protected void paintComponent(Graphics g2dima)
    {
      //super.paintComponent(g);
      //    java.awt.Graphics2D g2d = (Graphics2D) g;
      //    Graphics g2dima = (Graphics) g.create();
      Rectangle r = this.ClientRectangle;

      if (textAntiAliasing)
      {
        g2dima.TextRenderingHint = System.Drawing.Text.TextRenderingHint.AntiAlias;
        //        g2dima.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_ON);
      }
      else
      {
        g2dima.TextRenderingHint = System.Drawing.Text.TextRenderingHint.SingleBitPerPixel;
        //        g2dima.setRenderingHint(RenderingHints.KEY_TEXT_ANTIALIASING, RenderingHints.VALUE_TEXT_ANTIALIAS_DEFAULT);
      }

      int i;
      /* 2007 do not use double buffer any more hwu
          if (ima == null || r.Width != ima.getWidth() || r.Height != ima.getHeight())
          {
            // ima = new java.awt.image.BufferedImage(r.Width, r.Height,
            // BufferedImage.TYPE_INT_RGB);
            ima = new java.awt.image.BufferedImage(r.Width, r.Height, BufferedImage.TYPE_INT_ARGB);
            g2dima = ima.createGraphics();
          }
      */
      //    g2dima = g2d; //2007
      RectangleF Cliprect = g2dima.ClipBounds; // get original clip area

      // Ike: this method is not really painting background, but just clears it and in swint this
      // leaves white background
      backgroundPaint(g2dima, Rectangle.Round(Cliprect), r);

      // Ike: in swing you have to paint yourself your gackground
      //    g2dima.setColor(getBackground());
      //    g2dima.fillRect(0,0,ima.getWidth(),ima.getHeight());

      //2014-11     g2dima.setColor(aFrame.frameForeColor); // draw border
      if (frameBorderOn)
        g2dima.DrawRectangle(stroke, 0, 0, r.Width - 1, r.Height - 1);
      captionPaint(g2dima); // paint caption
      if (changeScaleWidth == 0) // prepare random data only once
      {
        scaleframe();
        /*
         * if ( Beans.isDesignTime() && randomData == true ) { prepareDraw();
         * System.out.println("DesignTime and RandomData"); }
         */
        changeScaleWidth = 1;
      }
      if (Cliprect == null || Cliprect.IntersectsWith(histRoundRect) == true)
      {
        //2014-11       g2dima.setColor(aFrame.frameForeColor);
        g2dima.DrawRectangle(stroke, histRoundRect.X, histRoundRect.Y, histRoundRect.Width, histRoundRect.Height);
      }
      drawhist(g2dima);
      //    drawtext(g2dima);
      //2014-11     g2dima.setStroke(stroke);
      if (isZoomedFlag && (Cliprect == null || Cliprect.IntersectsWith(aFrame.zoomIcon) == true))
      {
        //2014-11       g2dima.setColor(aFrame.frameForeColor);
        //2014-11      g2dima.setFont(aFrame.frameFont);
        g2dima.DrawRectangle(stroke, aFrame.zoomIcon.X, aFrame.zoomIcon.Y, aFrame.zoomIcon.Width, aFrame.zoomIcon.Height);
        g2dima.SetClip(aFrame.zoomIcon);//.clipRect(aFrame.zoomIcon.x, aFrame.zoomIcon.y, aFrame.zoomIcon.Width, aFrame.zoomIcon.Height);
        g2dima.TranslateTransform(aFrame.zoomIcon.X, aFrame.zoomIcon.Y);
        SizeF zStrSize;
        if ((zooming & 0x4) != 0)
        {
          zStrSize = g2dima.MeasureString(bufferedZoomRatio, aFrame.frameFont);
          g2dima.DrawString(bufferedZoomRatio, aFrame.frameFont, aFrame.framBrush, (aFrame.zoomIcon.Width - zStrSize.Width) / 2, aFrame.zoomIcon.Height - zStrSize.Height);
          //          g2dima.DrawString(bufferedZoomRatio, aFrame.frameFont, aFrame.framBrush, aFrame.zoomIcon.X + 1, aFrame.zoomIcon.Y
          //            + aFrame.zoomIcon.Height - 1);
        }
        else
        {
          zStrSize = g2dima.MeasureString(yZoomRatio, aFrame.frameFont);
          g2dima.DrawString(yZoomRatio, aFrame.frameFont, aFrame.framBrush, (aFrame.zoomIcon.Width - zStrSize.Width) / 2, aFrame.zoomIcon.Height - zStrSize.Height * 5 / 3);
          //          g2dima.DrawString(yZoomRatio, aFrame.frameFont, aFrame.framBrush, aFrame.zoomIcon.X + 1, aFrame.zoomIcon.Y + aFrame.zoomIcon.Width / 2);
          zStrSize = g2dima.MeasureString(xZoomRatio, aFrame.frameFont);
          g2dima.DrawString(xZoomRatio, aFrame.frameFont, aFrame.framBrush, (aFrame.zoomIcon.Width - zStrSize.Width) / 2, aFrame.zoomIcon.Height - zStrSize.Height * 4 / 5);
          //          g2dima.DrawString(xZoomRatio, aFrame.frameFont, aFrame.framBrush, aFrame.zoomIcon.X + 1, aFrame.zoomIcon.Y + aFrame.zoomIcon.Width - 1);
        }
        g2dima.TranslateTransform(-aFrame.zoomIcon.X, -aFrame.zoomIcon.Y);
        g2dima.SetClip(Cliprect);
      }
      if ((textFlag == true || (aFrame.drawFlag == true && histo[m_histstart].dismode != AcopConst.mode_textbox))
          && (fLeft > 0 || fRight > 0 || fBottom > 0 || fTop > 0))
      {
        for (i = 0; i < 3; i++)
        {
          if (i == 2 && sca[i].OnFlag == false) continue;
          sca[i].drawTicks(g2dima, histo[m_histstart]);
        }
      }
      drawtext(g2dima);
      if (zoomFlag && (Cliprect == null || Cliprect.IntersectsWith(zoomRect) == true))
      {
        //      g2dima.setXORMode(Color.DarkGray);
        //      BasicGraphicsUtils.drawDashedRect(g2dima, zoomRect.X, zoomRect.Y, zoomRect.Width, zoomRect.Height);

        ControlPaint.DrawReversibleFrame(theRectangle, Color.DarkGray, FrameStyle.Dashed);
        /*2014??
              theRectangle = new Rectangle(zoomRect.X, zoomRect.Y, zoomRect.Width, zoomRect.Height);
              ControlPaint.DrawReversibleFrame(theRectangle, Color.DarkGray, FrameStyle.Dashed);
        */
        //      g2dima.setPaintMode();
      }

      //    paintAnnotations(g2dima);
      // TODO Ike: not necessary to call inside paintComponent method, because children are painted inside
      // paintChildren method in parent JPanel
      //super.paint(g2dima); // paint all children
      /* 2007 do not use double buffer any more hwu   
          if (Cliprect == null)
            g2d.drawImage(ima, 0, 0, this);
          else
            g2d.drawImage(ima, Cliprect.x, Cliprect.y, Cliprect.x + Cliprect.Width, Cliprect.y + Cliprect.Height,
                Cliprect.x, Cliprect.y, Cliprect.x + Cliprect.Width, Cliprect.y + Cliprect.Height, this);
      */
      // MotifGraphicsUtils.drawStringInRect(a,caption,
      // frameWidth+frameLeftOffset,
      // 0,
      // titleRect.Width,
      // frameWidth,
      // MotifGraphicsUtils.CENTER);
      // todo. Add overriding code here.


      if (showLegend) applyLegend(g2dima);

    }
    /*  public void paintAll(java.awt.Graphics a)
      {
        // todo. Add overriding code here.
      }*/
    //  private void paintAnnotations(Graphics2D g) {
    //	  g.setFont(AcopHisto.ANNOTATION_FONT);
    //	  int xOffset = histRoundRect.x;
    //	  int yOffset = histRoundRect.y;
    //	  for (AcopHisto h : histo) {
    //		  if (h == null) continue;
    //		  int[] annotations = h.getAnnotationPoints();
    //		  if (annotations != null) {		  
    //    		  for (int i = 0; i < annotations.length; i++) {
    //		          if (h.dispOn[i] == 0) continue;
    //		          g.setColor(AcopHisto.ANNOTATION_COLOR);
    //		          g.fillRect(annotations[i]-3 + xOffset,yOffset-1-15,15,15);
    //		          g.setColor(h.penColor);
    //		          g.drawString(AcopHisto.ANNOTATION_TEXT,annotations[i]+xOffset,yOffset-3);
    //    		  }
    //		  }
    //	  }
    //  }

    /*
        private static void Main()
        {
            class DriveFrame: Frame
            {
                public Frame()
                {
                  this.SuspendLayout();
                  this.ResumeLayout(false);
                  setSize(400, 300);
                  add(new Acop());
                }
            }
            new DriveFrame.show();
        }
     */
    /*
     * public void addPropertyChangeListener(java.beans.PropertyChangeListener
     * pcl) { if (changes == null) changes = new
     * symantec.itools.beans.PropertyChangeSupport(this);
     * changes.addPropertyChangeListener("",pcl); } public void
     * removePropertyChangeListener(java.beans.PropertyChangeListener pcl) { if
     * (changes != null) changes.removePropertyChangeListener("",pcl); } public
     * void addVetoableChangeListener(java.beans.VetoableChangeListener vcl) { if
     * (veto == null) veto = new
     * symantec.itools.beans.VetoableChangeSupport(this);
     * veto.addVetoableChangeListener("",vcl); } public void
     * removeVetoableChangeListener(java.beans.VetoableChangeListener vcl) { if
     * (veto != null) veto.removeVetoableChangeListener("",vcl); }
     */
    /*
public synchronized void addAcopListener(AcopListener l)
{
if (!AcopListeners.contains(l)) AcopListeners.addElement(l);
}
public synchronized void removeAcopListener(AcopListener l)
{
if (AcopListeners.contains(l)) AcopListeners.removeElement(l);
}
    */
    // notify listening objects of Acop
    protected void notifyAcop(object sender, int id)
    {
      // create the event object
      if (id == AcopEvent.ACOP_ANNOATATION_EVENT || id == AcopEvent.ACOP_MOUSE_CLICK_EVENT || id == AcopEvent.ACOP_MOUSE_MOVE_EVENT
          || id == AcopEvent.ACOP_MOUSE_ENTER_EVENT || id == AcopEvent.ACOP_MOUSE_EXIT_EVENT
          || id == AcopEvent.ACOP_MOUSE_ZOOM_EVENT || id == AcopEvent.ACOP_MOUSE_DRAG_EVENT
          || id == AcopEvent.ACOP_MOUSE_DCLICK_EVENT || id == AcopEvent.ACOP_MOUSE_PRESSED_EVENT)
      {
        AcopEvent evt;
        if (id == AcopEvent.ACOP_MOUSE_ZOOM_EVENT)
          if (sca[2] != null)
            evt = new AcopEvent(this, id, sca[0].getMin(), sca[1].getMin(), sca[0].getMax(), sca[1].getMax(), sca[2].getMin(), sca[2].getMax());
          else
            evt = new AcopEvent(this, id, sca[0].getMin(), sca[1].getMin(), sca[0].getMax(), sca[1].getMax(), 0, 0);
        else /*if (id != AcopEvent.ACOP_RECEIVE_EVENT)*/
          evt = new AcopEvent(this, id, mouseIndex, mousepoint.X, mousepoint.Y, mouseConvert[0],
              mouseConvert[1], mouseConvert[2], mouseEvent, mouseArea);

        if (id == AcopEvent.ACOP_ANNOATATION_EVENT)
        {
          if (acopAnnotationClicked != null) acopAnnotationClicked(sender, evt);
        }
        else if (id == AcopEvent.ACOP_MOUSE_CLICK_EVENT)
        {
          if (acopClicked != null) acopClicked(sender, evt);
        }
        else if (id == AcopEvent.ACOP_MOUSE_DCLICK_EVENT)
        {
          if (acopDoubleClick != null) acopDoubleClick(sender, evt);
        }
        else if (id == AcopEvent.ACOP_MOUSE_MOVE_EVENT)
        {
          if (acopMsMove != null) acopMsMove(sender, evt);
        }
        else if (id == AcopEvent.ACOP_MOUSE_ENTER_EVENT)
        {
          if (acopMsEnter != null) acopMsEnter(sender, evt);
        }
        else if (id == AcopEvent.ACOP_MOUSE_EXIT_EVENT)
        {
          if (acopMsExit != null) acopMsExit(sender, evt);
        }
        else if (id == AcopEvent.ACOP_MOUSE_ZOOM_EVENT)
        {
          if (acopZoom != null) acopZoom(sender, evt);
        }
        else if (id == AcopEvent.ACOP_MOUSE_PRESSED_EVENT)
        {
          if (acopMsPressed != null) acopMsPressed(sender, evt);
        }
        else if (id == AcopEvent.ACOP_MOUSE_DRAG_EVENT)
        {
          if (acopMsDragged != null) acopMsDragged(sender, evt);
        }
        /*      else
                evt = new AcopEvent(this, id, 1, 1); // link id ans error
        */
        /*
                Vector v;
              synchronized (this)
              {
                v = (Vector) AcopListeners.clone();
              }
              // fire events
              int cnt = v.size();
              for (int i = 0; i < cnt; i++)
              {
                AcopListener client = (AcopListener) v.elementAt(i);
                if (id == AcopEvent.ACOP_MOUSE_CLICK_EVENT)
                  client.acopMouseClick(evt);
                else if (id == AcopEvent.ACOP_MOUSE_DCLICK_EVENT)
                  client.acopMouseDoubleClick(evt);
                else if (id == AcopEvent.ACOP_MOUSE_MOVE_EVENT)
                  client.acopMouseMove(evt);
                else if (id == AcopEvent.ACOP_MOUSE_ENTER_EVENT)
                  client.acopMouseEnter(evt);
                else if (id == AcopEvent.ACOP_MOUSE_EXIT_EVENT)
                  client.acopMouseExit(evt);
                else if (id == AcopEvent.ACOP_MOUSE_ZOOM_EVENT)
                  client.acopMouseZoom(evt);
                else if (id == AcopEvent.ACOP_MOUSE_PRESSED_EVENT) 
                  client.acopMousePressed(evt);
                //else if (id == AcopEvent.ACOP_RECEIVE_EVENT) client.AcopReceive(evt);
              }
         */
      }
    }
    public void notifyAcop(object sender, int id, int link, int code)
    {
      // create the event object
      if (id == AcopEvent.ACOP_ANNOATATION_EVENT || id == AcopEvent.ACOP_MOUSE_CLICK_EVENT || id == AcopEvent.ACOP_MOUSE_MOVE_EVENT
          || id == AcopEvent.ACOP_MOUSE_ENTER_EVENT || id == AcopEvent.ACOP_MOUSE_EXIT_EVENT
          || id == AcopEvent.ACOP_MOUSE_ZOOM_EVENT || id == AcopEvent.ACOP_MOUSE_DRAG_EVENT
        || id == AcopEvent.ACOP_MOUSE_DCLICK_EVENT || id == AcopEvent.ACOP_MOUSE_PRESSED_EVENT)
      {
        AcopEvent evt;
        if (id == AcopEvent.ACOP_MOUSE_ZOOM_EVENT)
        {
          if (sca[2] != null)
            evt = new AcopEvent(this, id, sca[0].min, sca[1].min, sca[0].max, sca[1].max, sca[2].min, sca[2].max);
          else
            evt = new AcopEvent(this, id, sca[0].min, sca[1].min, sca[0].max, sca[1].max, 0, 0);
        }
        else
        {
          evt = new AcopEvent(this, id, mouseIndex, mousepoint.X, mousepoint.Y, mouseConvert[0],
              mouseConvert[1], mouseConvert[2], mouseEvent, mouseArea);
        }

        if (id == AcopEvent.ACOP_ANNOATATION_EVENT)
        {
          if (acopAnnotationClicked != null) acopAnnotationClicked(sender, evt);
        }
        else if (id == AcopEvent.ACOP_MOUSE_CLICK_EVENT)
        {
          if (acopClicked != null) acopClicked(sender, evt);
        }
        else if (id == AcopEvent.ACOP_MOUSE_DCLICK_EVENT)
        {
          if (acopDoubleClick != null) acopDoubleClick(sender, evt);
        }
        else if (id == AcopEvent.ACOP_MOUSE_MOVE_EVENT)
        {
          if (acopMsMove != null) acopMsMove(sender, evt);
        }
        else if (id == AcopEvent.ACOP_MOUSE_ENTER_EVENT)
        {
          if (acopMsEnter != null) acopMsEnter(sender, evt);
        }
        else if (id == AcopEvent.ACOP_MOUSE_EXIT_EVENT)
        {
          if (acopMsExit != null) acopMsExit(sender, evt);
        }
        else if (id == AcopEvent.ACOP_MOUSE_ZOOM_EVENT)
        {
          if (acopZoom != null) acopZoom(sender, evt);
        }
        else if (id == AcopEvent.ACOP_MOUSE_PRESSED_EVENT)
        {
          if (acopMsPressed != null) acopMsPressed(sender, evt);
        }
        else if (id == AcopEvent.ACOP_MOUSE_DRAG_EVENT)
        {
          if (acopMsDragged != null) acopMsDragged(sender, evt);
        }

        /*
              Vector v;
              synchronized (this)
              {
                v = (Vector) AcopListeners.clone();
              }
 
              // fire events
              int cnt = v.size();
              for (int i = 0; i < cnt; i++)
              {
                AcopListener client = (AcopListener) v.elementAt(i);
                if (id == AcopEvent.ACOP_MOUSE_CLICK_EVENT)
                  client.acopMouseClick(evt);
                else if (id == AcopEvent.ACOP_MOUSE_DCLICK_EVENT)
                  client.acopMouseDoubleClick(evt);
                else if (id == AcopEvent.ACOP_MOUSE_MOVE_EVENT)
                  client.acopMouseMove(evt);
                else if (id == AcopEvent.ACOP_MOUSE_ENTER_EVENT)
                  client.acopMouseEnter(evt);
                else if (id == AcopEvent.ACOP_MOUSE_EXIT_EVENT)
                  client.acopMouseExit(evt);
                else if (id == AcopEvent.ACOP_MOUSE_ZOOM_EVENT)
                  client.acopMouseZoom(evt);
                else if (id == AcopEvent.ACOP_MOUSE_PRESSED_EVENT) 
                    client.acopMousePressed(evt);
                //else if (id == AcopEvent.ACOP_RECEIVE_EVENT) client.AcopReceive(evt);
              }
        */
      }
    }
    private void setCursorMarkerColor(Color cursorMarkerColor)
    {
      // cursorColor = ~(TranslateColor(m_cursorMarkerColor) ^
      // TranslateColor(GetBackColor())) & 0xffffff;
      if (m_cursorMarkerColor == cursorMarkerColor) return;
      Color oldValue = m_cursorMarkerColor;
      m_cursorMarkerColor = cursorMarkerColor;
      //    rev_cursorMarkerColor = new Color(~m_cursorMarkerColor.getRGB());
      rev_cursorMarkerColor = Color.FromArgb(~m_cursorMarkerColor.ToArgb() ^ ~backColor.ToArgb());
      //    rev_cursorMarkerColor = new Color(~m_cursorMarkerColor.getRGB() ^ ~backColor.getRGB());
      if (m_cursorMarkerMode != 0 && aFrame.drawFlag) repaintHisto();
      OnPropertyChanged("cursorMarkerColor");
    }
    private Color getCursorMarkerColor()
    {
      return m_cursorMarkerColor;
    }
    public enum AcopMarkerModeEnum
    {
      None = 0,
      Horizontal = 1,
      Vertical = 2,
      CrossHair = 3
    }
    AcopMarkerModeEnum getAcopMarkerModeFromInt(int m)
    {
      if (Enum.IsDefined(typeof(AcopMarkerModeEnum), m)) return (AcopMarkerModeEnum)m;
      return AcopMarkerModeEnum.None;
    }
    AcopMarkerModeEnum getAcopCursorMarkerMode()
    {
      return getAcopMarkerModeFromInt(m_cursorMarkerMode);
    }
    private void setAcopCursorMarkerMode(AcopMarkerModeEnum m)
    {
      setCursorMarkerMode((int)m);
    }
    private void setCursorMarkerMode(int cursorMarkerMode)
    {
      cursorMarkerMode = (cursorMarkerMode < 0 || cursorMarkerMode > 3) ? 0 : cursorMarkerMode;
      if (m_cursorMarkerMode == cursorMarkerMode) return;
      int oldValue = m_cursorMarkerMode;
      m_cursorMarkerMode = cursorMarkerMode;
      if (m_cursorMarkerMode != 0 && histRoundRect.Contains(mMovePoint) == false)
      {
        mMovePoint.X = histRoundRect.X + histRoundRect.Width / 2;
        mMovePoint.Y = histRoundRect.Y + histRoundRect.Height / 2;
      }
      if (aFrame.drawFlag) repaintHisto();
      OnPropertyChanged("cursorMarkerMode");
    }
    private int getCursorMarkerMode()
    {
      return this.m_cursorMarkerMode;
    }
    private void setCursorMarkerStyle(int cursorMarkerStyle)
    {
      if (m_cursorMarkerStyle == cursorMarkerStyle) return;
      int oldValue = m_cursorMarkerStyle;
      m_cursorMarkerStyle = cursorMarkerStyle;
      cursorMarkerStroke = AcopConst.createStroke(m_cursorMarkerColor, m_cursorMarkerWidth, m_cursorMarkerStyle);
      if (m_cursorMarkerMode != 0 && aFrame.drawFlag) repaintHisto();
      OnPropertyChanged("cursorMarkerStyle");
    }
    private int getCursorMarkerStyle()
    {
      return m_cursorMarkerStyle;
    }
    private void setCursorMarkerWidth(int cursorMarkerWidth)
    {
      if (m_cursorMarkerWidth == cursorMarkerWidth) return;
      int oldValue = m_cursorMarkerWidth;
      m_cursorMarkerWidth = cursorMarkerWidth;
      cursorMarkerStroke = AcopConst.createStroke(m_cursorMarkerColor, m_cursorMarkerWidth, m_cursorMarkerStyle);
      if (m_cursorMarkerMode != 0 && aFrame.drawFlag) repaintHisto();
      OnPropertyChanged("cursorMarkerWidth");
    }
    private int getCursorMarkerWidth()
    {
      return m_cursorMarkerWidth;
    }
    private void setCursorMarkerXExtent(double cursorMarkerXExtent)
    {
      if (m_cursorMarkerXExtent == cursorMarkerXExtent) return;
      double oldValue = m_cursorMarkerXExtent;
      m_cursorMarkerXExtent = cursorMarkerXExtent;
      cursorXPercent = -1;
      if (m_cursorMarkerMode != 0 && aFrame.drawFlag) repaintHisto();
      OnPropertyChanged("cursorMarkerXExtent");
    }
    private double getCursorMarkerXExtent()
    {
      return m_cursorMarkerXExtent;
    }
    private void setCursorMarkerYExtent(double cursorMarkerYExtent)
    {
      if (m_cursorMarkerYExtent == cursorMarkerYExtent) return;
      double oldValue = m_cursorMarkerYExtent;
      m_cursorMarkerYExtent = cursorMarkerYExtent;
      cursorYPercent = -1;
      if (m_cursorMarkerMode != 0 && aFrame.drawFlag) repaintHisto();
      OnPropertyChanged("cursorMarkerYExtent");
    }
    private double getCursorMarkerYExtent()
    {
      return m_cursorMarkerYExtent;
    }
    AcopMarkerModeEnum getAcopMarkerMode()
    {
      return getAcopMarkerModeFromInt(m_markerMode);
    }
    private void setAcopMarkerMode(AcopMarkerModeEnum m)
    {
      setMarkerMode((int)m);
    }
    private void setMarkerColor(Color markerColor)
    {
      if (m_markerColor == markerColor) return;
      Color oldValue = m_markerColor;
      m_markerColor = markerColor;
      if (m_markerMode == 0 && aFrame.drawFlag) repaintHisto();
      OnPropertyChanged("markerColor");
    }
    private Color getMarkerColor()
    {
      return m_markerColor;
    }
    private void setMarkerMode(int markerMode)
    {
      markerMode = (markerMode < 0 || markerMode > 3) ? 0 : markerMode;
      if (this.m_markerMode == markerMode) return;
      int oldValue = m_markerMode;
      m_markerMode = markerMode;
      if (aFrame.drawFlag) repaintHisto();
      OnPropertyChanged("markerMode");
    }
    private int getMarkerMode()
    {
      return this.m_markerMode;
    }
    private void setMarkerStyle(int markerStyle)
    {
      if (this.m_markerStyle == markerStyle) return;
      int oldValue = m_markerStyle;
      m_markerStyle = markerStyle;
      OnPropertyChanged("markerStyle");
    }
    private int getMarkerStyle()
    {
      return this.m_markerStyle;
    }
    private void setMarkerWidth(int markerWidth)
    {
      if (this.m_markerWidth == markerWidth) return;
      int oldValue = m_markerWidth;
      m_markerWidth = markerWidth;
      OnPropertyChanged("markerWidth");
    }
    private int getMarkerWidth()
    {
      return this.m_markerWidth;
    }
    private void setMarkerXExtent(double markerXExtent)
    {
      if (this.m_markerXExtent == markerXExtent) return;
      double oldValue = m_markerXExtent;
      m_markerXExtent = markerXExtent;
      OnPropertyChanged("markerXExtent");
    }
    private double getMarkerXExtent()
    {
      return this.m_markerXExtent;
    }
    private void setMarkerYExtent(double markerYExtent)
    {
      if (this.m_markerYExtent == markerYExtent) return;
      double oldValue = m_markerYExtent;
      m_markerYExtent = markerYExtent;
      OnPropertyChanged("markerYExtent");
    }
    private double getMarkerYExtent()
    {
      return this.m_markerYExtent;
    }
    /// <summary>
    /// Assigns an 'error' window range to all displays. Data plotted 'outside' the window are shown in the error color.
    /// </summary>
    /// <param name="XMax">The maximum non-error X value.</param>
    /// <param name="XMin">The minimum non-error X value.</param>
    /// <param name="YMax">The maximum non-error Y value.</param>
    /// <param name="YMin">The minimum non-error Y value.</param>
    /// <returns></returns>
    public int ErrorWindow(double XMax, double XMin, double YMax, double YMin)
    {
      return ErrorWindow(-1, XMax, XMin, YMax, YMin);
    }
    /// <summary>
    /// Assigns an 'error' window range to the display given. Data plotted 'outside' the window are shown in the error color.
    /// </summary>
    /// <param name="hDisplay">The display handle of the curve to apply the error window (returned from Draw() method). '-1' applies to all curves.</param>
    /// <param name="XMax">The maximum non-error X value.</param>
    /// <param name="XMin">The minimum non-error X value.</param>
    /// <param name="YMax">The maximum non-error Y value.</param>
    /// <param name="YMin">The minimum non-error Y value.</param>
    /// <returns></returns>
    public int ErrorWindow(int hDisplay, double XMax, double XMin, double YMax, double YMin)
    {
      int i, start, stop, on;
      // out of range, -1 to set for default value
      if (hDisplay < -1 || hDisplay > n_display) return -1;
      on = 0;
      start = hDisplay;
      stop = hDisplay + 1;
      if (hDisplay == -1) // set all
      {
        start = 0;
        stop = n_display;
        e_xmax = XMax; // set default
        e_xmin = XMin;
        e_ymax = YMax;
        e_ymin = YMin;
      }
      for (i = start; i < stop; i++)
      {
        if (histo[i] == null) break;
        histo[i].err_xmax = XMax;
        histo[i].err_xmin = XMin;
        histo[i].err_ymax = YMax;
        histo[i].err_ymin = YMin;
        if (histo[i].errWindowEnable && histo[i].displayON != 0) on = 1;
      }
      if (aFrame.drawFlag && on != 0) repaintHisto();
      return 0;
    }
    private void setErrorColor(Color errorColor)
    {
      if (m_errorColor == errorColor) return;
      Color oldValue = m_errorColor;
      m_errorColor = errorColor;
      if (histo[lastDisp] != null) histo[lastDisp].errorColor = m_errorColor;
      OnPropertyChanged("errorColor");
    }
    private Color getErrorColor()
    {
      return m_errorColor;
    }
    private void setTagColor(Color tagColor)
    {
      if (m_tagColor == tagColor) return;
      Color oldValue = m_tagColor;
      m_tagColor = tagColor;
      for (int i = 0; i < n_display; i++)
      {
        if (histo[i] == null) break;
        histo[i].tagColor = m_tagColor;
      }
      OnPropertyChanged("tagColor");
    }
    private Color getTagColor()
    {
      return m_tagColor;
    }
    private void setTagWidth(int tagWidth)
    {
      if (this.m_tagWidth == tagWidth) return;
      int oldValue = m_tagWidth;
      m_tagWidth = tagWidth;
      OnPropertyChanged("tagWidth");
    }
    private int getTagWidth()
    {
      return this.m_tagWidth;
    }
    private void setTagging(Boolean tagging)
    {
      if (this.m_tagging == tagging) return;
      this.m_tagging = tagging;
      if (aFrame.drawFlag) repaintHisto();
      OnPropertyChanged("tagging");
    }
    private Boolean isTagging()
    {
      return this.m_tagging;
    }
    /// <summary>
    /// Clears any histogram tags from the all displays
    /// </summary>
    public void ClearTags()
    {
      ClearTags(-1);
    }
    /// <summary>
    /// Clears any histogram tags from the given display
    /// </summary>
    /// <param name="hDisplay">The display handle of the curve whose tags are to be cleared (returned from Draw() method). '-1' clears all tags from all curves.</param>
    public void ClearTags(int hDisplay)
    {
      int i, j, ok, start, stop;
      if (pTagColorArray == null) return; // no histogram at all!
      if (hDisplay >= 0 && hDisplay < n_display) // tag one histogram only!
      {
        start = n_display;
        stop = start + 1;
      }
      else
      {
        start = 0;
        stop = n_display;
      }
      ok = 0;
      for (j = start; j < stop; j++) // clear all histogram tagging array!!
      {
        if (histo[j] == null) break;
        if (histo[j].dismode == AcopConst.mode_histogram
            || histo[j].dismode == AcopConst.mode_histogram_rastoring
            || histo[j].dismode == AcopConst.mode_dots || histo[j].dismode == AcopConst.mode_rectangle
            || histo[j].dismode == AcopConst.mode_circle)
        {
          ok = 1;
          for (i = 0; i < histo[j].npoints; i++)
            histo[j].m_tagColorArray[i] = histo[j].vorColor;
        }
      }
      if (ok != 0 && m_tagging && aFrame.drawFlag) repaintHisto();
    }
    internal void repaintHisto()
    {
      this.Invalidate(histRoundRect);
    }
    // read global marker flag
    private Boolean marker()
    {
      return m_marker != 0 ? true : false;
    }
    /// <summary>
    /// Gets the display marker setting for the display indicated.
    /// </summary>
    /// <param name="hDisplay">The display handle of the curve to retrieve the marker setting from (returned from Draw() method). '-1' applies to all curves.</param>
    /// <returns>The display marker setting for the display indicated</returns>
    public Boolean GetMarker(int hDisplay)
    {
      if (hDisplay < 0 || hDisplay >= n_display)
        return marker();
      else if (histo[hDisplay] == null)
        return false;
      else
        return histo[hDisplay].markerFlag != 0 ? true : false;
    }
    // set marker flag for all displays shown
    private Boolean marker(Boolean MarkerOn)
    {
      return SetMarker(MarkerOn, -1);
    }
    /// <summary>
    /// Sets the display marker setting for the display indicated.
    /// </summary>
    /// <param name="MarkerOn">The disired marker display setting.</param>
    /// <param name="hDisplay">The display handle of the curve to apply the marker setting (returned from Draw() method). '-1' applies to all curves.</param>
    /// <returns>The display marker setting for the display indicated</returns>
    public Boolean SetMarker(Boolean MarkerOn, int hDisplay)
    {
      int num, ende;
      m_marker = MarkerOn ? 2 : 0; // mark what you see!
      num = hDisplay;
      if (num < 0 || num >= n_display)
      {
        num = 0;
        ende = n_display - 1;
      }
      else
        ende = num;
      for (; num <= ende; num++)
      {
        if (histo[num] == null) continue;
        if (m_marker == 0)
          histo[num].markerFlag = 0;
        else if (histo[num].displayON != 0) histo[num].markerFlag = 1;
      }
      if (m_marker == 2) setmarkerflag(1); // copy once only
      // prepareDraw(FALSE, -1, FALSE, 0);
      if (aFrame.drawFlag)
        prepareDraw(); // dont scale keep old limit
      else
        changeScaleWidth = 0;
      return m_marker != 0 ? true : false;
    }
    /// <summary>
    /// Gets tagging on the display and index given (depending on the draw mode).
    /// </summary>
    /// <param name="index">is the array index for which the tagging information is desired</param>
    /// <param name="hDisplay">is the display handle for which the tagging information is desired</param>
    /// <returns>tagging setting on the display and index given</returns>
    public Boolean IsTagged(int index, int hDisplay)
    {
      return isTagged(index, -1, hDisplay);
    }
    /// <summary>
    /// Gets the tagging setting for the index given.
    /// </summary>
    /// <param name="index">is the array index for which the tagging information is desired</param>
    /// <returns>the tagging setting for the index given</returns>
    public Boolean IsTagged(int index)
    {
      if (n_display < 1) return false;
      return isTagged(index, -1, -1);
    }
    /// <summary>
    /// Gets the global tagging setting.
    /// </summary>
    /// <returns>the global tagging setting</returns>
    public Boolean IsTagged()
    {
      if (n_display < 1) return false;
      return isTagged(-1, -1, -1);
    }
    /// <summary>
    /// Sets tagging on the display and index given (depending on the draw mode).
    /// </summary>
    /// <param name="index">is the array index for which to apply the tagging</param>
    /// <param name="hDisplay">is the display handle for which to apply the tagging</param>
    /// <param name="value">true => apply tagging</param>
    /// <returns>the current setting</returns>
    public Boolean IsTagged(int index, int hDisplay, Boolean value)
    {
      if (n_display < 1) return false;
      return isTagged(index, value ? 1 : 0, hDisplay);
    }
    private Boolean isTagged(int index, int value, int hDisplay)
    {
      Boolean tagon;
      int j, found, lasfDisp, lastTagON, start, stop;
      if (pTagColorArray == null) return false; // no hoistogram at all!
      if (index < -1) index = -1;
      found = 0;
      lastTagON = -1;
      if (hDisplay >= 0 && hDisplay < n_display) // tag one histogram only!
      {
        start = hDisplay;
        stop = start + 1;
      }
      else
      {
        start = 0;
        stop = n_display;
      }
      tagon = value == 1 ? true : false; // setting
      for (j = start; j < stop; j++) // loop all histograms to mark tagging color
      {
        if (histo[j] == null) break;
        if (histo[j].dismode == AcopConst.mode_histogram
            || histo[j].dismode == AcopConst.mode_histogram_rastoring
            || histo[j].dismode == AcopConst.mode_dots || histo[j].dismode == AcopConst.mode_rectangle
            || histo[j].dismode == AcopConst.mode_circle)
        {
          if (index >= histo[j].npoints) continue; // out of range
          if (found == 0) // first found
          {
            if (value < 0 || value > 1)
              // reading
              return index == -1 ? m_tagging : (histo[j].m_tagColorArray[index] == histo[j].vorColor ? false
                  : true);
            found = 1;
            lasfDisp = j;
          }
          if (index != -1) // set color for this index only
            histo[j].m_tagColorArray[index] = tagon ? histo[j].tagColor : histo[j].vorColor;
          else
            // set color for all indexes
            for (int i = 0; i < histo[j].npoints; i++)
              histo[j].m_tagColorArray[i] = tagon ? histo[j].tagColor : histo[j].vorColor;
          if (histo[j].tagHist != 0) lasfDisp = j;
          if (j == lastTagHisto && histo[j].displayON != 0) lastTagON = j;
        }
      }
      if (found == 0) return false;
      // last recalled, refreshed or drawed, and still be seen on screen
      if (lastTagON >= 0) lastDisp = lastTagON;
      if (m_tagging && aFrame.drawFlag)
      {
        if (index == -1)
          repaintHisto();
        else
        {
          int xpos, left, right, low = 0, high = 0;
          // loop all histograms to mark tagging color
          for (lasfDisp = start; lasfDisp < stop; lasfDisp++)
          {
            if (histo[lasfDisp] == null) break;
            if (index >= histo[lasfDisp].npoints) continue; // out of range
            xpos = histo[lasfDisp].ix[index];
            if (histo[lasfDisp].dismode == AcopConst.mode_histogram
                || histo[lasfDisp].dismode == AcopConst.mode_histogram_rastoring)
            {
              left = xpos - histo[lasfDisp].penWidth;
              right = xpos + histo[lasfDisp].penWidth;
            }
            else
            {
              left = xpos - histo[lasfDisp].xextent;
              right = xpos + histo[lasfDisp].xextent;
            }
            if (lasfDisp == start)
            {
              low = left;
              high = right;
              continue;
            }
            if (low > left) low = left;
            if (high < right) high = right;
          }
          tagRect.X = low + aFrame.histRect.X;
          tagRect.Width = high - low;
          repaintTagging();
        }
      }
      return tagon;
    }
    protected internal void repaintTagging()
    {
      this.Invalidate(tagRect);
    }
    public int GetTaggedColor(Color[] ColorArray, int Npoints, int StartIndex, int hDisplay)
    {
      int num, start, ndata;
      int i, j, k;
      if (hDisplay < 0 || hDisplay >= n_display || histo[hDisplay] == null
          || histo[hDisplay].m_tagColorArray == null) return -1;
      num = Npoints; // number of points, at least 1 point
      if (num < 1) num = histo[hDisplay].npoints;
      start = StartIndex; // start point: 0 to (npoints-1)
      if (start < 0 || start >= histo[hDisplay].npoints) return -8;
      if (num + start > histo[hDisplay].npoints) num = histo[hDisplay].npoints - start;
      num += start;
      if (ColorArray == null) return -2;
      ndata = ColorArray.Length;
      if (ndata < num - start) num = start + ndata;
      for (k = start; k < num; k++)
      {
        i = k - start;
        j = k < histo[hDisplay].npoints ? k : (k - histo[hDisplay].npoints);
        ColorArray[i] = histo[hDisplay].m_tagColorArray[j];
      }
      return num - start; // return number of valid data
    }

    public void SetForeground(Color c)
    {
      //    super.setForeground(c);
      if (foreColor == c) return;
      //Color oldValue = foreColor;
      Color oldValue = this.ForeColor;
      this.ForeColor = c; // super.setForeground(c);
      foreColor = c;
      if (randomData == true)
      {
        rescaleFlag = 2;
        prepareDraw(); // rescale and reset limit
      }
      //    OnPropertyChanged("foreColor", oldValue, foreColor);
      OnPropertyChanged("foreground");
    }

    public Color GetForeground()
    {
      return foreColor;
    }
    private void setBackground(Color c)
    {
      if (backColor == c) return;
      Color oldValue = this.BackColor;    // getBackground();
      this.BackColor = c; // super.setBackground(c);
      // cursorColor = ~(TranslateColor(m_cursorMarkerColor) ^ TranslateColor(GetBackColor())) & 0xffffff;
      if (m_cursorMarkerColor != null) rev_cursorMarkerColor = Color.FromArgb(~m_cursorMarkerColor.ToArgb() ^ ~c.ToArgb());
      //    if (m_cursorMarkerColor != null) rev_cursorMarkerColor = new Color(~m_cursorMarkerColor.getRGB() ^ ~c.getRGB());
      backColor = c;
      backBrush = new SolidBrush(this.BackColor);
      OnPropertyChanged("background");
    }
    private Color getBackground()
    {
      return backColor;
    }

    // private symantec.itools.beans.PropertyChangeSupport changes = null;
    // private symantec.itools.beans.VetoableChangeSupport veto = null;

    /*
public PopupManager getPopupManager()
{
if (popupManager == null) {
  popupManager = new PopupManager(this, false);
  popupManager.addAction(new AbstractAction("Preferences...") {
    private static final long serialVersionUID = 1L;

      public void actionPerformed(ActionEvent e)
      {
        getCustomizer().showDialog();
      }
    });
}

return popupManager;
}
*/
    private Boolean IsPopupEnabled()
    {
      return popupEnabled;
    }

    private void SetPopupEnabled(Boolean enabled)
    {
      if (popupEnabled == enabled) return;
      popupEnabled = enabled;
      if (enabled)
      {
        // do dothing! 2014-11
        //			addMouseListener(getPopupManager().getMouseHook());
      }
      else
      {
        //			removeMouseListener(getPopupManager().getMouseHook());
      }
      OnPropertyChanged("popupEnabled");
    }
    /**
     * Returns the Customizer instance for this component.
     *
     * @return the Customizer instance for this component.
     */
    //	public AbstractCustomizerPanel getCustomizer()
    //	{
    //		if (customizer == null) {
    //			customizer = AbstractCustomizerPanel.findCustomizer(this);
    //			customizer.setObject(this);
    //		}
    //
    //		return customizer;
    //	}

    public Boolean isZoomFlag()
    {
      return zoomFlag;
    }
    /// <summary>
    /// If 'ForceWidth' is not true then the pen width setting is allowed to
    /// diminish when a large number of points are plotted.  Otherwise the 
    /// requested pen width is used even for a huge amount of data.
    /// </summary>
    /// <param name="value">the desired setting</param>
    public void SetForceWidth(Boolean value)
    {
      if (forceWidth == value) return;
      this.forceWidth = value;
      OnPropertyChanged("forceWidth");
    }
    /// <summary>
    /// If 'ForceWidth' is not true then the pen width setting is allowed to
    /// diminish when a large number of points are plotted. Otherwise the 
    /// requested pen width is used even for a huge amount of data.
    /// </summary>
    /// <returns>the current setting</returns>

    public Boolean IsForceWidth()
    {
      return forceWidth;
    }
    /* first Para: FFT Parameter, fitted results, the last: residual standard deviation of least Chi Square fit */
    public double[] GetCurveFitResults(int hDisplay)
    {
      return histo[hDisplay].curveFitResults;
    }
    public int[] GetAnnotations(int handle)
    {
      return histo[handle].getAnnotationPoints();
    }
    public int[] GetStatuses(int handle)
    {
      return histo[handle].getStatusPoints();
    }
    /// <summary>
    /// Gets the maximum Y (vertical) axis data value plotted on the chart for the display indicated.
    /// </summary>
    /// <param name="hDisplay">Is the display handle of the acop display for which the data are desired (returned via a call to Draw()).</param>
    /// <returns>The maximum data value for the display indicated.</returns>
    public double GetYDataMax(int hDisplay)
    {
      return histo[hDisplay].getYDataMax(true);
    }
    /// <summary>
    /// Gets the minimum Y (vertical) axis data value plotted on the chart for the display indicated.
    /// </summary>
    /// <param name="hDisplay">Is the display handle of the acop display for which the data are desired (returned via a call to Draw()).</param>
    /// <returns>The minimum data value for the display indicated.</returns>
    public double GetYDataMin(int hDisplay)
    {
      return histo[hDisplay].getYDataMin(true);
    }
    /// <summary>
    /// Gets the mean value of the Y (vertical) axis data plotted on the chart for the display indicated.
    /// </summary>
    /// <param name="hDisplay">Is the display handle of the acop display for which the data are desired (returned via a call to Draw()).</param>
    /// <returns>The mean data value for the display indicated.</returns>
    public double GetYDataMean(int hDisplay)
    {
      return histo[hDisplay].getYDataMean(true);
    }
    /// <summary>
    /// Gets the root mean squared (RMS) value of the Y (vertical) axis data plotted on the chart for the display indicated.
    /// </summary>
    /// <param name="hDisplay">Is the display handle of the acop display for which the data are desired (returned via a call to Draw()).</param>
    /// <returns>The rms data value for the display indicated.</returns>
    public double GetYDataRms(int hDisplay)
    {
      return histo[hDisplay].getYDataRms(true);
    }
    /// <summary>
    /// Gets the standard deviation value of the Y (vertical) axis data plotted on the chart for the display indicated.
    /// </summary>
    /// <param name="hDisplay">Is the display handle of the acop display for which the data are desired (returned via a call to Draw()).</param>
    /// <returns>The standard deviation of the data for the display indicated.</returns>
    public double GetYDataStdDiv(int hDisplay)
    {
      return histo[hDisplay].getYDataStdDiv(true);
    }
    /// <summary>
    /// Gets the maximum X (horizontal) axis data value plotted on the chart for the display indicated.
    /// </summary>
    /// <param name="hDisplay">Is the display handle of the acop display for which the data are desired (returned via a call to Draw()).</param>
    /// <returns>The maximum data value for the display indicated.</returns>
    public double GetXDataMax(int hDisplay)
    {
      return histo[hDisplay].getYDataMax(false);
    }
    /// <summary>
    /// Gets the minimum X (horizontal) axis data value plotted on the chart for the display indicated.
    /// </summary>
    /// <param name="hDisplay">Is the display handle of the acop display for which the data are desired (returned via a call to Draw()).</param>
    /// <returns>The minimum data value for the display indicated.</returns>
    public double GetXDataMin(int hDisplay)
    {
      return histo[hDisplay].getYDataMin(false);
    }
    /// <summary>
    /// Gets the mean value of the X (horizontal) axis data plotted on the chart for the display indicated.
    /// </summary>
    /// <param name="hDisplay">Is the display handle of the acop display for which the data are desired (returned via a call to Draw()).</param>
    /// <returns>The mean data value for the display indicated.</returns>
    public double GetXDataMean(int hDisplay)
    {
      return histo[hDisplay].getYDataMean(false);
    }
    /// <summary>
    /// Gets the root mean squared (RMS) value of the X (horizontal) axis data plotted on the chart for the display indicated.
    /// </summary>
    /// <param name="hDisplay">Is the display handle of the acop display for which the data are desired (returned via a call to Draw()).</param>
    /// <returns>The rms data value for the display indicated.</returns>
    public double GetXDataRms(int hDisplay)
    {
      return histo[hDisplay].getYDataRms(false);
    }
    /// <summary>
    /// Gets the standard deviation value of the X (horizontal) axis data plotted on the chart for the display indicated.
    /// </summary>
    /// <param name="hDisplay">Is the display handle of the acop display for which the data are desired (returned via a call to Draw()).</param>
    /// <returns>The standard deviation of the data for the display indicated.</returns>
    public double GetXDataStdDiv(int hDisplay)
    {
      return histo[hDisplay].getYDataStdDiv(false);
    }
    /// <summary>
    /// Gets the current X (horizontal) data value at the cursor for the display indicated.
    /// </summary>
    /// <param name="hDisplay">Is the display handle of the acop display for which the data are desired (returned via a call to Draw()).</param>
    /// <returns>the current X data Value at the cursor for the display indicated.</returns>
    public double GetCursorXValue(int hDisplay)
    {
      histo[hDisplay].getMousePosition(new Point(cursorwy, cursorwx), mouseConvert);
      return mouseConvert[0];
    }
    public void lockCursorToCurrentScreenPosition(Boolean locked)
    {
      if (cursorLockedToCurrentScreenPosition == locked) return;
      cursorLockedToCurrentScreenPosition = locked;
      cursorStay = locked ? 0 : 1;
      if (!cursorLockedToCurrentScreenPosition)
      {
        LockCursorMarker(false);
      }
    }
    /// <summary>
    /// Gives the cursor position in pixels.
    /// </summary>
    /// <returns>The cursor position in pixels.</returns>
    public int GetCursorXPosition()
    {
      return cursorwy;
    }
    /// <summary>
    /// Sets the cursor marker position.
    /// </summary>
    /// <param name="cursor"></param>
    public void SetCursorXPosition(int cursor)
    {
      mMovePoint.X = cursor;
      if (aFrame.drawFlag) repaintHisto();
      drawCursorMarker(null, new Point(cursor, cursorwx));
    }
    private void setPrintTextLine(Boolean print)
    {
      if (this.printTextLine == print) return;
      this.printTextLine = print;
      this.Invalidate();
      OnPropertyChanged("printTextLine");
    }
    private Boolean isPrintTextLine()
    {
      return printTextLine;
    }
    private void setAppendLineIndexInTextMode(Boolean append)
    {
      if (appendLineIndexInTextMode == append) return;
      this.appendLineIndexInTextMode = append;
      OnPropertyChanged("appendLineIndexInTextMode");
    }
    private Boolean isAppendLineIndexInTextMode()
    {
      return appendLineIndexInTextMode;
    }
    /// <summary>
    /// Gives the index of the zooming area
    /// </summary>
    /// <returns>The index of the zooming area (how many zoom ins have been performed from the original data area)</returns>
    public int GetZoomIndex()
    {
      return zoomIndex;
    }
    /// <summary>
    /// Applies a persisence to 'cleared' displays (analogous to clearing with a 'KeepDepth').
    /// </summary>
    /// <param name="hDisplay">The display handle of the curve to apply persisence (returned from Draw() method). '-1' applies to all curves.</param>
    /// <param name="depth">Is the 'keep' depth of the cleared displays(non-volatile).</param>
    /// <param name="memCopy">If true will actually maintain cleared displays in memory up to the depth given.</param>
    /// <param name="endlessFlag">If true will maintain 'graphical' persistence.  A 'volatile' conditions which disappears when the dispalyed window is invalidated.</param>
    /// <param name="persistColor">Is the desired color of the persistence display.</param>
    /// <returns>Returns 0 is successful.</returns>
    public int PersistScreen(int hDisplay, int depth, Boolean memCopy, Boolean endlessFlag, Color persistColor)
    {
      int i;
      if (depth <= 1) depth = 1;
      for (i = 0; i < AcopConst.MAX_PERSIST; i++)
      {
        if (persist[i] == null) break;
        if (persist[i].hisIndex == hDisplay) break;
      }
      if (i >= AcopConst.MAX_PERSIST || persist[i] == null)
        for (i = 0; i < AcopConst.MAX_PERSIST; i++)
        {
          if (persist[i] == null) break;
          if (persist[i].hisIndex < 0) break;
        }
      if (i >= AcopConst.MAX_PERSIST) return -3;
      else if (persist[i] == null) persist[i] = new AcopPesist(this, hDisplay);
      else persist[i].hisIndex = hDisplay;

      return persist[i].initPesist(depth, memCopy, endlessFlag, persistColor);
    }
    /// <summary>
    /// Applies a persisence to 'cleared' displays (analogous to clearing with a 'KeepDepth').
    /// </summary>
    /// <param name="hDisplay">The display handle of the curve to apply persisence (returned from Draw() method). '-1' applies to all curves.</param>
    /// <param name="depth">Is the 'keep' depth of the cleared displays (non-volatile).</param>
    /// <param name="memCopy">If true will actually maintain cleared displays in memory up to the depth given.</param>
    /// <param name="persistColor">Is the desired color of the persistence display.</param>
    /// <returns>Returns 0 is successful.</returns>
    public int PersistScreen(int hDisplay, int depth, Boolean memCopy, Color persistColor)
    {
      return PersistScreen(hDisplay, depth, memCopy, true, persistColor);
    }
    /// <summary>
    /// Applies a persisence to 'cleared' displays (analogous to clearing with a 'KeepDepth').
    /// </summary>
    /// <param name="hDisplay">The display handle of the curve to apply persisence (returned from Draw() method). '-1' applies to all curves.</param>
    /// <param name="depth">Is the 'keep' depth of the cleared displays (non-volatile).</param>
    /// <param name="persistColor">Is the desired color of the persistence display.</param>
    /// <returns>Returns 0 is successful.</returns>
    public int PersistScreen(int hDisplay, int depth, Color persistColor)
    {
      return PersistScreen(hDisplay, depth, true, persistColor);
    }
    /// <summary>
    /// Refreshes a displayed array in a persistent screen.
    /// </summary>
    /// <param name="Yarray">Is the vertical (Y) axis data to be used in the refresh action.</param>
    /// <param name="hDisplay">The display handle of the curve be refreshed (returned from Draw() method).</param>
    /// <returns>Returns 0 is successful.</returns>
    public int RefreshPersistScreen(Object Yarray, int hDisplay)
    {
      int i;
      for (i = 0; i < AcopConst.MAX_PERSIST; i++)
      {
        if (persist[i] == null) break;
        if (persist[i].hisIndex == hDisplay) break;
      }
      if (i < AcopConst.MAX_PERSIST && persist[i] != null)
      {
        persist[i].refreshPesist(Yarray);
        return 0;
      }
      return -1;
    }
    /// <summary>
    /// Clears (terminates) display persistence.
    /// </summary>
    /// <param name="hDisplay">The display handle of the curve for which persisence should be terminated (returned from Draw() method). '-1' applies to all curves.</param>
    public void PersistClear(int hDisplay)
    {
      int i;
      for (i = 0; i < AcopConst.MAX_PERSIST; i++)
      {
        if (persist[i] == null) break;
        if (persist[i].hisIndex == hDisplay || hDisplay == -1)
        {
          persist[i].clearPesist();
          if (hDisplay >= 0) break;
        }
      }
    }
    /// <summary>
    /// Sets the horizontal (x) axis label.
    /// </summary>
    /// <param name="text">The Text to display in the label</param>
    private void setXLeftLabel(String text)
    {
      if (XLeftLabel != null && XLeftLabel.Equals(text)) return;
      String oldValue = XLeftLabel;
      XLeftLabel = text;
      this.Invalidate(sca[0].labelRect);
      OnPropertyChanged("xLeftLabel");
    }
    private String getXLeftLabel()
    {
      return XLeftLabel;
    }
    private void setXRightLabel(String text)
    {
      if (XRightLabel != null && XRightLabel.Equals(text)) return;
      String oldValue = XRightLabel;
      XRightLabel = text;
      this.Invalidate(sca[0].labelRect);
      OnPropertyChanged("xRightLabel");
    }
    private String getXRightLabel()
    {
      return XRightLabel;
    }
    /// <summary>
    /// Set the current bit display mask setting
    /// </summary>
    /// <param name="value">the desired bit display mask setting</param>
    public void SetBitDisplayMask(int value)
    {
      if (this.bitDisplayMask == value) return;
      int oldValue = this.bitDisplayMask;
      this.bitDisplayMask = value;
      OnPropertyChanged("bitDisplayMask");
    }
    /// <summary>
    /// Get the current bit display mask setting
    /// </summary>
    /// <returns>the current bit display mask setting</returns>
    public int GetBitDisplayMask()
    {
      return this.bitDisplayMask;
    }
    public void SetGanttBitDisplayBase(double ganttBitBase)
    {
      if (this.ganttBitDisplayBase == ganttBitBase) return;
      double oldValue = this.ganttBitDisplayBase;
      this.ganttBitDisplayBase = ganttBitBase;
      OnPropertyChanged("ganttBitDisplayBase");
    }
    public double GetGanttBitDisplayBase()
    {
      return this.ganttBitDisplayBase;
    }
    public void SetGanttBitDisplayHeight(double ganttBitHeight)
    {
      if (this.ganttBitDisplayHeight == ganttBitHeight) return;
      double oldValue = this.ganttBitDisplayHeight;
      this.ganttBitDisplayHeight = ganttBitHeight;
      OnPropertyChanged("ganttBitDisplayHeight");
    }
    public double GetGanttBitDisplayHeight()
    {
      return this.ganttBitDisplayHeight;
    }
    /// <summary>
    /// Specifies a series of labels to use for the vertical (Y) axis tick marks.
    /// </summary>
    /// <param name="ylabels">An array of labels to use at the Y axis tick mark locations</param>
    /// <param name="start">The starting Y-position for the initial label</param>
    /// <param name="interval">The Y-interval over which to apply the given labels.</param>
    public void SetYAxisTickLabels(String[] ylabels, int start, int interval)
    {
      if (ylabels != null)
      {
        yLabelStart = start;
        yLabelInterval = interval;
      }
      SetYAxisTickLabels(ylabels);
    }
    /// <summary>
    /// Specifies a series of labels to use for the vertical (Y) axis tick marks.
    /// </summary>
    public void SetYAxisTickLabels(String[] ylabel)
    {
      OnPropertyChanged("yLabel");
      if (ylabel == null) ylabON = 0;
      else
      {
        ylabON = 1;
        ylabLength = ylabel.Length;
        if (ylab == null || ylab.Length != ylabLength) ylab = new String[ylabLength];
        for (int i = 0; i < ylabel.Length; i++) ylab[i] = ylabel[i];
      }
    }
    /// <summary>
    /// Gives the series of labels used for the vertical (Y) axis tick marks.
    /// </summary>
    /// <returns>An array of labels used for the vertical (Y) axis tick marks</returns>
    public String[] GetYAxisTickLabels()
    {
      return this.ylab;
    }
    private void setYLabelDisplayOffset(int yLabelDisplayOffset)
    {
      if (this.yLabelDisplayOffset == yLabelDisplayOffset) return;
      int oldValue = this.yLabelDisplayOffset;
      this.yLabelDisplayOffset = yLabelDisplayOffset;
      OnPropertyChanged("yLabelDisplayOffset");
    }
    private int getYLabelDisplayOffset()
    {
      return this.yLabelDisplayOffset;
    }
    /// <summary>
    /// Allowable label offset modes.
    /// </summary>
    public enum AcopLabelOffsetMode
    {
      Normal = 0,
      UseMinimum = 1,
      UseModular = 2
    }
    AcopLabelOffsetMode getAcopLabelOffsetMode(int m)
    {
      if (Enum.IsDefined(typeof(AcopLabelOffsetMode), m)) return (AcopLabelOffsetMode)m;
      return AcopLabelOffsetMode.Normal;
    }
    AcopLabelOffsetMode getAcopXLabelOffsetMode()
    {
      return getAcopLabelOffsetMode(sca[0].labelOffsetMode);
    }
    void setAcopXLabelOffsetMode(AcopLabelOffsetMode m)
    {
      SetXAxisDisplayOffsetMode((int)m);
    }
    AcopLabelOffsetMode getAcopYLabelOffsetMode()
    {
      return getAcopLabelOffsetMode(sca[1].labelOffsetMode);
    }
    void setAcopYLabelOffsetMode(AcopLabelOffsetMode m)
    {
      SetYAxisDisplayOffsetMode((int)m);
    }
    AcopLabelOffsetMode getAcopSecondYLabelOffsetMode()
    {
      return getAcopLabelOffsetMode(sca[2].labelOffsetMode);
    }
    void setAcopSecondYLabelOffsetMode(AcopLabelOffsetMode m)
    {
      setSecondYAxisDisplayOffsetMode((int)m);
    }
    /// <summary>
    /// Adjusts axis tick labels to account for large but insignifcant common offsets. Does not adjust data!
    /// </summary>
    /// <param name="mode">is the desired X-axis display offset mode. One of ((0: off, 1: Use X-min, or 2: Use Modular))</param>
    private void SetXAxisDisplayOffsetMode(int mode)
    {
      if (mode < 0) mode = 0;
      else if (mode > 2) mode = 2;
      if (this.sca[0].labelOffsetMode == mode) return;
      int oldValue = this.sca[0].labelOffsetMode;
      this.sca[0].labelOffsetMode = mode;
      if (mode == 0) this.sca[0].labelOffset = 0;
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw();
      OnPropertyChanged("xLabelOffsetMode");
    }
    private int GetXAxisDislayOffsetMode()
    {
      return sca[0].labelOffsetMode;
    }
    public double GetXAxisDisplayOffset()
    {
      return this.sca[0].labelOffset;
    }
    /// <summary>
    /// Adjusts axis tick labels to account for large but insignifcant common offsets. Does not adjust data!
    /// </summary>
    /// <param name="mode">is the Y-axis display offset mode. One of (0: off, 1: Use Y-min, or 2: Use Modular)</param>
    private void SetYAxisDisplayOffsetMode(int mode)
    {
      if (mode < 0) mode = 0;
      else if (mode > 2) mode = 2;
      if (this.sca[1].labelOffsetMode == mode) return;
      int oldValue = this.sca[1].labelOffsetMode;
      this.sca[1].labelOffsetMode = mode;
      if (mode == 0) this.sca[1].labelOffset = 0;
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw();
      OnPropertyChanged("yLabelOffsetMode");
    }
    private int GetYAxisDislayOffsetMode()
    {
      return sca[1].labelOffsetMode;
    }
    public double GetYAxisDisplayOffset()
    {
      return this.sca[1].labelOffset;
    }
    /// <summary>
    /// Adjusts axis tick labels to account for large but insignifcant common offsets. Does not adjust data!
    /// </summary>
    /// <param name="mode">is the secondary Y-axis display offset mode. One of (0: off, 1: Use secondary Y-min, or 2: Use Modular)</param>
    private void setSecondYAxisDisplayOffsetMode(int mode)
    {
      if (mode < 0) mode = 0;
      else if (mode > 2) mode = 2;
      if (this.sca[2].labelOffsetMode == mode) return;
      int oldValue = this.sca[2].labelOffsetMode;
      this.sca[2].labelOffsetMode = mode;
      if (mode == 0) this.sca[2].labelOffset = 0;
      rescaleFlag = 2;
      rescaleTextFlag = AcopConst.NEW_ZOOM_WINDOW;
      prepareDraw();
      OnPropertyChanged("secondYLabelOffsetMode");
    }
    private int getSecondYAxisDislayOffsetMode()
    {
      return sca[2].labelOffsetMode;
    }
    public double getSecondYAxisDisplayOffset()
    {
      return this.sca[2].labelOffset;
    }

    private void setTextAntiAliasing(Boolean antialias)
    {
      if (this.textAntiAliasing == antialias) return;
      this.textAntiAliasing = antialias;
      OnPropertyChanged("textAntiAliasing");
    }
    private Boolean isTextAntiAliasing()
    {
      return textAntiAliasing;
    }

    private void setWeightedStatistics(Boolean weightStatitics)
    {
      if (this.weightStatistics == weightStatitics) return;
      this.weightStatistics = weightStatitics;
      OnPropertyChanged("weightedStatistics");
    }
    private Boolean isWeightedStatistics()
    {
      return weightStatistics;
    }
    private Boolean tttSetByUser = false;

    /// <summary>
    /// Activate or deactivate the "More Option" menuitem in contextmenu.
    /// </summary>
    /// <param name="value">true to show "More Option" false to hide (default: false)</param>
    public void ShowMoreOptionsContext(Boolean value)
    {
      cm.MoreOptions = value;
    }
    public void OnMoreOptionsClick(object sender, EventArgs e)
    {
      ContextMenuMoreOptionsClick?.Invoke(this, e);
    }

    /// <summary>
    /// Hide or show a graph in the chart
    /// </summary>
    /// <param name="id">the id of the graph</param>
    /// <param name="visible">false to hide graph in chart</param>
    public void SetGraphVisible(int id, Boolean visible)
    {   
      try
      {
        if (this.histo[id].displayON == 1 && !visible) this.ClearScreen(id);
        else if (this.histo[id].displayON == 0 && visible) this.RecallScreen(id);
      }
      catch (Exception ex)
      {
        Console.WriteLine("ERROR: Check graph id!");
      }
    }

    /// <summary>
    /// Set the color of a graph in the chart
    /// </summary>
    /// <param name="id">the id of the graph</param>
    /// <param name="col">the color</param>
    public void SetGraphColor(int id, Color col)
    {
      try
      {
        if (this.histo[id].getCurveColor() == col) return;
        this.histo[id].setCurveColor(col);
      }
      catch (Exception ex)
      {
        Console.WriteLine("ERROR: Check graph id!");
      }
    }

    public delegate void acopAnnotationClick(object sender, AcopEvent e);
    [Category("Acop.Display")]
    [Description("Occurs when a chart annotation has been clicked.")]
    public event acopAnnotationClick acopAnnotationClicked;

    public delegate void acopMouseClick(object sender, AcopEvent e);
    [Category("Acop.Display")]
    [Description("Occurs when a chart has been clicked.")]
    public event acopMouseClick acopClicked;

    public delegate void acopMouseMove(object sender, AcopEvent e);
    [Category("Acop.Display")]
    [Description("Occurs when the mouse hovers over the chart.")]
    public event acopMouseMove acopMsMove;

    public delegate void acopMouseDoubleClick(object sender, AcopEvent e);
    [Category("Acop.Display")]
    [Description("Occurs when a chart has been double-clicked.")]
    public event acopMouseDoubleClick acopDoubleClick;

    public delegate void acopMouseEnter(object sender, AcopEvent e);
    [Category("Acop.Display")]
    [Description("Occurs when the mouse is moved into the chart.")]
    public event acopMouseEnter acopMsEnter;

    public delegate void acopMouseExit(object sender, AcopEvent e);
    [Category("Acop.Display")]
    [Description("Occurs when the mouse is moved out of the chart.")]
    public event acopMouseExit acopMsExit;

    public delegate void acopMouseZoom(object sender, AcopEvent e);
    [Category("Acop.Display")]
    [Description("Occurs when the acop chart is zoomed.")]
    public event acopMouseZoom acopZoom;

    public delegate void acopMousePressed(object sender, AcopEvent e);
    [Category("Acop.Display")]
    [Description("Occurs when the mouse has been pressed on the chart.")]
    public event acopMousePressed acopMsPressed;

    public delegate void acopMouseDragged(object sender, AcopEvent e);
    [Category("Acop.Display")]
    [Description("Occurs when the mouse is being dragged over the chart.")]
    public event acopMouseDragged acopMsDragged;
    public event PropertyChangedEventHandler PropertyChanged;
    
    public delegate void showMoreOptionsEventHandler(object sender, EventArgs e);
    [Category("Acop.Display")]
    [ToolboxItem(false)]
    [Browsable(false), EditorBrowsable(EditorBrowsableState.Always)]
    public event showMoreOptionsEventHandler ContextMenuMoreOptionsClick;

    [Category("Acop.Transport")]
    [ToolboxItem(false)]
    [Browsable(false), EditorBrowsable(EditorBrowsableState.Never)]
    public new event acopApplySetting acopApply;

    [Category("Acop.Transport")]
    [Browsable(false), EditorBrowsable(EditorBrowsableState.Never)]
    public new ApplyEventSettingType ApplyEventOrder { get; set; }
    /// <summary>
    /// If set to true, instructs ACOP acquire and apply appropriate chart setting based on the input link address and property
    /// </summary>
    [Category("Acop.Transport")]
    [Description("If set to true, instructs ACOP acquire and apply appropriate chart setting based on the input link address and property")]
    public AutoScaleMode AutoScaleUpdate { get { return getAutoScaleUpdate(); } set { setAutoScaleUpdate(value); } }
    /// <summary>
    /// If set to true, instructs ACOP apply a trend-chart and update this chart's contents upon receipt of new link data (provided no user-defined event handle is in play)
    /// </summary>
    [Category("Acop.Transport")]
    [Description("If set to true, instructs ACOP apply a trend-chart and update this chart's contents upon receipt of new link data (provided no user-defined event handle is in play)")]
    public bool AutoTrendUpdate { get { return getAutoTrend(); } set { setAutoTrend(value); } }
    /// <summary>
    /// Specifies the trend depth in points
    /// </summary>
    [Category("Acop.Transport")]
    [Description("Specifies the trend depth in points")]
    public int LinkTrendDepth { get { return getTrendDepth(); } set { setTrendDepth(value); } }
    /// <summary>
    /// Specifies the trend depth in hours to use in a trend display
    /// </summary>
    [Category("Acop.Transport")]
    [Description("Specifies the trend depth in hours to use in a trend display")]
    public double LinkTrendHours { get { return getTrendDepthHours(); } set { setTrendDepthHours(value); } }

    /// <summary>
    /// Gets/Sets the tool tip text to hover over thee acop frame
    /// </summary>
    [Category("Acop.Display")]
    [Description("Specifies the tool tip text to hover over thee acop frame.")]
    public String ToolTipText { get { return acopToolTip.GetToolTip(this); } set { tttSetByUser = !(value == null || value.Length == 0); acopToolTip.SetToolTip(this, value); } }
    /// <summary>
    /// Gets/Sets the tool tip forecolor.
    /// </summary>
    [Category("Acop.Display")]
    [Description("Specifies the tooltip forecolor.")]
    public Color ToolTipForeColor { get { return acopToolTip.ForeColor; } set { acopToolTip.ForeColor = value; } }
    /// <summary>
    /// Gets/Sets the tool tip backcolor.
    /// </summary>
    [Category("Acop.Display")]
    [Description("Specifies the tooltip backcolor.")]
    public Color ToolTipBackColor { get { return acopToolTip.BackColor; } set { acopToolTip.BackColor = value; } }
    /// <summary>
    /// Gets/Sets the font used in the acop frame.
    /// </summary>
    [Category("Acop.Display.Frame")]
    [Description("Specifies the font used in the acop frame.")]
    public Font FrameFont { get { return getFrameFont(); } set { setFrameFont(value); } }
    /// <summary>
    /// Gets/Sets the font sized used in the acop frame.
    /// </summary>
    [Category("Acop.Display.Frame")]
    [Description("Specifies the font sized used in the acop frame.")]
    public float FrameFontSize { get { return getFrameFontSize(); } set { setFrameFontSize(value); } }
    /// <summary>
    /// Gets/Sets the forecolor used within the acop frame.
    /// </summary>
    [Category("Acop.Display.Frame")]
    [Description("Specifies the forecolor used within the acop frame.")]
    public Color FrameForeColor { get { return getFrameForeColor(); } set { setFrameForeColor(value); } }
    /// <summary>
    /// Gets/Sets the postioning offset (positive or negative) to apply to the lefthand side of the display frame.
    /// </summary>
    [Category("Acop.Display.Frame")]
    [Description("Specifies a postioning offset (positive or negative) to apply to the lefthand side of the display frame.")]
    public int FrameLeftOffset { get { return getFrameLeftOffset(); } set { setFrameLeftOffset(value); } }
    /// <summary>
    /// Gets/Sets the postioning offset (positive or negative) to apply to the righthand side of the display frame.
    /// </summary>
    [Category("Acop.Display.Frame")]
    [Description("Specifies a postioning offset (positive or negative) to apply to the righthand side of the display frame.")]
    public int FrameRightOffset { get { return getFrameRightOffset(); } set { setFrameRightOffset(value); } }
    /// <summary>
    /// Gets/Sets the postioning offset (positive or negative) to apply to the top of the display frame.
    /// </summary>
    [Category("Acop.Display.Frame")]
    [Description("Specifies a postioning offset (positive or negative) to apply to the top of the display frame.")]
    public int FrameTopOffset { get { return getFrameTopOffset(); } set { setFrameTopOffset(value); } }
    /// <summary>
    /// Gets/Sets the postioning offset (positive or negative) to apply to the bottom of the display frame.
    /// </summary>
    [Category("Acop.Display.Frame")]
    [Description("Specifies a postioning offset (positive or negative) to apply to the bottom of the display frame.")]
    public int FrameBottomOffset { get { return getFrameBottomOffset(); } set { setFrameBottomOffset(value); } }
    /// <summary>
    /// Gets/Sets the display frame width
    /// </summary>
    [Category("Acop.Display.Frame")]
    [Description("Specifies the display frame width.")]
    public int FrameWidth { get { return getFrameWidth(); } set { setFrameWidth(value); } }
    /// <summary>
    /// Gets/Sets the display frame caption (top margin).
    /// </summary>
    [Category("Acop.Display.Frame")]
    [Description("Specifies the display frame caption (top margin).")]
    public String FrameCaption { get { return getCaption(); } set { setCaption(value); } }
    /// <summary>
    /// Gets/Sets the relative position of the frame caption.
    /// </summary>
    [Category("Acop.Display.Frame")]
    [Description("Specifies the relative position of the frame caption.")]
    public AcopCaptionPosition FrameCaptionLocation { get { return getAcopCaptionPosition(); } set { setAcopCaptionPosition(value); } }
    /// <summary>
    /// Gets/Sets the acop frame border visibility.
    /// </summary>
    [Category("Acop.Display.Frame")]
    [Description("If true: draws a visible border around the acop frame.")]
    public bool FrameBorder { get { return isFrameBorderOn(); } set { setFrameBorderOn(value); } }
    /// <summary>
    /// Gets/Sets the X-axis display minimum.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Specifies the X-axis display minimum.")]
    public double XMin { get { return getXMin(); } set { setXMin(value); } }
    /// <summary>
    /// Gets/Sets the X-axis display maximum.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Specifies the X-axis display maximum.")]
    public double XMax { get { return getXMax(); } set { setXMax(value); } }
    /// <summary>
    /// Gets/Sets the Y-axis display minimum.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Specifies the Y-axis display minimum.")]
    public double YMin { get { return getYMin(); } set { setYMin(value); } }
    /// <summary>
    /// Gets/Sets the Y-axis display maximum.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Specifies the Y-axis display maximum.")]
    public double YMax { get { return getYMax(); } set { setYMax(value); } }
    /// <summary>
    /// Gets/Sets the secondary (right-hand side) Y-axis display minimum.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Specifies the secondary (right-hand side) Y-axis display minimum.")]
    public double SecondaryYMin { get { return getSecondaryYMin(); } set { setSecondaryYMin(value); } }
    /// <summary>
    /// Gets/Sets the secondary (right-hand side) Y-axis display maximum.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Specifies the secondary (right-hand side) Y-axis display maximum.")]
    public double SecondaryYMax { get { return getSecondaryYMax(); } set { setSecondaryYMax(value); } }
    /// <summary>
    /// Gets/Sets the background color to use within the display frame.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the background color to use within the display frame.")]
    public Color BackgroundColor { get { return getBackground(); } set { setBackground(value); } }
    /// <summary>
    /// Gets/Sets the foreground color to use within the display frame.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the foreground color to use within the display frame.")]
    public Color ForegroundColor { get { return GetForeground(); } set { SetForeground(value); } }

    [Category("Acop.Display.Plot")]
    [Description("If not 'none' and AutoUpdate is 'true' then additional plots will be plotted in different colors")]
    public ColorIncrement ForegroundColorAutoIncrement { get { return GetForegroundColorAutoIncrement(); } set { SetForegroundColorAutoIncrement(value); } }
    /// <summary>
    /// Gets/Sets a multiplication scale factor to apply to the X-axis of the plotted array
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies a multiplication scale factor to apply to the X-axis of the plotted array.")]
    public double XScale { get { return getXScale(); } set { setXScale(value); } }
    /// <summary>
    /// Gets/Sets an additive shift factor to apply to the X-axis of the plotted array.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies an additive shift factor to apply to the X-axis of the plotted array.")]
    public double XShift { get { return getXShift(); } set { setXShift(value); } }
    /// <summary>
    /// Gets/Sets the horizontal extent of the data-point rectangles used when 'dots' are plotted.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Sets the horizontal extent of the data-point rectangles used when 'dots' are plotted.")]
    public double XExtent { get { return getXExtent(); } set { setXExtent(value); } }
    /// <summary>
    /// Gets/Sets a multiplication scale factor to apply to the Y-axis of the plotted array.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies a multiplication scale factor to apply to the Y-axis of the plotted array.")]
    public double YScale { get { return getYScale(); } set { setYScale(value); } }
    /// <summary>
    /// Gets/Sets an additive shift factor to apply to the Y-axis of the plotted array.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies an additive shift factor to apply to the Y-axis of the plotted array.")]
    public double YShift { get { return getYShift(); } set { setYShift(value); } }
    /// <summary>
    /// Gets/Sets the vertical extent of the data-point rectangles used when 'dots' are plotted.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Sets the vertical extent of the data-point rectangles used when 'dots' are plotted.")]
    public double YExtent { get { return getYExtent(); } set { setYExtent(value); } }
    /// <summary>
    /// Gets/Sets the X-axis best scale attribute.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If true: apply the nearest order of magnitude max/min settings to the X-axis.")]
    public bool XBestScale { get { return isXBestScale(); } set { setXBestScale(value); } }
    /// <summary>
    /// Gets/Sets the Y-axis best scale attribute.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If true: apply the nearest order of magnitude max/min settings to the Y-axis.")]
    public bool YBestScale { get { return isYBestScale(); } set { setYBestScale(value); } }
    /// <summary>
    /// Gets/Sets the secondary Y-axis best scale attribute.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If true: apply the nearest order of magnitude max/min settings to the secondary Y-axis.")]
    public bool SecondaryYBestScale { get { return isSecondaryYBestScale(); } set { setSecondaryYBestScale(value); } }
    /// <summary>
    /// Gets/Sets the visibility of the secondary Y axis.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If true: make the secondary Y-axis visible.")]
    public bool SecondaryYAxis { get { return isSecondaryYAxisOn(); } set { setSecondaryYAxisOn(value); } }
    /// <summary>
    /// Gets/Sets the secondary Y-axis log scale attribute.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If true: make the secondary Y-axis use a log scale.")]
    public bool SecondaryYLogScale { get { return isSecondaryYLogOn(); } set { setSecondaryYLogOn(value); } }
    /// <summary>
    /// Gets/Sets the label to use on the X-axis.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Specifies the label to use on the X-axis.")]
    public String XAxisLabel { get { return getXAxisLabel(); } set { setXAxisLabel(value); } }
    /// <summary>
    /// Gets/Sets a short text to use on the lower left X-axis.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Specifies a short text to use on the lower left X-axis.")]
    public String XLeftCaption { get { return getXLeftLabel(); } set { setXLeftLabel(value); } }
    /// <summary>
    /// Gets/Sets a short text to use on the lower right X-axis.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Specifies a short text to use on the lower right X-axis.")]
    public String XRightCaption { get { return getXRightLabel(); } set { setXRightLabel(value); } }
    /// <summary>
    /// Gets/Sets the label to use on the Y-axis.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Specifies the label to use on the Y-axis.")]
    public String YAxisLabel { get { return getYAxisLabel(); } set { setYAxisLabel(value); } }
    /// <summary>
    /// Gets/Sets the label to use on the secondary Y-axis.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Specifies the label to use on the secondary Y-axis.")]
    public String SecondaryYAxisLabel { get { return getSecondaryYAxisLabel(); } set { setSecondaryYAxisLabel(value); } }
    [Category("Acop.Display.Axes")]
    public int YLabelDisplayOffset { get { return getYLabelDisplayOffset(); } set { setYLabelDisplayOffset(value); } }
    /// <summary>
    /// Gets/Sets the X-axis label offset mode.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Adjusts axis tick labels to account for large but insignifcant common offsets. Does not adjust data!")]
    public AcopLabelOffsetMode XLabelOffsetMode { get { return getAcopXLabelOffsetMode(); } set { setAcopXLabelOffsetMode(value); } }
    /// <summary>
    /// Gets/Sets the Y-axis label offset mode.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Adjusts axis tick labels to account for large but insignifcant common offsets. Does not adjust data!")]
    public AcopLabelOffsetMode YLabelOffsetMode { get { return getAcopYLabelOffsetMode(); } set { setAcopYLabelOffsetMode(value); } }
    /// <summary>
    /// Gets/Sets the secondary Y-axis label offset mode.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Adjusts axis tick labels to account for large but insignifcant common offsets. Does not adjust data!")]
    public AcopLabelOffsetMode SecondaryYLabelOffsetMode { get { return getAcopSecondYLabelOffsetMode(); } set { setAcopSecondYLabelOffsetMode(value); } }
    /// <summary>
    /// Gets/Sets the X-axis grid visibility.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("If true: apply a horizontal (X-axis) grid on the display frame.")]
    public bool XGrid { get { return isXGrid(); } set { setXGrid(value); } }
    /// <summary>
    /// Gets/Sets the Y-axis grid visibility.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("If true: apply a vertical (Y-axis) grid on the display frame.")]
    public bool YGrid { get { return isYGrid(); } set { setYGrid(value); } }
    /// <summary>
    /// Gets/Sets the grid color.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the color to use for the displayed grid.")]
    public Color GridColor { get { return getGridColor(); } set { setGridColor(value); } }
    /// <summary>
    /// Gets/Sets the grid width.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the width of the grid lines used in the displayed grid.")]
    public int GridWidth { get { return getGridWidth(); } set { setGridWidth(value); } }
    /// <summary>
    /// Gets/Sets the X-axis tick mark visibility.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If non-zero: make horizontal (X-axis) tick marks visible on the display frame.")]
    public int XTicks { get { return getXTicks(); } set { setXTicks(value); } }
    /// <summary>
    /// Gets/Sets the X-axis fine tick mark visibility.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If non-zero: make horizontal (X-axis) sub (fine) tick marks visible on the display frame.")]
    public int XTicksFine { get { return getXFineTicks(); } set { setXFineTicks(value); } }
    /// <summary>
    /// Gets/Sets the X-axis tick coordinate visibility.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If true: show the horizontal (X-axis) coordinate next to a tick mark.")]
    public bool XTicksText { get { return isXTickText(); } set { setXTickText(value); } }
    /// <summary>
    /// Gets/Sets the Y-axis tick mark visibility.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If non-zero: make vertical (Y-axis) tick marks visible on the display frame.")]
    public int YTicks { get { return getYTicks(); } set { setYTicks(value); } }
    /// <summary>
    /// Gets/Sets the fine Y-axis tick mark visibility.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If non-zero: make vertical (Y-axis) sub (fine) tick marks visible on the display frame.")]
    public int YTicksFine { get { return getYFineTicks(); } set { setYFineTicks(value); } }
    /// <summary>
    /// Gets/Sets the Y-axis tick coordinate visibility.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If true: show the vertical (Y-axis) coordinate next to a tick mark.")]
    public bool YTicksText { get { return isYTickText(); } set { setYTickText(value); } }
    /// <summary>
    /// Gets/Sets the secondary Y-axis tick mark visibility.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If non-zero: make right-hand side vertical (secondary Y-axis) tick marks visible on the display frame.")]
    public int SecondaryYTicks { get { return getSecondaryYTicks(); } set { setSecondaryYTicks(value); } }
    /// <summary>
    /// Gets/Sets the secondary Y-axis fine tick mark visibility.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If non-zero: make right-hand side vertical (secondary Y-axis) sub (fine) tick marks visible on the display frame.")]
    public int SecondaryYTicksFine { get { return getSecondaryYFineTicks(); } set { setSecondaryYFineTicks(value); } }
    /// <summary>
    /// Gets/Sets the secondary Y-axis tick coordinate visibility.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If true: show the right-hand side vertical (secondary Y-axis) coordinate next to a tick mark.")]
    public bool SecondaryYTicksText { get { return isSecondaryYTickText(); } set { setSecondaryYTickText(value); } }
    /// <summary>
    /// Gets/Sets the X-axis 'tick marks at bottom' attribute.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If true: make horizontal (X-axis) tick marks visible along the bottom of the display frame.")]
    public bool XTicksBottom { get { return getXTicksBottom(); } set { setXTicksBottom(value); } }
    /// <summary>
    /// Gets/Sets the Y-axis 'tick-marks on left-hand-side' attribute.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If true: make vertical (Y-axis) tick marks visible along the left of the display frame.")]
    public bool YTicksLeft { get { return getYTicksLeft(); } set { setYTicksLeft(value); } }
    /// <summary>
    /// Gets/Sets the X-axis 'tick-marks on bottom' attribute.
    /// </summary>
    [Category("Acop.Display")]
    [Description("If true: put X label at lower left of the display frame.")]
    [Browsable(false), EditorBrowsable(EditorBrowsableState.Never)]
    public bool XLabelLowerLeft { get { return isBottomXLabel(); } set { setBottomXLabel(value); } }
    /// <summary>
    /// Anchors the X-Axis to the an area of the chart frame
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Anchors the X-Axis to the an area of the chart frame")]
    public AcopAxisLabelAnchor XLabelAnchor {  get { return getXLabelAnchor(); } set { setXLabelAnchor(value); } }
    /// <summary>
    /// Gets/Sets the wrap-around attribute when scrolling the display frame via 'mouse-down'.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("If true: allow plotted data to 'wrap around the display' when scrolling the display frame.")]
    public bool WrapAround { get { return isWrapAround(); } set { setWrapAround(value); } }
    /// <summary>
    /// Gets/Sets the X-axis tick label color.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Specifies the color to use for the X-axis tick labels in the display frame.")]
    public Color XTickLabelColor { get { return getXTickLabelColor(); } set { setXTickLabelColor(value); } }
    /// <summary>
    /// Gets/Sets the Y-axis tick label color
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Specifies the color to use for the Y-axis tick labels in the display frame.")]
    public Color YTickLabelColor { get { return getYTickLabelColor(); } set { setYTickLabelColor(value); } }
    /// <summary>
    /// Gets/Sets the secondary Y-axis tick label color.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Specifies the color to use for the secondary Y-axis tick labels in the display frame.")]
    public Color SecondaryYTickLabelColor { get { return getSecondaryYTickLabelColor(); } set { setSecondaryYTickLabelColor(value); } }
    /// <summary>
    /// Gets/Sets the keep color (for 'kept' curves during a Clear()).
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the color to use for the 'kept' curves (during a 'Clear()' operation) in the display frame.")]
    public Color KeepColor { get { return getKeepColor(); } set { setKeepColor(value); } }
    /// <summary>
    /// Gets/Sets the draw width (for 'kept' curves during a Clear()).
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the width of the 'kept' curves (during a 'Clear()' operation) in the displayed grid.")]
    public int KeepWidth { get { return getKeepWidth(); } set { setKeepWidth(value); } }
    /// <summary>
    /// Gets/Sets the plot mode (polyline, histogram, dots, etc.) in the display frame.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the plot mode (polyline, histogram, dots, etc.) in the display frame.")]
    public AcopPlotMode PlotMode { get { return getPlotMode(); } set { setPlotMode(value); } }
    /// <summary>
    /// Gets/Sets the 'dots-filled-with-foreground color' attribute.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("If true: rectangles used in data-point plots will be filled with the assigned color.")]
    public bool PlottedDotsFilled { get { return isColorFilled(); } set { setColorFilled(value); } }
    /// <summary>
    /// Gets/Sets the 'barline-filled' attribute.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("If < 0: barline plots will fill in color below a plotted barline curve. If > 0: barline plots will fill in above. If 0: barline plots will not be filled in.")]
    public AcopBarLineFilledStyle PlottedBarLinesFilled { get { return getAcopBarlineColorFilled(); } set { setAcopBarlineColorFilled(value); } }
    /// <summary>
    /// Gets/Sets the graph style (LIN_LIN, LOG_LIN, etc.) in the display frame.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the graph style (LIN_LIN, LOG_LIN, etc.) in the display frame.")]
    public AcopGraphStyle GraphStyle { get { return getAcopGraphStyle(); } set { setAcopGraphStyle(value); } }
    /// <summary>
    /// Gets/Sets the draw style (SOLID, DASH, etc.) in the display frame.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the draw style (SOLID, DASH, etc.) in the display frame.")]
    public AcopDrawStyle DrawStyle { get { return getAcopDrawStyle(); } set { setAcopDrawStyle(value); } }
    /// <summary>
    /// Gets/Sets the draw style (SOLID, DASH, etc.) of the kept curves.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the draw style (SOLID, DASH, etc.) of the kept curves in the display frame.")]
    public AcopDrawStyle KeepStyle { get { return getAcopKeepStyle(); } set { setAcopKeepStyle(value); } }
    /// <summary>
    /// Gets/Sets the draw style (SOLID, DASH, etc.) of the grid lines in the display frame.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the draw style (SOLID, DASH, etc.) of the grid lines in the display frame.")]
    public AcopDrawStyle GridStyle { get { return getAcopGridStyle(); } set { setAcopGridStyle(value); } }
    /// <summary>
    /// Gets/Sets the draw style (SOLID, DASH, etc.) of the leading edge in the display frame.
    /// </summary>
    [Category("Acop.Display.LeadingEdge")]
    [Description("Specifies the draw style (SOLID, DASH, etc.) of the leading edge in the display frame.")]
    public AcopDrawStyle LeadingEdgeStyle { get { return getAcopLeadingEdgeStyle(); } set { setAcopLeadingEdgeStyle(value); } }
    /// <summary>
    /// Gets/Sets the draw style (SOLID, DASH, etc.) of the marker in the display frame.
    /// </summary>
    [Category("Acop.Display.Marker")]
    [Description("Specifies the draw style (SOLID, DASH, etc.) of the marker in the display frame.")]
    public AcopDrawStyle MarkerStyle { get { return getAcopMarkerStyle(); } set { setAcopMarkerStyle(value); } }
    /// <summary>
    /// Gets/Sets the draw style (SOLID, DASH, etc.) of the cursor marker in the display frame.
    /// </summary>
    [Category("Acop.Display.Marker")]
    [Description("Specifies the draw style (SOLID, DASH, etc.) of the cursor marker in the display frame.")]
    public AcopDrawStyle CursorMarkerStyle { get { return getAcopCursorMarkerStyle(); } set { setAcopCursorMarkerStyle(value); } }
    /// <summary>
    /// Gets/Sets the width of the cursor marker in the displayed frame.
    /// </summary>
    [Category("Acop.Display.Marker")]
    [Description("Specifies the width of the cursor marker in the displayed frame.")]
    public int CursorMarkerWidth { get { return getCursorMarkerWidth(); } set { setCursorMarkerWidth(value); } }
    /// <summary>
    /// Gets/Sets the width of the data-point used marker in the displayed frame.
    /// </summary>
    [Category("Acop.Display.Marker")]
    [Description("Specifies the width of the data-point used marker in the displayed frame.")]
    public int MarkerWidth { get { return getMarkerWidth(); } set { setMarkerWidth(value); } }
    /// <summary>
    /// Gets/Sets the zoom mode (both axes, x-axis only, etc.) of the display frame.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the zoom mode (both axes, x-axis only, etc.) of the display frame.")]
    public AcopZoomModes ZoomMode { get { return getAcopZoomMode(); } set { setAcopZoomMode(value); } }
    /// <summary>
    /// Gets/Sets the color to use for the cursor marker in the display frame.
    /// </summary>
    [Category("Acop.Display.Marker")]
    [Description("Specifies the color to use for the cursor marker in the display frame.")]
    public Color CursorMarkerColor { get { return getCursorMarkerColor(); } set { setCursorMarkerColor(value); } }
    /// <summary>
    /// Gets/Sets the color to use for the marker in the display frame.
    /// </summary>
    [Category("Acop.Display.Marker")]
    [Description("Specifies the color to use for the marker in the display frame.")]
    public Color MarkerColor { get { return getMarkerColor(); } set { setMarkerColor(value); } }
    /// <summary>
    /// Gets/Sets the color to use for error data in the display frame.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the color to use for error data in the display frame.")]
    public Color ErrorColor { get { return getErrorColor(); } set { setErrorColor(value); } }
    /// <summary>
    /// Gets/Sets the color to use for tagged data in the display frame.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the color to use for tagged data in the display frame.")]
    public Color TagColor { get { return getTagColor(); } set { setTagColor(value); } }
    /// <summary>
    /// Specifies the pen width to use for tagged data in the display frame.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the pen width to use for tagged data in the display frame.")]
    public Int32 TagWidth {  get { return getTagWidth(); } set { setTagWidth(value); } }
    /// <summary>
    /// Get/Sets the data tagging attribute.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("If true: designated data will be 'tagged'.")]
    public bool Tagging { get { return isTagging(); } set { setTagging(value); } }
    /// <summary>
    /// Gets/Sets the reuse-screen attribute.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("If true: will discard (and later reuse the display handle) a display following a ClearScreen().")]
    public bool ReuseScreen { get { return isReuseScreen(); } set { setReuseScreen(value); } }
    /// <summary>
    /// Gets/Sets the reuse-text attribute.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("If true: will discard (and later reuse the text handle) a display following a ClearText().")]
    public bool ReuseText { get { return isReuseText(); } set { setReuseText(value); } }
    /// <summary>
    /// Gets/Sets the the color to use for the leading edge in the display frame.
    /// </summary>
    [Category("Acop.Display.LeadingEdge")]
    [Description("Specifies the color to use for the leading edge in the display frame.")]
    public Color LeadingEdgeColor { get { return getLeadingEdgeColor(); } set { setLeadingEdgeColor(value); } }
    /// <summary>
    /// Gets/Sets the gap size to use for the leading edge in the display frame.
    /// </summary>
    [Category("Acop.Display.LeadingEdge")]
    [Description("Specifies the gap size to use for the leading edge in the display frame (units of time axis)")]
    public int LeadingEdgeGapSize { get { return getLeadingEdgeGapSize(); } set { setLeadingEdgeGapSize(value); } }
    [Category("Acop.Display.LeadingEdge")]
    [Description("determines whether the leading edge is fixed (0) or moving (non-zero)")]
    [Browsable(false), EditorBrowsable(EditorBrowsableState.Never)]
    public int LeadingEdgeMotion { get { return getLeadingEdgeMotion(); } set { setLeadingEdgeMotion(value); } }
    /// <summary>
    /// Determines whether the leading edge is fixed (true) or moving (false)
    /// </summary>
    [Category("Acop.Display.LeadingEdge")]
    [Description("Determines whether the leading edge is fixed (true) or moving (false)")]
    public Boolean LeadingEdgeFixed { get { return getLeadingEdgeFixed(); } set { setLeadingEdgeFixed(value); } }
    /// <summary>
    /// Cursor mode for the leading edge in an updating trend chart
    /// </summary>
    [Category("Acop.Display.LeadingEdge")]
    [Description("Cursor mode for the leading edge in an updating trend chart")]
    public LeadingEdgeCursor LeadingEdgeMode { get { return getLeadingEdgeMode(); } set { setLeadingEdgeMode(value); } }
    /// <summary>
    /// Specifies the pen width a leading edge when the LeadingEdgeMode is not 'none'
    /// </summary>
    [Category("Acop.Display.LeadingEdge")]
    [Description("Specifies the pen width a leading edge when the LeadingEdgeMode is not 'none'")]
    public int LeadingEdgeWidth { get { return getLeadingEdgeWidth(); } set { setLeadingEdgeWidth(value); } }
    [Category("Acop.Display.LeadingEdge")]
    [Description("Specifies the horizontal width of a leading edge when the LeadingEdgeMode specifies a horizontal line")]
    public double LeadingEdgeXExtent { get { return getLeadingEdgeXExtent(); } set { setLeadingEdgeXExtent(value); } }
    [Category("Acop.Display.LeadingEdge")]
    [Description("Specifies the vertical width of a leading edge when the LeadingEdgeMode specifies a vertical line")]
    public double LeadingEdgeYExtent { get { return getLeadingEdgeYExtent(); } set { setLeadingEdgeYExtent(value); } }
    /// <summary>
    /// Gets/Sets the time-label-on-left attribute.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If true: show the absolute time on the left in a TIME_LIN or TIME_LOG plot.")]
    public bool LeftTimeLabel { get { return isLeftTimeLabel(); } set { setLeftTimeLabel(value); } }
    /// <summary>
    /// Gets/Sets the left-side Y-axis tick label visibility.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If true: makes the left-side Y-axis label visible.")]
    public bool LeftYLabel { get { return isLeftYLabel(); } set { setLeftYLabel(value); } }
    /// <summary>
    /// Gets/Sets the absolute time tick-labels attribute.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("If true: displays abolute time as tick mark labels for a TIME_LIN or TIME_LOG display.")]
    public bool AbsoluteTimeDisplay { get { return isAbsTimeDisplay(); } set { setAbsTimeDisplay(value); } }
    /// <summary>
    /// Gets/Sets the pen-width to use for plots in the display frame.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the pen-width to use for plots in the display frame.")]
    public int DrawWidth { get { return getDrawWidth(); } set { setDrawWidth(value); } }
    /// <summary>
    /// Gets/Sets  the cursor marker mode in the display frame.
    /// </summary>
    [Category("Acop.Display.Marker")]
    [Description("Specifies the cursor marker mode in the display frame (0 = none).")]
    public AcopMarkerModeEnum CursorMarkerMode { get { return getAcopCursorMarkerMode(); } set { setAcopCursorMarkerMode(value); } }
    /// <summary>
    /// Gets/Sets the data-point marker mode in the display frame.
    /// </summary>
    [Category("Acop.Display.Marker")]
    [Description("Specifies the data-point marker mode in the display frame (0 = none).")]
    public AcopMarkerModeEnum MarkerMode { get { return getAcopMarkerMode(); } set { setAcopMarkerMode(value); } }
    /// <summary>
    /// Gets/Sets the horizontal (X) extent of the cursor marker (when enabled)."
    /// </summary>
    [Category("Acop.Display.Marker")]
    [Description("Specifies the horizontal (X) extent of the cursor marker (when enabled).")]
    public double CursorMarkerXExtent { get { return getCursorMarkerXExtent(); } set { setCursorMarkerXExtent(value); } }
    /// <summary>
    /// Gets/Sets the vertical (Y) extent of the cursor marker (when enabled).
    /// </summary>
    [Category("Acop.Display.Marker")]
    [Description("Specifies the vertical (Y) extent of the cursor marker (when enabled).")]
    public double CursorMarkerYExtent { get { return getCursorMarkerYExtent(); } set { setCursorMarkerYExtent(value); } }
    /// <summary>
    /// Gets/Sets the horizontal (X) extent of the data-point markers (when enabled).
    /// </summary>
    [Category("Acop.Display.Marker")]
    [Description("Specifies the horizontal (X) extent of the data-point markers (when enabled).")]
    public double MarkerXExtent { get { return getMarkerXExtent(); } set { setMarkerXExtent(value); } }
    /// <summary>
    /// Gets/Sets the vertical (Y) extent of the data-point markers (when enabled).
    /// </summary>
    [Category("Acop.Display.Marker")]
    [Description("Specifies the vertical (Y) extent of the data-point markers (when enabled).")]
    public double MarkerYExtent { get { return getMarkerYExtent(); } set { setMarkerYExtent(value); } }
    [Category("Acop.Display.Plot")]
    public int TextDepth { get { return getTextDepth(); } set { setTextDepth(value); } }
    /// <summary>
    /// Gets/Sets the mark-print-text-location attribute.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("If true: Text displayed in the chart with the PrintText() method will mark the origin of the text with a vertical line.")]
    public bool MarkPrintedTextLocation { get { return isPrintTextLine(); } set { setPrintTextLine(value); } }
    /// <summary>
    /// Gets/Sets the relative text location for text printed on a chart with the PrintText() method.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the relative text location for text printed on a chart with the PrintText() method.")]
    public AcopTextLocation PrintTextLocation { get { return getAcopTextLocation(); } set { setAcopTextLocation(value); } }
    /// <summary>
    /// Gets/Sets the text rotation to use for the text printed on the chart via calls to PrintText().
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the text rotation to use for the text printed on the chart via calls to PrintText().")]
    public int PrintTextRotation { get { return getPrintTextRotation(); } set { setPrintTextRotation(value); } }
    /// <summary>
    /// Gets/Sets the text rotation to use for horizontal (X) axis tick mark labels.
    /// </summary>
    [Category("Acop.Display.Axes")]
    [Description("Specifies the text rotation to use for horizontal (X) axis tick mark labels.")]
    public int LabelRotationX { get { return getXlabelRotation(); } set { setXlabelRotation(value); } }
    /// <summary>
    /// Gets/Sets the printed-text-pinned attribute.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Specifies the pinned behavior and zooming-scalability for text printed on a chart with the PrintText() method.")]
    public AcopPinTextStyle PrintTextStickyAttribute { get { return getAcopPinTextStyle(); } set { setAcopPinTextStyle(value); } }
    /// <summary>
    /// "Gets/Sets the number of points at which the draw width automatically resets to '1'"
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Gets/Sets the number of points at which the draw width automatically resets to '1'")]
    public int DrawWidthPointsLimit { get { return getDrawWidthPointsLimit(); } set { setDrawWidthPointsLimit(value); } }
    /// <summary>
    /// Gets/Sets the display points for drawWidth attribute.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Gets/Sets the display points for drawWidth attribute")]
    public int ScreenDepth { get { return getScreenDepth(); } set { setScreenDepth(value); } }
    /// <summary>
    /// Gets/Sets the data-fitting attribute.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Establishes the data operation or fitting to be applied to the Y-axis data.")]
    public AcopFitStyle Fitting { get { return getAcopFitStyle(); } set { setAcopFitStyle(value); } }
    /// <summary>
    /// Gets/Sets the data-inversion (reciprocal) attribute.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("If true: The vertical (Y) axis data are inverted (1/y with zero check) on the display")]
    public bool Reciprocal { get { return isInvert(); } set { setInvert(value); } }
    /// <summary>
    /// Gets/Sets the statistical weighting attribute.
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("If true: calls to GetYDataMean() or GetYDataRms() will apply X-interval weighting in determining the mean data value of the plotted data.")]
    public bool WeightStatistics { get { return isWeightedStatistics(); } set { setWeightedStatistics(value); } }
    [Category("Acop.Display.Plot")]
    public bool TextAntiAliasing { get { return isTextAntiAliasing(); } set { setTextAntiAliasing(value); } }
    [Category("Acop.Display.Plot")]
    [Description("If true and the display mode is 'textbox': The array element index will precede the contents of each string array element")]
    public bool DisplayIndexInTextMode { get { return isAppendLineIndexInTextMode(); } set { setAppendLineIndexInTextMode(value); } }
    [Category("Acop.Display.Plot")]
    [Description("If true: a vertical line is printed at the text location in the display frame.")]
    public bool DisplayTextLine { get { return isPrintTextLine(); } set { setPrintTextLine(value); } }
    [Category("Acop.Display.Plot")]
    public int HistogramPosition { get { return getHistogramPosition(); } set { setHistogramPosition(value); } }
    /// <summary>
    /// Gets/Sets the add-display-info-to-text attribute (calls to Draw() in 'textbox' mode).
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("If true: accessing the Draw() method in 'textbox' mode will append the acop display number and array index number to the displayed data.")]
    public bool AppendDisplayInfoInTextMode { get { return isAppendLineIndexInTextMode(); } set { setAppendLineIndexInTextMode(value); } }
    /// <summary>
    /// Gets/Sets the display marker attribute
    /// </summary>
    [Category("Acop.Display.Marker")]
    [Description("If true: activates the display marker for all displays showing.")]
    public bool Marker { get { return marker(); } set { marker(value); } }
    /// <summary>
    /// Specifies a list of foreground colors to use in multiple plots
    /// </summary>
    [Category("Acop.Display.Plot")]
    [Description("Forecolor List Editor")]
    [Editor(typeof(ColorListEditor), typeof(System.Drawing.Design.UITypeEditor))]
    [DesignerSerializationVisibility(DesignerSerializationVisibility.Content)]
    [TypeConverter(typeof(ColorListEditorConverter))]
    public ColorListEditorValue ForegroundColorList { get { return getColorListEditorValue(); } set { setColorListEditorValue(value); } }

    [Category("Acop.Display")]
    [Browsable(false), EditorBrowsable(EditorBrowsableState.Never)]
    public new Boolean DisplayAsMultiChannel { get; set; }

    [Category("Acop.Display")]
    [Browsable(false), EditorBrowsable(EditorBrowsableState.Never)]
    public new String Description { get; set; }

  }
}
